/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */
#line 30 "core/cfg.y" /* yacc.c:339  */


#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netinet/ip.h>
#include <arpa/inet.h>
#include <string.h>
#include <errno.h>
#include "route_struct.h"
#include "globals.h"
#include "shm_init.h"
#include "route.h"
#include "switch.h"
#include "dprint.h"
#include "sr_module.h"
#include "modparam.h"
#include "ip_addr.h"
#include "resolve.h"
#include "socket_info.h"
#include "name_alias.h"
#include "ut.h"
#include "dset.h"
#include "select.h"
#include "flags.h"
#include "tcp_init.h"
#include "tcp_options.h"
#include "sctp_core.h"
#include "pvar.h"
#include "lvalue.h"
#include "rvalue.h"
#include "sr_compat.h"
#include "msg_translator.h"
#include "async_task.h"

#include "kemi.h"
#include "ppcfg.h"
#include "pvapi.h"
#include "config.h"
#include "cfg_core.h"
#include "cfg/cfg.h"
#ifdef CORE_TLS
#include "tls/tls_config.h"
#endif
#include "timer_ticks.h"

#ifdef DEBUG_DMALLOC
#include <dmalloc.h>
#endif

/* hack to avoid alloca usage in the generated C file (needed for compiler
 with no built in alloca, like icc*/
#undef _ALLOCA_H

#define onsend_check(s) \
	do{\
		if (rt!=ONSEND_ROUTE) yyerror( s " allowed only in onsend_routes");\
	}while(0)

	#define IF_AUTO_BIND_IPV6(x) x

#ifdef USE_DNS_CACHE
	#define IF_DNS_CACHE(x) x
#else
	#define IF_DNS_CACHE(x) warn("dns cache support not compiled in")
#endif

#ifdef USE_DNS_FAILOVER
	#define IF_DNS_FAILOVER(x) x
#else
	#define IF_DNS_FAILOVER(x) warn("dns failover support not compiled in")
#endif

#ifdef USE_NAPTR
	#define IF_NAPTR(x) x
#else
	#define IF_NAPTR(x) warn("dns naptr support not compiled in")
#endif

#ifdef USE_DST_BLACKLIST
	#define IF_DST_BLACKLIST(x) x
#else
	#define IF_DST_BLACKLIST(x) warn("dst blacklist support not compiled in")
#endif

#ifdef USE_SCTP
	#define IF_SCTP(x) x
#else
	#define IF_SCTP(x) warn("sctp support not compiled in")
#endif

#ifdef USE_RAW_SOCKS
	#define IF_RAW_SOCKS(x) x
#else
	#define IF_RAW_SOCKS(x) warn("raw socket support not compiled in")
#endif


extern int yylex();
/* safer then using yytext which can be array or pointer */
extern char* yy_number_str;

static void yyerror(char* s, ...);
static void yyerror_at(struct cfg_pos* pos, char* s, ...);
static char* tmp = NULL;
static int i_tmp = 0;
static struct socket_id* lst_tmp = NULL;
static struct name_lst* nl_tmp = NULL;
static int rt = 0;  /* Type of route block for find_export */
static str* str_tmp = NULL;
static str s_tmp = STR_NULL;
static struct ip_addr* ip_tmp = NULL;
static struct avp_spec* s_attr = NULL;
static select_t sel;
static select_t* sel_ptr = NULL;
static pv_spec_t* pv_spec = NULL;
static struct action *mod_func_action = NULL;
static struct lvalue* lval_tmp = NULL;
static struct rvalue* rval_tmp = NULL;

static void warn(char* s, ...);
static void warn_at(struct cfg_pos* pos, char* s, ...);
static void get_cpos(struct cfg_pos* pos);
static struct rval_expr* mk_rve_rval(enum rval_type, void* v);
static struct rval_expr* mk_rve1(enum rval_expr_op op, struct rval_expr* rve1);
static struct rval_expr* mk_rve2(enum rval_expr_op op, struct rval_expr* rve1,
									struct rval_expr* rve2);
static int rval_expr_int_check(struct rval_expr *rve);
static int warn_ct_rve(struct rval_expr *rve, char* name);
static struct socket_id* mk_listen_id(char*, int, int);
static struct name_lst* mk_name_lst(char* name, int flags);
static struct socket_id* mk_listen_id2(struct name_lst*, int, int);
static void free_name_lst(struct name_lst* lst);
static void free_socket_id_lst(struct socket_id* i);

static struct case_stms* mk_case_stm(struct rval_expr* ct, int is_re,
									struct action* a, int* err);
static int case_check_type(struct case_stms* stms);
static int case_check_default(struct case_stms* stms);
static int mod_f_params_pre_fixup(struct action* a);
static void free_mod_func_action(struct action* a);


extern int line;
extern int column;
extern int startcolumn;
extern int startline;
extern char *finame;
extern char *routename;
extern char *default_routename;

#define set_cfg_pos(x) \
	do{\
		if(x) {\
		(x)->cline = line;\
		(x)->cfile = (finame!=0)?finame:((cfg_file!=0)?cfg_file:"default");\
		(x)->rname = (routename!=0)?routename:((default_routename!=0)?default_routename:"DEFAULT");\
		}\
	}while(0)



#line 232 "core/cfg.tab.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "cfg.tab.h".  */
#ifndef YY_YY_CORE_CFG_TAB_H_INCLUDED
# define YY_YY_CORE_CFG_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    FORWARD = 258,
    FORWARD_TCP = 259,
    FORWARD_TLS = 260,
    FORWARD_SCTP = 261,
    FORWARD_UDP = 262,
    EXIT = 263,
    DROP = 264,
    RETURN = 265,
    BREAK = 266,
    LOG_TOK = 267,
    ERROR = 268,
    ROUTE = 269,
    ROUTE_REQUEST = 270,
    ROUTE_FAILURE = 271,
    ROUTE_ONREPLY = 272,
    ROUTE_REPLY = 273,
    ROUTE_BRANCH = 274,
    ROUTE_SEND = 275,
    ROUTE_EVENT = 276,
    EXEC = 277,
    SET_HOST = 278,
    SET_HOSTPORT = 279,
    SET_HOSTPORTTRANS = 280,
    PREFIX = 281,
    STRIP = 282,
    STRIP_TAIL = 283,
    SET_USERPHONE = 284,
    APPEND_BRANCH = 285,
    REMOVE_BRANCH = 286,
    CLEAR_BRANCHES = 287,
    SET_USER = 288,
    SET_USERPASS = 289,
    SET_PORT = 290,
    SET_URI = 291,
    REVERT_URI = 292,
    FORCE_RPORT = 293,
    ADD_LOCAL_RPORT = 294,
    FORCE_TCP_ALIAS = 295,
    UDP_MTU = 296,
    UDP_MTU_TRY_PROTO = 297,
    UDP4_RAW = 298,
    UDP4_RAW_MTU = 299,
    UDP4_RAW_TTL = 300,
    IF = 301,
    ELSE = 302,
    SET_ADV_ADDRESS = 303,
    SET_ADV_PORT = 304,
    FORCE_SEND_SOCKET = 305,
    SET_FWD_NO_CONNECT = 306,
    SET_RPL_NO_CONNECT = 307,
    SET_FWD_CLOSE = 308,
    SET_RPL_CLOSE = 309,
    SWITCH = 310,
    CASE = 311,
    DEFAULT = 312,
    WHILE = 313,
    CFG_SELECT = 314,
    CFG_RESET = 315,
    URIHOST = 316,
    URIPORT = 317,
    MAX_LEN = 318,
    SETFLAG = 319,
    RESETFLAG = 320,
    ISFLAGSET = 321,
    SETAVPFLAG = 322,
    RESETAVPFLAG = 323,
    ISAVPFLAGSET = 324,
    METHOD = 325,
    URI = 326,
    FROM_URI = 327,
    TO_URI = 328,
    SRCIP = 329,
    SRCPORT = 330,
    DSTIP = 331,
    DSTPORT = 332,
    TOIP = 333,
    TOPORT = 334,
    SNDIP = 335,
    SNDPORT = 336,
    SNDPROTO = 337,
    SNDAF = 338,
    PROTO = 339,
    AF = 340,
    MYSELF = 341,
    MSGLEN = 342,
    UDP = 343,
    TCP = 344,
    TLS = 345,
    SCTP = 346,
    WS = 347,
    WSS = 348,
    DEBUG_V = 349,
    FORK = 350,
    FORK_DELAY = 351,
    MODINIT_DELAY = 352,
    LOGSTDERROR = 353,
    LOGFACILITY = 354,
    LOGNAME = 355,
    LOGCOLOR = 356,
    LOGPREFIX = 357,
    LOGPREFIXMODE = 358,
    LOGENGINETYPE = 359,
    LOGENGINEDATA = 360,
    XAVPVIAPARAMS = 361,
    XAVPVIAFIELDS = 362,
    LISTEN = 363,
    ADVERTISE = 364,
    STRNAME = 365,
    ALIAS = 366,
    SR_AUTO_ALIASES = 367,
    DNS = 368,
    REV_DNS = 369,
    DNS_TRY_IPV6 = 370,
    DNS_TRY_NAPTR = 371,
    DNS_SRV_LB = 372,
    DNS_UDP_PREF = 373,
    DNS_TCP_PREF = 374,
    DNS_TLS_PREF = 375,
    DNS_SCTP_PREF = 376,
    DNS_RETR_TIME = 377,
    DNS_SLOW_QUERY_MS = 378,
    DNS_RETR_NO = 379,
    DNS_SERVERS_NO = 380,
    DNS_USE_SEARCH = 381,
    DNS_SEARCH_FMATCH = 382,
    DNS_NAPTR_IGNORE_RFC = 383,
    DNS_CACHE_INIT = 384,
    DNS_USE_CACHE = 385,
    DNS_USE_FAILOVER = 386,
    DNS_CACHE_FLAGS = 387,
    DNS_CACHE_NEG_TTL = 388,
    DNS_CACHE_MIN_TTL = 389,
    DNS_CACHE_MAX_TTL = 390,
    DNS_CACHE_MEM = 391,
    DNS_CACHE_GC_INT = 392,
    DNS_CACHE_DEL_NONEXP = 393,
    DNS_CACHE_REC_PREF = 394,
    AUTO_BIND_IPV6 = 395,
    BIND_IPV6_LINK_LOCAL = 396,
    DST_BLST_INIT = 397,
    USE_DST_BLST = 398,
    DST_BLST_MEM = 399,
    DST_BLST_TTL = 400,
    DST_BLST_GC_INT = 401,
    DST_BLST_UDP_IMASK = 402,
    DST_BLST_TCP_IMASK = 403,
    DST_BLST_TLS_IMASK = 404,
    DST_BLST_SCTP_IMASK = 405,
    IP_FREE_BIND = 406,
    PORT = 407,
    STAT = 408,
    STATS_NAMESEP = 409,
    CHILDREN = 410,
    SOCKET_WORKERS = 411,
    ASYNC_WORKERS = 412,
    ASYNC_USLEEP = 413,
    ASYNC_NONBLOCK = 414,
    CHECK_VIA = 415,
    PHONE2TEL = 416,
    MEMLOG = 417,
    MEMDBG = 418,
    MEMSUM = 419,
    MEMSAFETY = 420,
    MEMJOIN = 421,
    MEMSTATUSMODE = 422,
    CORELOG = 423,
    SIP_WARNING = 424,
    SERVER_SIGNATURE = 425,
    SERVER_HEADER = 426,
    USER_AGENT_HEADER = 427,
    REPLY_TO_VIA = 428,
    LOADMODULE = 429,
    LOADPATH = 430,
    MODPARAM = 431,
    CFGENGINE = 432,
    MAXBUFFER = 433,
    SQL_BUFFER_SIZE = 434,
    USER = 435,
    GROUP = 436,
    CHROOT = 437,
    WDIR = 438,
    RUNDIR = 439,
    MHOMED = 440,
    DISABLE_TCP = 441,
    TCP_ACCEPT_ALIASES = 442,
    TCP_ACCEPT_UNIQUE = 443,
    TCP_CONNECTION_MATCH = 444,
    TCP_CHILDREN = 445,
    TCP_CONNECT_TIMEOUT = 446,
    TCP_SEND_TIMEOUT = 447,
    TCP_CON_LIFETIME = 448,
    TCP_POLL_METHOD = 449,
    TCP_MAX_CONNECTIONS = 450,
    TLS_MAX_CONNECTIONS = 451,
    TCP_NO_CONNECT = 452,
    TCP_SOURCE_IPV4 = 453,
    TCP_SOURCE_IPV6 = 454,
    TCP_OPT_FD_CACHE = 455,
    TCP_OPT_BUF_WRITE = 456,
    TCP_OPT_CONN_WQ_MAX = 457,
    TCP_OPT_WQ_MAX = 458,
    TCP_OPT_RD_BUF = 459,
    TCP_OPT_WQ_BLK = 460,
    TCP_OPT_DEFER_ACCEPT = 461,
    TCP_OPT_DELAYED_ACK = 462,
    TCP_OPT_SYNCNT = 463,
    TCP_OPT_LINGER2 = 464,
    TCP_OPT_KEEPALIVE = 465,
    TCP_OPT_KEEPIDLE = 466,
    TCP_OPT_KEEPINTVL = 467,
    TCP_OPT_KEEPCNT = 468,
    TCP_OPT_CRLF_PING = 469,
    TCP_OPT_ACCEPT_NO_CL = 470,
    TCP_OPT_ACCEPT_HEP3 = 471,
    TCP_OPT_ACCEPT_HAPROXY = 472,
    TCP_CLONE_RCVBUF = 473,
    TCP_REUSE_PORT = 474,
    DISABLE_TLS = 475,
    ENABLE_TLS = 476,
    TLSLOG = 477,
    TLS_PORT_NO = 478,
    TLS_METHOD = 479,
    TLS_HANDSHAKE_TIMEOUT = 480,
    TLS_SEND_TIMEOUT = 481,
    SSLv23 = 482,
    SSLv2 = 483,
    SSLv3 = 484,
    TLSv1 = 485,
    TLS_VERIFY = 486,
    TLS_REQUIRE_CERTIFICATE = 487,
    TLS_CERTIFICATE = 488,
    TLS_PRIVATE_KEY = 489,
    TLS_CA_LIST = 490,
    DISABLE_SCTP = 491,
    ENABLE_SCTP = 492,
    SCTP_CHILDREN = 493,
    ADVERTISED_ADDRESS = 494,
    ADVERTISED_PORT = 495,
    DISABLE_CORE = 496,
    OPEN_FD_LIMIT = 497,
    SHM_MEM_SZ = 498,
    SHM_FORCE_ALLOC = 499,
    MLOCK_PAGES = 500,
    REAL_TIME = 501,
    RT_PRIO = 502,
    RT_POLICY = 503,
    RT_TIMER1_PRIO = 504,
    RT_TIMER1_POLICY = 505,
    RT_TIMER2_PRIO = 506,
    RT_TIMER2_POLICY = 507,
    MCAST_LOOPBACK = 508,
    MCAST_TTL = 509,
    MCAST = 510,
    TOS = 511,
    PMTU_DISCOVERY = 512,
    KILL_TIMEOUT = 513,
    MAX_WLOOPS = 514,
    PVBUFSIZE = 515,
    PVBUFSLOTS = 516,
    PVCACHELIMIT = 517,
    PVCACHEACTION = 518,
    HTTP_REPLY_PARSE = 519,
    VERSION_TABLE_CFG = 520,
    VERBOSE_STARTUP = 521,
    ROUTE_LOCKS_SIZE = 522,
    CFG_DESCRIPTION = 523,
    SERVER_ID = 524,
    KEMI = 525,
    ONSEND_ROUTE_CALLBACK = 526,
    REPLY_ROUTE_CALLBACK = 527,
    EVENT_ROUTE_CALLBACK = 528,
    RECEIVED_ROUTE_CALLBACK = 529,
    RECEIVED_ROUTE_MODE = 530,
    MAX_RECURSIVE_LEVEL = 531,
    MAX_BRANCHES_PARAM = 532,
    LATENCY_CFG_LOG = 533,
    LATENCY_LOG = 534,
    LATENCY_LIMIT_DB = 535,
    LATENCY_LIMIT_ACTION = 536,
    LATENCY_LIMIT_CFG = 537,
    MSG_TIME = 538,
    ONSEND_RT_REPLY = 539,
    URI_HOST_EXTRA_CHARS = 540,
    FLAGS_DECL = 541,
    AVPFLAGS_DECL = 542,
    ATTR_MARK = 543,
    SELECT_MARK = 544,
    ATTR_FROM = 545,
    ATTR_TO = 546,
    ATTR_FROMURI = 547,
    ATTR_TOURI = 548,
    ATTR_FROMUSER = 549,
    ATTR_TOUSER = 550,
    ATTR_FROMDOMAIN = 551,
    ATTR_TODOMAIN = 552,
    ATTR_GLOBAL = 553,
    ADDEQ = 554,
    SUBST = 555,
    SUBSTDEF = 556,
    SUBSTDEFS = 557,
    EQUAL = 558,
    LOG_OR = 559,
    LOG_AND = 560,
    BIN_OR = 561,
    BIN_AND = 562,
    BIN_XOR = 563,
    BIN_LSHIFT = 564,
    BIN_RSHIFT = 565,
    EQUAL_T = 566,
    DIFF = 567,
    MATCH = 568,
    INTEQ = 569,
    INTDIFF = 570,
    STREQ = 571,
    STRDIFF = 572,
    GT = 573,
    LT = 574,
    GTE = 575,
    LTE = 576,
    PLUS = 577,
    MINUS = 578,
    STAR = 579,
    SLASH = 580,
    MODULO = 581,
    NOT = 582,
    UNARY = 583,
    BIN_NOT = 584,
    DEFINED = 585,
    INTCAST = 586,
    STRCAST = 587,
    DOT = 588,
    STRLEN = 589,
    STREMPTY = 590,
    NUMBER = 591,
    ID = 592,
    NUM_ID = 593,
    STRING = 594,
    IPV6ADDR = 595,
    PVAR = 596,
    AVP_OR_PVAR = 597,
    EVENT_RT_NAME = 598,
    COMMA = 599,
    SEMICOLON = 600,
    RPAREN = 601,
    LPAREN = 602,
    LBRACE = 603,
    RBRACE = 604,
    LBRACK = 605,
    RBRACK = 606,
    CR = 607,
    COLON = 608
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 196 "core/cfg.y" /* yacc.c:355  */

	long intval;
	unsigned long uval;
	char* strval;
	struct expr* expr;
	struct action* action;
	struct case_stms* case_stms;
	struct net* ipnet;
	struct ip_addr* ipaddr;
	struct socket_id* sockid;
	struct name_lst* name_l;
	struct avp_spec* attr;
	struct _pv_spec* pvar;
	struct lvalue* lval;
	struct rvalue* rval;
	struct rval_expr* rv_expr;
	select_t* select;

#line 645 "core/cfg.tab.c" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;

int yyparse (void);

#endif /* !YY_YY_CORE_CFG_TAB_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 662 "core/cfg.tab.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  469
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   12133

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  354
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  104
/* YYNRULES -- Number of rules.  */
#define YYNRULES  912
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  1703

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   608

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   628,   628,   631,   632,   633,   636,   637,   638,   639,
     640,   641,   641,   642,   642,   643,   644,   644,   645,   645,
     646,   646,   647,   648,   651,   667,   675,   689,   690,   696,
     697,   701,   702,   703,   704,   705,   708,   709,   710,   711,
     712,   713,   714,   717,   718,   721,   722,   723,   724,   725,
     729,   730,   731,   732,   733,   737,   738,   741,   742,   745,
     746,   748,   749,   752,   755,   761,   762,   766,   767,   770,
     771,   774,   780,   781,   782,   783,   784,   785,   786,   787,
     788,   791,   792,   798,   799,   800,   801,   802,   803,   804,
     805,   806,   807,   808,   809,   810,   811,   814,   815,   818,
     819,   820,   821,   822,   823,   824,   825,   826,   827,   828,
     829,   830,   831,   832,   833,   834,   835,   837,   838,   839,
     840,   841,   842,   843,   844,   845,   846,   847,   848,   849,
     850,   851,   852,   853,   854,   855,   856,   857,   858,   859,
     860,   861,   862,   863,   864,   865,   866,   867,   868,   869,
     870,   871,   872,   873,   874,   875,   876,   877,   878,   879,
     880,   883,   884,   887,   888,   891,   892,   893,   894,   897,
     898,   901,   902,   905,   906,   909,   910,   911,   912,   913,
     914,   915,   916,   917,   918,   919,   920,   921,   922,   923,
     924,   925,   926,   927,   928,   929,   930,   931,   932,   933,
     934,   935,   936,   937,   938,   939,   940,   941,   942,   943,
     944,   945,   946,   947,   948,   949,   950,   953,   954,   961,
     968,   969,   970,   971,   972,   973,   974,   975,   976,   977,
     978,   979,   980,   981,   982,   983,   990,   991,   998,   999,
    1006,  1007,  1014,  1015,  1022,  1023,  1030,  1031,  1038,  1039,
    1049,  1050,  1064,  1078,  1079,  1086,  1087,  1094,  1095,  1102,
    1103,  1112,  1113,  1122,  1123,  1130,  1131,  1138,  1139,  1146,
    1147,  1154,  1155,  1162,  1163,  1170,  1171,  1178,  1179,  1186,
    1187,  1194,  1195,  1202,  1203,  1210,  1211,  1218,  1219,  1226,
    1227,  1234,  1235,  1242,  1243,  1250,  1251,  1258,  1259,  1266,
    1268,  1275,  1276,  1287,  1288,  1295,  1296,  1303,  1304,  1311,
    1312,  1319,  1320,  1327,  1334,  1341,  1348,  1355,  1362,  1363,
    1370,  1371,  1378,  1379,  1386,  1387,  1394,  1395,  1402,  1403,
    1410,  1411,  1418,  1419,  1426,  1427,  1434,  1435,  1436,  1437,
    1440,  1441,  1444,  1445,  1446,  1447,  1448,  1449,  1461,  1473,
    1486,  1499,  1512,  1525,  1527,  1538,  1539,  1540,  1541,  1547,
    1548,  1558,  1559,  1560,  1561,  1562,  1563,  1570,  1571,  1578,
    1579,  1580,  1581,  1582,  1583,  1584,  1585,  1586,  1587,  1588,
    1589,  1590,  1591,  1592,  1593,  1594,  1595,  1602,  1603,  1610,
    1611,  1618,  1625,  1626,  1627,  1654,  1655,  1656,  1657,  1658,
    1659,  1660,  1661,  1662,  1663,  1664,  1665,  1666,  1667,  1668,
    1669,  1670,  1671,  1672,  1673,  1674,  1675,  1676,  1677,  1686,
    1687,  1696,  1697,  1706,  1707,  1716,  1717,  1718,  1719,  1720,
    1721,  1722,  1723,  1724,  1725,  1726,  1727,  1728,  1729,  1730,
    1731,  1732,  1733,  1734,  1735,  1736,  1737,  1739,  1740,  1742,
    1744,  1745,  1746,  1749,  1750,  1753,  1754,  1755,  1758,  1759,
    1762,  1763,  1764,  1772,  1777,  1782,  1787,  1792,  1795,  1800,
    1808,  1814,  1815,  1825,  1826,  1836,  1837,  1846,  1855,  1856,
    1862,  1863,  1869,  1873,  1874,  1877,  1906,  1921,  1922,  1926,
    1937,  1938,  1942,  1943,  1947,  1954,  1970,  1971,  1974,  1977,
    1984,  2000,  2004,  2005,  2010,  2010,  2017,  2018,  2020,  2019,
    2042,  2047,  2050,  2057,  2073,  2076,  2079,  2086,  2102,  2105,
    2108,  2125,  2128,  2129,  2130,  2131,  2132,  2133,  2155,  2156,
    2157,  2158,  2161,  2162,  2163,  2164,  2167,  2168,  2174,  2175,
    2176,  2177,  2178,  2179,  2180,  2183,  2184,  2185,  2186,  2193,
    2194,  2195,  2202,  2203,  2204,  2208,  2209,  2210,  2211,  2212,
    2217,  2218,  2221,  2222,  2223,  2229,  2231,  2233,  2234,  2236,
    2238,  2240,  2242,  2244,  2245,  2247,  2248,  2249,  2250,  2252,
    2254,  2256,  2258,  2260,  2262,  2263,  2299,  2301,  2303,  2305,
    2308,  2310,  2312,  2314,  2318,  2319,  2330,  2331,  2335,  2336,
    2351,  2366,  2367,  2370,  2371,  2372,  2384,  2385,  2400,  2415,
    2417,  2424,  2466,  2467,  2470,  2471,  2472,  2475,  2476,  2477,
    2478,  2479,  2480,  2481,  2482,  2485,  2493,  2503,  2520,  2527,
    2534,  2541,  2548,  2553,  2558,  2559,  2560,  2561,  2562,  2565,
    2574,  2581,  2606,  2622,  2623,  2628,  2647,  2656,  2668,  2683,
    2684,  2687,  2687,  2697,  2698,  2699,  2700,  2701,  2702,  2703,
    2704,  2705,  2708,  2711,  2712,  2715,  2722,  2725,  2732,  2738,
    2739,  2748,  2749,  2750,  2753,  2754,  2766,  2790,  2801,  2832,
    2836,  2846,  2860,  2872,  2873,  2875,  2876,  2877,  2891,  2892,
    2893,  2894,  2895,  2896,  2897,  2901,  2902,  2903,  2916,  2922,
    2923,  2924,  2925,  2926,  2927,  2928,  2929,  2930,  2931,  2932,
    2933,  2934,  2935,  2936,  2954,  2955,  2956,  2957,  2958,  2959,
    2960,  2961,  2962,  2963,  2964,  2965,  2966,  2967,  2968,  2969,
    2970,  2972,  2974,  2975,  2976,  2977,  2978,  2981,  2999,  3000,
    3001,  3004,  3005,  3006,  3007,  3008,  3009,  3010,  3011,  3012,
    3013,  3014,  3015,  3016,  3017,  3018,  3019,  3020,  3021,  3022,
    3023,  3024,  3025,  3026,  3027,  3028,  3029,  3030,  3031,  3032,
    3033,  3034,  3035,  3036,  3037,  3038,  3046,  3054,  3062,  3070,
    3078,  3086,  3094,  3102,  3110,  3111,  3113,  3121,  3129,  3137,
    3146,  3155,  3164,  3172,  3181,  3189,  3190,  3192,  3195,  3196,
    3197,  3198,  3205,  3212,  3213,  3219,  3226,  3227,  3233,  3240,
    3241,  3247,  3250,  3253,  3254,  3255,  3258,  3259,  3260,  3269,
    3278,  3279,  3280,  3281,  3282,  3283,  3284,  3285,  3286,  3287,
    3288,  3289,  3290,  3291,  3292,  3293,  3294,  3295,  3299,  3303,
    3304,  3305,  3306,  3307,  3308,  3309,  3310,  3311,  3312,  3313,
    3314,  3315,  3316,  3317,  3318,  3319,  3320,  3321,  3322,  3323,
    3324,  3325,  3326,  3327,  3328,  3329,  3330,  3338,  3346,  3354,
    3355,  3357,  3359,  3370,  3371,  3372,  3388,  3389,  3390,  3394,
    3397,  3398,  3401,  3404,  3407,  3410,  3413,  3416,  3419,  3422,
    3425,  3428,  3429,  3430,  3433,  3434,  3435,  3435,  3468,  3470,
    3472,  3473,  3476,  3493,  3497,  3501,  3505,  3510,  3514,  3519,
    3523,  3527,  3531
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "FORWARD", "FORWARD_TCP", "FORWARD_TLS",
  "FORWARD_SCTP", "FORWARD_UDP", "EXIT", "DROP", "RETURN", "BREAK",
  "LOG_TOK", "ERROR", "ROUTE", "ROUTE_REQUEST", "ROUTE_FAILURE",
  "ROUTE_ONREPLY", "ROUTE_REPLY", "ROUTE_BRANCH", "ROUTE_SEND",
  "ROUTE_EVENT", "EXEC", "SET_HOST", "SET_HOSTPORT", "SET_HOSTPORTTRANS",
  "PREFIX", "STRIP", "STRIP_TAIL", "SET_USERPHONE", "APPEND_BRANCH",
  "REMOVE_BRANCH", "CLEAR_BRANCHES", "SET_USER", "SET_USERPASS",
  "SET_PORT", "SET_URI", "REVERT_URI", "FORCE_RPORT", "ADD_LOCAL_RPORT",
  "FORCE_TCP_ALIAS", "UDP_MTU", "UDP_MTU_TRY_PROTO", "UDP4_RAW",
  "UDP4_RAW_MTU", "UDP4_RAW_TTL", "IF", "ELSE", "SET_ADV_ADDRESS",
  "SET_ADV_PORT", "FORCE_SEND_SOCKET", "SET_FWD_NO_CONNECT",
  "SET_RPL_NO_CONNECT", "SET_FWD_CLOSE", "SET_RPL_CLOSE", "SWITCH", "CASE",
  "DEFAULT", "WHILE", "CFG_SELECT", "CFG_RESET", "URIHOST", "URIPORT",
  "MAX_LEN", "SETFLAG", "RESETFLAG", "ISFLAGSET", "SETAVPFLAG",
  "RESETAVPFLAG", "ISAVPFLAGSET", "METHOD", "URI", "FROM_URI", "TO_URI",
  "SRCIP", "SRCPORT", "DSTIP", "DSTPORT", "TOIP", "TOPORT", "SNDIP",
  "SNDPORT", "SNDPROTO", "SNDAF", "PROTO", "AF", "MYSELF", "MSGLEN", "UDP",
  "TCP", "TLS", "SCTP", "WS", "WSS", "DEBUG_V", "FORK", "FORK_DELAY",
  "MODINIT_DELAY", "LOGSTDERROR", "LOGFACILITY", "LOGNAME", "LOGCOLOR",
  "LOGPREFIX", "LOGPREFIXMODE", "LOGENGINETYPE", "LOGENGINEDATA",
  "XAVPVIAPARAMS", "XAVPVIAFIELDS", "LISTEN", "ADVERTISE", "STRNAME",
  "ALIAS", "SR_AUTO_ALIASES", "DNS", "REV_DNS", "DNS_TRY_IPV6",
  "DNS_TRY_NAPTR", "DNS_SRV_LB", "DNS_UDP_PREF", "DNS_TCP_PREF",
  "DNS_TLS_PREF", "DNS_SCTP_PREF", "DNS_RETR_TIME", "DNS_SLOW_QUERY_MS",
  "DNS_RETR_NO", "DNS_SERVERS_NO", "DNS_USE_SEARCH", "DNS_SEARCH_FMATCH",
  "DNS_NAPTR_IGNORE_RFC", "DNS_CACHE_INIT", "DNS_USE_CACHE",
  "DNS_USE_FAILOVER", "DNS_CACHE_FLAGS", "DNS_CACHE_NEG_TTL",
  "DNS_CACHE_MIN_TTL", "DNS_CACHE_MAX_TTL", "DNS_CACHE_MEM",
  "DNS_CACHE_GC_INT", "DNS_CACHE_DEL_NONEXP", "DNS_CACHE_REC_PREF",
  "AUTO_BIND_IPV6", "BIND_IPV6_LINK_LOCAL", "DST_BLST_INIT",
  "USE_DST_BLST", "DST_BLST_MEM", "DST_BLST_TTL", "DST_BLST_GC_INT",
  "DST_BLST_UDP_IMASK", "DST_BLST_TCP_IMASK", "DST_BLST_TLS_IMASK",
  "DST_BLST_SCTP_IMASK", "IP_FREE_BIND", "PORT", "STAT", "STATS_NAMESEP",
  "CHILDREN", "SOCKET_WORKERS", "ASYNC_WORKERS", "ASYNC_USLEEP",
  "ASYNC_NONBLOCK", "CHECK_VIA", "PHONE2TEL", "MEMLOG", "MEMDBG", "MEMSUM",
  "MEMSAFETY", "MEMJOIN", "MEMSTATUSMODE", "CORELOG", "SIP_WARNING",
  "SERVER_SIGNATURE", "SERVER_HEADER", "USER_AGENT_HEADER", "REPLY_TO_VIA",
  "LOADMODULE", "LOADPATH", "MODPARAM", "CFGENGINE", "MAXBUFFER",
  "SQL_BUFFER_SIZE", "USER", "GROUP", "CHROOT", "WDIR", "RUNDIR", "MHOMED",
  "DISABLE_TCP", "TCP_ACCEPT_ALIASES", "TCP_ACCEPT_UNIQUE",
  "TCP_CONNECTION_MATCH", "TCP_CHILDREN", "TCP_CONNECT_TIMEOUT",
  "TCP_SEND_TIMEOUT", "TCP_CON_LIFETIME", "TCP_POLL_METHOD",
  "TCP_MAX_CONNECTIONS", "TLS_MAX_CONNECTIONS", "TCP_NO_CONNECT",
  "TCP_SOURCE_IPV4", "TCP_SOURCE_IPV6", "TCP_OPT_FD_CACHE",
  "TCP_OPT_BUF_WRITE", "TCP_OPT_CONN_WQ_MAX", "TCP_OPT_WQ_MAX",
  "TCP_OPT_RD_BUF", "TCP_OPT_WQ_BLK", "TCP_OPT_DEFER_ACCEPT",
  "TCP_OPT_DELAYED_ACK", "TCP_OPT_SYNCNT", "TCP_OPT_LINGER2",
  "TCP_OPT_KEEPALIVE", "TCP_OPT_KEEPIDLE", "TCP_OPT_KEEPINTVL",
  "TCP_OPT_KEEPCNT", "TCP_OPT_CRLF_PING", "TCP_OPT_ACCEPT_NO_CL",
  "TCP_OPT_ACCEPT_HEP3", "TCP_OPT_ACCEPT_HAPROXY", "TCP_CLONE_RCVBUF",
  "TCP_REUSE_PORT", "DISABLE_TLS", "ENABLE_TLS", "TLSLOG", "TLS_PORT_NO",
  "TLS_METHOD", "TLS_HANDSHAKE_TIMEOUT", "TLS_SEND_TIMEOUT", "SSLv23",
  "SSLv2", "SSLv3", "TLSv1", "TLS_VERIFY", "TLS_REQUIRE_CERTIFICATE",
  "TLS_CERTIFICATE", "TLS_PRIVATE_KEY", "TLS_CA_LIST", "DISABLE_SCTP",
  "ENABLE_SCTP", "SCTP_CHILDREN", "ADVERTISED_ADDRESS", "ADVERTISED_PORT",
  "DISABLE_CORE", "OPEN_FD_LIMIT", "SHM_MEM_SZ", "SHM_FORCE_ALLOC",
  "MLOCK_PAGES", "REAL_TIME", "RT_PRIO", "RT_POLICY", "RT_TIMER1_PRIO",
  "RT_TIMER1_POLICY", "RT_TIMER2_PRIO", "RT_TIMER2_POLICY",
  "MCAST_LOOPBACK", "MCAST_TTL", "MCAST", "TOS", "PMTU_DISCOVERY",
  "KILL_TIMEOUT", "MAX_WLOOPS", "PVBUFSIZE", "PVBUFSLOTS", "PVCACHELIMIT",
  "PVCACHEACTION", "HTTP_REPLY_PARSE", "VERSION_TABLE_CFG",
  "VERBOSE_STARTUP", "ROUTE_LOCKS_SIZE", "CFG_DESCRIPTION", "SERVER_ID",
  "KEMI", "ONSEND_ROUTE_CALLBACK", "REPLY_ROUTE_CALLBACK",
  "EVENT_ROUTE_CALLBACK", "RECEIVED_ROUTE_CALLBACK", "RECEIVED_ROUTE_MODE",
  "MAX_RECURSIVE_LEVEL", "MAX_BRANCHES_PARAM", "LATENCY_CFG_LOG",
  "LATENCY_LOG", "LATENCY_LIMIT_DB", "LATENCY_LIMIT_ACTION",
  "LATENCY_LIMIT_CFG", "MSG_TIME", "ONSEND_RT_REPLY",
  "URI_HOST_EXTRA_CHARS", "FLAGS_DECL", "AVPFLAGS_DECL", "ATTR_MARK",
  "SELECT_MARK", "ATTR_FROM", "ATTR_TO", "ATTR_FROMURI", "ATTR_TOURI",
  "ATTR_FROMUSER", "ATTR_TOUSER", "ATTR_FROMDOMAIN", "ATTR_TODOMAIN",
  "ATTR_GLOBAL", "ADDEQ", "SUBST", "SUBSTDEF", "SUBSTDEFS", "EQUAL",
  "LOG_OR", "LOG_AND", "BIN_OR", "BIN_AND", "BIN_XOR", "BIN_LSHIFT",
  "BIN_RSHIFT", "EQUAL_T", "DIFF", "MATCH", "INTEQ", "INTDIFF", "STREQ",
  "STRDIFF", "GT", "LT", "GTE", "LTE", "PLUS", "MINUS", "STAR", "SLASH",
  "MODULO", "NOT", "UNARY", "BIN_NOT", "DEFINED", "INTCAST", "STRCAST",
  "DOT", "STRLEN", "STREMPTY", "NUMBER", "ID", "NUM_ID", "STRING",
  "IPV6ADDR", "PVAR", "AVP_OR_PVAR", "EVENT_RT_NAME", "COMMA", "SEMICOLON",
  "RPAREN", "LPAREN", "LBRACE", "RBRACE", "LBRACK", "RBRACK", "CR",
  "COLON", "$accept", "cfg", "statements", "statement", "$@1", "$@2",
  "$@3", "$@4", "$@5", "listen_id", "listen_id_lst", "listen_id2", "proto",
  "eqproto", "port", "phostport", "listen_phostport", "id_lst", "intno",
  "flags_decl", "flag_list", "flag_spec", "flag_name", "avpflags_decl",
  "avpflag_list", "avpflag_spec", "assign_stm", "cfg_var_id",
  "cfg_var_idn", "cfg_var", "module_stm", "ip", "ipv4", "ipv6addr", "ipv6",
  "route_name", "route_main", "route_stm", "failure_route_main",
  "failure_route_stm", "route_reply_main", "onreply_route_stm", "$@6",
  "$@7", "branch_route_main", "branch_route_stm", "send_route_main",
  "send_route_stm", "event_route_main", "event_route_stm",
  "preprocess_stm", "equalop", "cmpop", "strop", "rve_equalop",
  "rve_cmpop", "uri_type", "eint_op_onsend", "eint_op", "eip_op_onsend",
  "eip_op", "exp_elem", "ipnet", "host", "host_if_id", "host_or_if",
  "fcmd", "stm", "actions", "action", "if_cmd", "ct_rval", "single_case",
  "case_stms", "switch_cmd", "while_cmd", "select_param", "select_params",
  "select_id", "$@8", "attr_class_spec", "attr_name_spec", "attr_spec",
  "attr_mark", "attr_id", "attr_id_num_idx", "attr_id_no_idx",
  "attr_id_ass", "attr_id_any", "attr_id_any_str", "pvar", "avp_pvar",
  "assign_op", "lval", "rval", "rve_un_op", "rval_expr", "assign_action",
  "avpflag_oper", "cmd", "$@9", "func_params", "func_param", "ret_cmd", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608
};
# endif

#define YYPACT_NINF -1174

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-1174)))

#define YYTABLE_NINF -897

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    2529,  -238,     9,    15,  -213,  -202,  -183,  -143,  -124,  -113,
   -1174,   -74,   -65,   -61,   -54,   -51,   -47,   -33,   -22,    19,
      34,    39,    77,   376,   410,   414,   430,   468,   480,   530,
      37,   188,   219,   322,   568,   605,   662,   664,   689,   736,
     773,   801,   820,   854,   874,   877,   895,   905,   910,   913,
     914,   917,   920,   923,   927,   928,   931,   939,   941,   943,
     947,   953,   954,   957,   960,   967,   549,   550,   564,   588,
     597,   610,   616,   620,   666,   677,   686,   708,   714,   739,
     762,   813,   836,   837,   859,   870,   872,   880,   134,    47,
      43,   187,   887,   888,   900,   901,   908,   911,   915,   919,
     935,   944,   956,   959,   963,   964,   966,   970,   974,   977,
     986,  1001,  1003,  1004,  1023,  1029,   971,   972,   978,   982,
    1042,  1057,  1068,  1070,  1131,  1132,  1133,  1136,  1137,  1138,
    1224,  1226,  1227,  1228,  1229,  1271,  1272,  1313,  1314,  1315,
    1317,  1318,  1324,  1325,  1326,  1331,  1332,  1334,  1336,  1337,
    1338,  1339,  1340,  1349,  1350,  1351,  1352,  1353,  1354,  1355,
    1356,  1357,  1358,  1359,  1360,  1361,  1362,   987,  1363,  1364,
    1366,  1367,  1373,  1374,  1375,  1376,  1377,  1378,  1379,   451,
    1380,  1381,  1382,  1383,  1408,  1409,  1410,  1411,  1413,  1414,
    1415,   202,   220,   158,   168,   194, -1174, -1174, -1174,    82,
    1630, -1174,   245,   336,   292,   965,   871, -1174, -1174, -1174,
    -303, -1174, -1174,   638, -1174, -1174, -1174, -1174,  -165, -1174,
     151,   215,   771,   332,   274,   333,   437,   335,   338,   491,
     559,   130,   201,   574,   234,   584,   242,   243,   264,   272,
      55,   240,   626,   628,   679, -1174,   657, -1174,   660, -1174,
     687, -1174,  -158, -1174,  -158, -1174,  -158, -1174,  -158, -1174,
     691, -1174,   700, -1174,   701, -1174,   704, -1174,   713, -1174,
     722, -1174,   742, -1174,   765, -1174,   769, -1174,   774, -1174,
     784, -1174,   789, -1174,   797, -1174,   816, -1174,   843, -1174,
     883, -1174,  1026, -1174,  1385, -1174,  1386, -1174,  1403, -1174,
    1404, -1174,  1447, -1174,  1521, -1174,  1522, -1174,  1523, -1174,
    1524, -1174,  1562, -1174,  1565, -1174,  1566,   443,   680,   273,
     682,   683,   690,   692,   693,   694,   695,   452,   454,   462,
     464,   512,   520,   561,   696,   699,   275,   277,   702, -1174,
   -1174, -1174,   278, -1174, -1174,   663, -1174,   279, -1174,   705,
     711,   231,   249,   252,   256,   257,   717,   718,   719,   720,
     721,   723,   571,   623,   630,   260,   724,   725,   733,   734,
      33,   737,   743, -1174,  1567, -1174,  1568, -1174,  1582, -1174,
    1583,   744,   745,   746,   747,   748,   749,   750,   751,   752,
     753,   754,   755,   756,   757,   758,   760,   761,   763,    86,
     764,   766,   767,   775,   281,   282,   283,   777,   779,   781,
      31,   785,   788,   790,   791,   792,   793,   794,   795,   796,
     802,   805,   806,   807,   808,   809,   261,   113, -1174,  1584,
     810,   811,   812,   814,   815,   822,   823,   284,   828,   829,
     830,  1064,   634,  1585,  1586,   648,   651,   831,   833,   838,
     845,   846,   287, -1174, -1174, -1174, -1174,   706,  1570, -1174,
   -1174, -1174,  1580, -1174, -1174, -1174, -1174, -1174, -1174, -1174,
    -238, -1174,    48,    24,  1371, -1174,    49,  1372, -1174,    58,
    1577, -1174,    67,  1578, -1174,    11,   799, -1174,   -16,  1591,
   -1174, -1174, -1174, -1174,   949, -1174, -1174, -1174, -1174, -1174,
   -1174, -1174, -1174, -1174, -1174, -1174, -1174,  1592, -1174, -1174,
   -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174,
   -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174,
   -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174,
   -1174, -1174, -1174,  1596, -1174, -1174, -1174, -1174,  -132,  1593,
   -1174,  1581,  1605,   955,   589, -1174, -1174, -1174, -1174, -1174,
    -272, -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174,
   -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174,
   -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174,
   -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174,
   -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174,
   -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174,
   -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174,
   -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174,
   -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174,
   -1174,  1615, -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174,
   -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174,
   -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174,
   -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174,
   -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174,
   -1174,  1596, -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174,
   -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174,
   -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174,
   -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174,
   -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174,
   -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174,
   -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174,
   -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174,
   -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174,
   -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174,
   -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174,
   -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174,
   -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174,
   -1174, -1174, -1174, -1174, -1174,  1657,  1658,  1659,  1660, -1174,
   -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174,
   -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174,  -189,
    1628,  -189, -1174,  -165, -1174, 11788, -1174,  -165, 11788, -1174,
    -165, 11788, -1174,  -165, 11788, -1174,  1622, -1174, -1174, -1174,
    1663,  1617, 11788,    41, -1174,  1633,  1626,  1625,  1621,   317,
    1286, -1174,  -132,   759,    17,   324,  1634,   289,   291,   293,
     294, -1174, -1174, -1174,  1623,    56,    62,    65,    69,    73,
   10700, 11046, 11131, -1174,    75,    76,    78,  1629,    88,   101,
     111,   112,   114,   115,   117,   122,  1632,   129,   132,   136,
     137,  1648,  1649,  1650,  1651,  1652, 11216,   146,   153,   154,
    1653,  1654,  1674,  1676,  6372, 11216,   155,   162,   172,   180,
     181, -1174, -1174, -1174, -1174,   183, -1174, -1174, -1174,    79,
    3634, -1174, -1174, -1174, -1174,  1021, -1174, -1174, -1174, -1174,
   -1174,  1675,  1635,   184, -1174,  1665,  1673,  3710,  1685,  3790,
    1686,  4057,  1690,   265,  1692,  4137, -1174,  1679,  1709,  -132,
   -1174, -1174, -1174, -1174, -1174, -1174,  1698,   -41, -1174, -1174,
   -1174, -1174, -1174, -1174,  1699, -1174, -1174, -1174, -1174, -1174,
   -1174, -1174, -1174,  1716, -1174,    97, -1174,   135, -1174,   175,
   -1174,   208, -1174,   216,   614, -1174, -1174, -1174, -1174, -1174,
   -1174, -1174, -1174, -1174, -1174, -1174,  1121, -1174,  1121, -1174,
     665, -1174, -1174,  1592, -1174, -1174,  6459,  6546,  6894,  1718,
    1719, -1174,  5502, 11716, -1174,   889, -1174,   876, -1174,   916,
   -1174, -1174, -1174,  1021, -1174, -1174, -1174, -1174, -1174, -1174,
   -1174,  6981,  1384,  5850,  1384,  5937,  1384, -1174,   266, -1174,
     295, -1174,  7068,  1728, -1174,   297, -1174,   298, -1174,   301,
   -1174,   303, -1174,   848, -1174,   849, -1174,  1722, -1174,   238,
    1723, -1174,   304, -1174,   305, -1174,   306, -1174,   307,  1724,
    1733,  1744,   110,   798,  7416, 10633, -1174,    92, -1174,   850,
   -1174,    38,  1746,  1747,  1748,  1750, -1174,  1083, 10633, -1174,
     308, -1174,   309, -1174,   527, -1174,   685, -1174,   738, -1174,
    1758, -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174,
   -1174, -1174, -1174, -1174, -1174, -1174,  1773, -1174,  1760, -1174,
   11216, -1174, -1174,   190, -1174,  1763, -1174,  1764, -1174,  1772,
   -1174,  1785, -1174,  1866,  1867,   -16, -1174, 11788,  1800, -1174,
    -240,  1798,  1802,  -251, 11788,  1793,  -176, -1174,  -145, -1174,
    -118,  -271,  1813,   539,   593,   768,   866,  1815,   817,   826,
     832,   932,  1816,   863,   899,   907,  1011,  1817,   952,   984,
     997,  1030, -1174, -1174, -1174, -1174, -1174, -1174, -1174,  7503,
    5316,  5409, -1174,  1251,  1811, -1174, -1174, -1174, -1174, -1174,
   -1174,  7590,  7938,  1819, -1174,  1871,  1872,  1876,  1877,  1139,
    1835,  1840,  4206, -1174,  8025, -1174, -1174, -1174, -1174, -1174,
    8112,  8460, -1174,  2864,  1852, -1174, -1174,  8547,  8634,  8982,
    9069, 11216, 11216, 11216, -1174, -1174, -1174, -1174, -1174, -1174,
   -1174, -1174, -1174, -1174, -1174,  9156,  9504,  9591,  9678, 10026,
   10113, 10200, -1174, -1174,  1857,  1860,  1859,  1861,  1862,  1882,
      54,  1182,  1884,  1885,  1886,  1888,  1897,  1898,  1902,  1903,
    1904,  1911,  1912,  1913,  1914, -1174,  1915, -1174,  1916, -1174,
    1917,  1918,  1919,  1920,  1921,  1923,  1924,  1925, -1174, -1174,
   -1174,  1926,  1927, -1174,  1928,  1929, 11788,  2161, -1174,  1930,
    1931,  1932,  1933,  1934,  1864,  1954,  1935, -1174, -1174, -1174,
   -1174,    35, -1174,  1936,  1939,  1962,  1963,  1964,  1965,  1966,
    1968,  1969,  1970, 11216,  1981,  1972,  1384,  1010, -1174,  1021,
   -1174,  1975, -1174, 11788, 11788, 11788, 11788,  1990,  1991,  2017,
    4275,  1998, -1174, -1174,  2222,  1988,  1989,  4404, -1174,   -35,
   -1174,  2000, -1174,  2002, -1174,   186,   197,  2003, -1174, -1174,
      -9, -1174,  2004, -1174,  2005, -1174,  2006, -1174, -1174,     2,
   -1174,  2007, -1174,  2008, -1174,  2009, -1174, -1174,     5, -1174,
    2010, -1174,  2011, -1174,  2012, -1174, -1174,   602, -1174,  2013,
   -1174,  2014, -1174,  2015, -1174, -1174,  2049,  1059, -1174, -1174,
   -1174, -1174, -1174, -1174, -1174, -1174, -1174,  1059, -1174, -1174,
    1059, -1174, -1174, -1174,  2026, -1174,  2019,  2031,  1230,  2032,
    1273, -1174, -1174, -1174, -1174, -1174, -1174,  2118,  1059, -1174,
    1059, -1174,   681, -1174,  2187,  1596,  1980,  2054, -1174,  -199,
    1059,  -265, -1174,  2282, -1174,  1104, -1174,  2525, -1174,  1158,
    1200,  1247,  1289, -1174,  -114, -1174,  -114, -1174, -1174, -1174,
   -1174, -1174, -1174, -1174,  1059, -1174,   681, -1174,  2041, -1174,
   -1174,  2042, -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174,
   -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174,
   -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174,
   -1174, -1174,  4622, 11647, -1174, -1174, -1174, -1174, -1174,   481,
    -132, -1174,  2033,  6024,  2030, -1174, -1174,   671, -1174, 11562,
   -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174,  1384,  1015,
   -1174, -1174, -1174,  -189, -1174, -1174,   270,  4751,  4820,  4889,
    4969, -1174, -1174,  -139, -1174,  2048,  2046, -1174, -1174, -1174,
    2043,  2052,  2053,  2055, -1174, -1174, -1174, -1174,  2057,  2058,
    2059,  2061,  2062,  2063,  2064,  2065,  2066,  2067,  2068,  2069,
    2070,  2071,  2072,  2073,  2074,  2075,  2099,  2100,  2101,  -109,
    1811, -1174, -1174, -1174, -1174,     8,  2036,  2102,  2103, -1174,
   -1174, -1174, -1174,  2035, -1174,  2039, 10548,  2047,  1384, 11788,
   -1174, -1174,  2104,  1631, 11216, -1174,  2105,  2106,  2107, -1174,
   -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174,
   -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174,
   -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174,
   -1174, -1174,  2110,  2114, -1174, -1174,  1596, -1174, -1174, -1174,
   -1174,  -240, 11788,  2115,  2116,  2951,  3020, -1174, -1174, -1174,
   -1174, -1174, -1174, -1174, -1174, -1174,  3090, 11788, 11788, -1174,
    3218,  3443,  3565
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     459,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   458,    22,    23,     0,
       0,     4,     0,     0,     0,     0,     0,     8,     9,     6,
       0,   456,    10,     0,    15,     7,   457,   506,     0,   507,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   105,     0,   107,     0,   109,
       0,   111,     0,   113,     0,   115,     0,   117,     0,   119,
       0,   121,     0,   123,     0,   125,     0,   127,     0,   129,
       0,   131,     0,   133,     0,   135,     0,   137,     0,   139,
       0,   141,     0,   145,     0,   143,     0,   147,     0,   149,
       0,   151,     0,   153,     0,   155,     0,   157,     0,   159,
       0,   161,     0,   163,     0,   165,     0,   167,     0,   169,
       0,   171,     0,   173,     0,   175,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   471,
     470,   473,     0,   472,   478,     0,   480,     0,   479,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   269,     0,   271,     0,   273,     0,   275,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   397,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    60,    66,    65,    59,    61,    63,    68,
      71,    67,    69,   523,   522,   525,   524,   527,   526,     1,
       5,     3,     0,     0,     0,    12,     0,     0,    14,     0,
       0,    17,     0,     0,    19,     0,     0,    21,     0,     0,
     504,   489,   490,   491,     0,   447,   446,   445,   444,   449,
      31,    32,    33,    34,    35,   448,   451,     0,    57,   450,
     453,   452,   455,   454,    73,    72,    75,    74,    77,    76,
      79,    78,    81,    80,    83,    82,    85,    84,    87,    86,
      89,    88,    91,    90,    93,    92,    95,    94,    97,    96,
      99,    98,   353,   605,   603,   604,    25,   486,     0,     0,
      30,    50,     0,    55,   347,    24,   483,   487,   484,   606,
      26,   355,   354,   357,   356,   101,   100,   103,   102,   104,
     106,   108,   110,   112,   114,   116,   118,   120,   122,   124,
     126,   128,   130,   132,   134,   136,   138,   140,   144,   142,
     146,   148,   150,   152,   154,   156,   158,   160,   162,   164,
     166,   168,   170,   172,   174,   177,   176,   183,   178,   187,
     186,   185,   184,   189,   188,   191,   190,   193,   192,   195,
     194,   197,   196,   199,   198,   201,   200,   203,   202,   205,
     204,   207,   206,   209,   208,   211,   210,   213,   212,   215,
     214,   338,   337,   340,   339,   342,   341,   346,   345,   475,
     474,     0,   482,   481,   180,   179,   182,   181,   220,   219,
     218,   223,   222,   221,   226,   225,   224,   229,   228,   227,
     232,   231,   230,   234,   233,   236,   235,   238,   237,   240,
     239,   242,   241,   244,   243,   246,   245,   248,   247,   250,
     249,   253,   251,   252,   255,   254,   257,   256,   259,   258,
     261,     0,   260,   263,   262,   265,   264,   267,   266,   268,
     270,   272,   274,   277,   276,   279,   278,   281,   280,   283,
     282,   285,   284,   287,   286,   289,   288,   291,   290,   293,
     292,   295,   294,   297,   296,   299,   298,   301,   300,   303,
     302,   305,   304,   307,   306,   309,   308,   311,   310,   316,
     312,   313,   314,   315,   328,   327,   330,   329,   318,   317,
     320,   319,   322,   321,   324,   323,   326,   325,   332,   331,
     334,   333,   336,   335,   359,   358,   361,   360,   363,   362,
     365,   364,   367,   366,   369,   368,   371,   370,   373,   372,
     375,   374,   377,   376,   379,   378,   381,   380,   383,   382,
     385,   384,   387,   386,   389,   388,   392,   390,   391,   395,
     393,   394,   396,   399,   398,   401,   400,   403,   402,   405,
     404,   407,   406,   409,   408,   411,   410,   217,   216,   413,
     412,   415,   414,   417,   416,     0,     0,     0,     0,   427,
     426,   428,   429,   433,   432,   431,   430,   435,   434,   437,
     436,   439,   438,   441,   440,   443,   442,   344,   343,     0,
       0,     0,   496,     0,   497,     0,   501,     0,     0,   514,
       0,     0,   518,     0,     0,   521,     0,   461,   462,   460,
       0,     0,     0,     0,    58,     0,    27,     0,     0,     0,
       0,    56,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    62,    64,    70,     0,     0,     0,     0,     0,     0,
     908,   905,   909,   912,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   861,   863,   865,   868,     0,     0,     0,     0,     0,
     882,   884,   886,   888,     0,     0,     0,     0,     0,     0,
       0,   738,   739,   740,   665,     0,   677,   678,   623,     0,
       0,   615,   618,   619,   620,     0,   669,   670,   680,   681,
     682,     0,     0,     0,   611,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   510,     0,     0,     0,
      29,   488,    54,    44,    43,    51,    52,   351,   348,   610,
     605,   608,   609,   607,     0,   419,   418,   421,   420,   423,
     422,   425,   424,     0,   751,     0,   773,     0,   784,     0,
     795,     0,   762,     0,     0,   549,   550,   551,   562,   555,
     563,   556,   561,   553,   560,   552,     0,   554,     0,   557,
       0,   558,   651,   697,   695,   696,     0,     0,     0,     0,
       0,   684,     0,     0,   683,     0,   559,     0,   564,     0,
     690,   689,   688,     0,   671,   673,   672,   685,   686,   687,
     698,     0,   907,     0,   904,     0,   911,   799,     0,   816,
       0,   820,     0,     0,   824,     0,   843,     0,   846,     0,
     827,     0,   833,     0,   830,     0,   836,     0,   839,     0,
       0,   852,     0,   855,     0,   849,     0,   858,     0,     0,
       0,     0,     0,     0,     0,     0,   874,     0,   877,     0,
     880,     0,     0,     0,     0,     0,   643,     0,     0,   891,
       0,   894,     0,   803,     0,   806,     0,   809,     0,   898,
       0,   624,   617,   616,   494,   614,   653,   654,   655,   656,
     657,   658,   659,   660,   661,   662,     0,   663,   666,   679,
       0,   622,   814,     0,   621,     0,   499,     0,   512,     0,
     516,     0,   467,   463,   464,     0,   505,     0,     0,    28,
       0,     0,     0,     0,     0,     0,     0,   598,     0,   741,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   568,   528,   529,   537,   530,   531,   536,     0,
       0,     0,   593,     0,     0,   736,   719,   721,   700,   722,
     701,     0,     0,     0,   906,   671,   672,   686,   687,     0,
       0,     0,     0,   572,     0,   577,   532,   533,   534,   535,
       0,     0,   589,     0,   666,   720,   699,     0,     0,     0,
       0,     0,     0,     0,   538,   539,   544,   540,   541,   542,
     543,   545,   546,   547,   548,     0,     0,     0,     0,     0,
       0,     0,   903,   910,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   835,     0,   838,     0,   841,
       0,     0,     0,     0,     0,     0,     0,     0,   860,   862,
     864,     0,     0,   867,     0,     0,     0,   625,   612,     0,
       0,     0,     0,     0,    45,     0,     0,   881,   883,   885,
     887,     0,   645,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   899,     0,     0,   737,     0,   676,     0,
     674,     0,   675,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    53,   352,   349,     0,     0,     0,   752,     0,
     750,     0,   743,     0,   744,     0,     0,     0,   742,   774,
       0,   772,     0,   765,     0,   766,     0,   764,   785,     0,
     783,     0,   776,     0,   777,     0,   775,   796,     0,   794,
       0,   787,     0,   788,     0,   786,   763,     0,   761,     0,
     754,     0,   755,     0,   753,   567,     0,   565,   583,    36,
      37,    38,    39,    40,    41,    42,   581,   582,   580,   578,
     579,   592,   590,   591,   646,   650,   652,     0,     0,     0,
       0,   694,   716,   693,   692,   691,   571,     0,   569,   576,
     574,   575,   573,   588,     0,    57,     0,   596,   584,   586,
     585,     0,   733,   715,   732,   714,   728,   707,   729,   708,
     709,   710,   711,   723,   702,   724,   703,   725,   704,   726,
     705,   727,   706,   731,   713,   730,   712,   800,     0,   797,
     817,     0,   821,   819,   818,   822,   825,   823,   844,   842,
     847,   845,   828,   826,   834,   832,   831,   829,   840,   837,
     853,   851,   856,   854,   850,   848,   859,   857,   869,   866,
     871,   870,     0,     0,   873,   872,   876,   875,   879,     0,
       0,   878,     0,     0,     0,   642,   640,     0,   892,     0,
     895,   893,   801,   802,   804,   805,   807,   808,   902,     0,
     901,   664,   668,     0,   813,   666,     0,     0,     0,     0,
       0,   465,   466,     0,   509,     0,     0,   476,   477,   495,
       0,     0,     0,     0,   602,   600,   601,   599,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   734,   717,   735,   718,     0,     0,     0,     0,   613,
     626,    49,    46,    47,   644,     0,     0,     0,   627,   633,
     641,   639,    57,     0,     0,   897,     0,     0,     0,   500,
     513,   517,   520,   468,   469,   485,   350,   748,   749,   746,
     747,   745,   770,   771,   768,   769,   767,   781,   782,   779,
     780,   778,   792,   793,   790,   791,   789,   759,   760,   757,
     758,   756,     0,     0,   649,   597,   595,   594,   667,   798,
     815,     0,   636,     0,     0,     0,     0,   889,   890,   900,
     812,   811,   810,   648,   647,    48,     0,   637,   631,   638,
       0,     0,     0
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -1174, -1174, -1174,  2254, -1174, -1174, -1174, -1174, -1174,  -406,
    1467,  1587,  -220,  1236, -1173, -1174, -1174,  -221,  -223, -1174,
    1599, -1174,  -191, -1174,  1606, -1174, -1174, -1174,  1295, -1174,
   -1174, -1002,  2109,  1937,  2111,   391, -1174, -1174, -1174, -1174,
   -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174, -1174,
   -1174, -1012, -1174,  -893, -1174, -1174,  1249, -1174, -1174, -1174,
    1250, -1174, -1174,   280,  -631, -1174,  -414, -1122,  -707,  -882,
   -1174,   853,   929, -1174, -1174, -1174,   864, -1174, -1174, -1174,
   -1174,  1126, -1040,  -461,  -860, -1174,  -688, -1174, -1174, -1174,
    -634,  -828, -1174, -1174, -1174, -1174,    89,  -992, -1174, -1174,
   -1174, -1174,   851, -1174
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,   199,   200,   201,   202,   203,   204,   205,   206,   550,
     887,   551,   552,  1436,   995,  1336,   553,   554,  1054,   207,
     456,   457,   458,   208,   461,   462,   209,   210,   880,   211,
     212,   555,   556,   557,   558,   494,   474,   475,   477,   478,
     213,   214,   882,   987,   480,   481,   483,   484,   486,   487,
     215,  1218,  1251,  1219,  1280,  1281,  1055,  1056,  1057,  1058,
    1059,  1060,  1468,  1191,   559,   560,  1061,  1327,   960,   961,
     962,  1627,  1546,  1547,   963,   964,  1445,  1446,  1062,  1224,
    1156,  1157,  1158,  1063,  1064,  1065,  1066,   968,  1067,  1361,
    1068,  1069,  1160,   971,  1070,  1071,  1239,   972,   973,   974,
    1140,  1559,  1560,   975
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     509,   460,   505,   515,   775,   966,  1342,  1372,   966,  1675,
     217,   966,   875,  1190,   966,  1195,   219,  1200,   999,  1205,
     562,  1210,   966,  1254,  1220,   864,  1221,  1580,  1223,   572,
     488,   573,   774,   574,   703,   575,  1542,   970,   245,  1333,
     970,   877,   986,   970,   344,  1250,   970,   489,   341,   862,
     866,   894,  1385,  1589,   970,  1139,   542,  1014,   507,   869,
    1240,   895,  1386,  1016,  1594,   216,  1018,  1599,   872,  1181,
    1020,   508,   507,  1387,  1022,  1388,  1077,  1079,  1145,  1081,
    1141,  1240,   469,  1240,   993,   508,  1562,   749,  1375,  1084,
     220,  1543,  1544,  1329,   606,  1145,   994,  1145,  1185,  1145,
     966,   221,  1086,  1145,   626,   628,   630,   632,   634,   636,
     638,  1321,  1088,  1090,   809,  1092,  1094,   966,  1096,   966,
     222,   966,  1240,  1098,  1385,   966,   500,   501,   502,   503,
    1101,   524,   970,  1103,  1386,   339,  1192,  1105,  1107,   686,
     688,   690,   886,   500,   501,   502,   503,  1116,   454,   970,
     455,   970,   495,   970,  1118,  1120,  1129,   970,  1186,   463,
     223,   977,  1244,  1131,   979,   507,  1253,   981,  1379,   465,
    1380,   491,   492,  1133,   493,   985,  1197,   967,   508,   224,
     967,  1135,  1137,   967,  1139,  1162,   967,  1584,   346,   247,
     225,  1357,  1235,   966,   967,   467,  1193,  1643,  1586,  1381,
    1644,  1382,   526,   453,   543,   544,   545,   546,   547,  1202,
    1277,  1278,  1279,  1235,   507,  1235,   497,  1207,   549,   840,
     249,   459,   844,   846,  1238,   970,  1383,   508,  1384,   226,
    1672,   969,   658,  1328,   969,   530,  1198,   969,   227,  1306,
     969,   561,   228,   534,   536,  1238,  1328,  1238,   969,   229,
     661,  1467,   230,   664,  1235,   966,   231,   667,   670,   472,
     473,   691,   806,  1001,  1003,   538,  1172,  1284,   966,  1203,
     232,  1637,   967,   540,   609,   510,   643,  1208,   645,   649,
     652,   233,   762,   764,   766,   827,  1238,   970,   857,   967,
    1005,   967,  1007,   967,  1009,  1011,  1287,   967,  1293,  1295,
     970,  1581,  1297,  1360,  1299,  1310,  1312,  1314,  1316,  1343,
    1345,   479,  1182,   750,   751,   752,   753,   966,   992,  1565,
     878,   879,   234,   251,   966,  1002,   969,  1590,   500,   501,
     502,   503,   891,   506,   512,  1362,   516,   235,  1595,   518,
     246,  1600,   236,   969,  1676,   969,  1242,   969,   547,   970,
     342,   969,   476,  1000,   544,   545,   970,  -502,   549,   218,
    1145,  -519,   504,  -503,  1236,   967,  1622,   543,   544,   545,
     546,   547,  -493,   547,   543,   544,   545,   546,   547,   504,
     237,   549,   966,   549,  1545,  1236,   343,  1236,   549,  -508,
     345,   543,   544,   545,   546,   547,  -492,  -498,   863,   867,
    1503,  -896,   548,  1015,   965,   549,  -511,   965,   870,  1017,
     965,  1620,  1019,   965,   970,  -515,  1021,   873,  1237,   969,
    1023,   965,  1078,  1080,  1142,  1082,  1236,   967,   543,   544,
     545,   546,   547,   701,  1187,  1085,  1188,   547,   514,  1237,
     967,  1237,   549,  1189,   605,  1223,  1322,   549,  1087,   810,
     811,   959,  1223,   625,   959,   627,  1323,   959,  1089,  1091,
     959,  1093,  1095,   629,  1097,   631,   966,   525,   959,  1099,
    1370,   701,  1187,   340,  1194,   547,  1102,  1377,   954,  1104,
    1237,   969,  1621,  1106,  1108,   549,   997,   496,  1145,   967,
     347,   248,   520,  1117,   969,  1145,   967,   464,   970,   965,
    1119,  1121,  1130,   966,   966,   966,   966,   466,  1695,  1132,
     966,   701,  1187,   633,  1199,   547,   965,   966,   965,  1134,
     965,   635,   250,  1585,   965,   549,   348,  1136,  1138,  1358,
    -896,  1163,   957,   468,  1587,   970,   970,   970,   970,   454,
     527,   455,   970,   969,   701,  1187,   959,  1204,   547,   970,
     969,   498,   701,  1187,   967,  1209,   547,   454,   549,   455,
     522,   507,   637,   959,   504,   959,   549,   959,   659,   253,
     660,   959,   685,   531,   508,   528,   543,   544,   545,   546,
     547,   535,   537,   886,  1307,   532,   662,   548,   663,   665,
     549,   666,   965,   668,   671,   669,   672,   692,   807,   693,
     808,  1173,  1285,   539,  1174,  1286,   255,   454,   969,   455,
     511,   541,   610,  1677,   644,  1212,   646,   650,   653,  1532,
     763,   765,   767,   828,   687,   252,   858,   563,  1006,   565,
    1008,   689,  1010,  1012,  1288,   839,  1294,  1296,   967,   959,
    1298,   993,  1300,  1311,  1313,  1315,  1317,  1344,  1346,   843,
    1145,  1328,   845,   994,   965,   507,  1567,  1568,  1569,  1570,
    1000,   544,   545,   257,  1604,   259,  1222,   965,   508,   513,
     460,   517,   966,   966,   519,   967,   967,   967,   967,   238,
     567,   607,   967,   611,   613,  1145,  1145,  1145,  1145,   967,
     261,   615,   969,   617,   619,   621,   623,   639,   892,   893,
     641,   959,  1359,   647,   970,   970,   654,   966,   966,   966,
     966,  1330,   656,   239,   959,  1334,   965,   240,   673,   675,
     677,   679,   681,   965,   683,   694,   696,  1543,  1544,   969,
     969,   969,   969,   241,   698,   700,   969,   263,   705,   970,
     970,   970,   970,   969,   707,   713,   715,   717,   719,   721,
     723,   725,   727,   729,   731,   733,   735,   737,   739,   741,
     507,   743,   745,   959,   747,   754,   507,   756,   758,   966,
     959,   242,   499,   508,   265,   507,   760,   507,   768,   508,
     770,   965,   772,   243,   441,   507,   776,   507,   508,   778,
     508,   780,   782,   784,   786,   788,   790,   792,   508,  1324,
     508,   970,   267,   794,  1145,   993,   796,   798,   800,   802,
     804,   813,   815,   817,  1145,   819,   821,   994,  1145,  1145,
    1145,   269,   966,   823,   825,   966,   966,   521,   959,   829,
     831,   833,   847,   244,   849,   507,   966,   966,   966,   851,
     966,   966,   966,   507,   967,   967,   853,   855,   508,  1301,
    1303,  1331,   317,   318,   970,   271,   508,   970,   970,   500,
     501,   502,   503,  1347,   454,   965,   455,   319,   970,   970,
     970,   254,   970,   970,   970,   273,  1308,  1245,   275,   967,
     967,   967,   967,  1390,   507,  1391,   500,   501,   502,   503,
    1243,   320,   485,  1325,   507,   523,   277,   508,   969,   969,
     321,  1335,   965,   965,   965,   965,   279,   508,   256,   965,
     529,   281,   959,   322,   283,   285,   965,  1252,   287,   323,
     533,   289,  1686,   324,   291,  1213,  1214,  1215,   293,   295,
    1216,  1217,   297,   969,   969,   969,   969,  1392,  1605,  1393,
     299,   967,   301,  1348,   303,  1350,   507,  1352,   305,   959,
     959,   959,   959,   507,   307,   309,   959,   507,   311,   508,
    1376,   313,   564,   959,   566,   258,   508,   260,   315,   325,
     508,   507,   373,   375,   507,  1696,  1213,  1214,  1700,   377,
     326,  1216,  1217,   379,   508,   482,   490,   508,   428,   327,
    1701,  1702,   262,   569,   967,   969,   570,   967,   967,  1072,
    1074,  1076,   651,  1275,  1276,  1277,  1278,  1279,   967,   967,
     967,   328,   967,   967,   967,   568,   608,   329,   612,   614,
    1630,  1349,   454,   571,   455,  1115,   616,   576,   618,   620,
     622,   624,   640,  1127,  1128,   642,   577,   578,   648,   264,
     579,   655,   330,   500,   501,   502,   503,   657,   969,   580,
     859,   969,   969,   674,   676,   678,   680,   682,   581,   684,
     695,   697,   969,   969,   969,   331,   969,   969,   969,   699,
     701,   965,   965,   706,  1351,   454,   266,   455,   582,   708,
     714,   716,   718,   720,   722,   724,   726,   728,   730,   732,
     734,   736,   738,   740,   742,   504,   744,   746,   998,   748,
     755,   583,   757,   759,   268,   584,   965,   965,   965,   965,
     585,   761,  1394,   769,  1395,   771,   332,   773,   959,   959,
     586,   777,   504,   270,   779,   587,   781,   783,   785,   787,
     789,   791,   793,   588,  1623,  1226,  1228,  1230,   795,   333,
     334,   797,   799,   801,   803,   805,   814,   816,   818,   876,
     820,   822,   589,   959,   959,   959,   959,   272,   824,   826,
    1256,  1399,   335,  1400,   830,   832,   834,   848,   965,   850,
    1401,  1291,  1402,   336,   852,   337,  1403,   274,  1404,   590,
     276,   854,   856,   338,  1302,  1304,  1332,  1213,  1214,  1385,
     349,   350,  1216,  1217,  1246,  1247,  1248,  1249,   278,  1386,
    1213,  1214,  1215,   351,   352,  1216,  1217,  1408,   280,  1409,
    1396,   353,  1397,   282,   354,   959,   284,   286,   355,   591,
     288,   965,   356,   290,   965,   965,   292,  1213,  1214,  1215,
     294,   296,  1216,  1217,   298,   965,   965,   965,   357,   965,
     965,   965,   300,  1410,   302,  1411,   304,   358,  1616,  1356,
     306,  1412,  1441,  1413,   904,  1385,   308,   310,   976,   359,
     312,   978,   360,   314,   980,  1386,   361,   362,   959,   363,
     316,   959,   959,   364,   374,   376,  1405,   365,  1406,   504,
     366,   378,   959,   959,   959,   380,   959,   959,   959,   367,
     429,   543,   544,   545,   546,   547,  1417,  1196,  1418,  1201,
     883,  1206,   548,  1211,   368,   549,   369,   370,  1427,  1437,
    1440,  1146,  1147,  1148,  1149,  1150,  1151,  1152,  1153,  1154,
    1448,  1450,  1025,  1026,  1027,  1028,   371,  1030,  1419,  1032,
    1420,  1034,   372,  1458,  1385,   835,   836,   837,   838,  1460,
    1462,  1421,  1470,  1422,  1386,   381,  1473,  1475,  1477,  1479,
    1480,  1481,  1482,  1385,  1563,  1414,  1564,  1415,  1155,  1634,
     382,  1635,   592,  1386,  1484,  1486,  1488,  1490,  1492,  1494,
    1496,   383,  1636,   384,  1423,  1638,  1424,  1271,  1272,  1273,
    1274,  1275,  1276,  1277,  1278,  1279,  1673,  1257,  1258,  1259,
    1260,  1261,  1262,  1263,  1264,  1265,  1266,  1267,  1268,  1269,
    1270,  1271,  1272,  1273,  1274,  1275,  1276,  1277,  1278,  1279,
    1259,  1260,  1261,  1262,  1263,  1264,  1265,  1266,  1267,  1268,
    1269,  1270,  1271,  1272,  1273,  1274,  1275,  1276,  1277,  1278,
    1279,  1341,  1213,  1214,   385,   386,   387,  1216,  1217,   388,
     389,   390,  1558,  1257,  1258,  1259,  1260,  1261,  1262,  1263,
    1264,  1265,  1266,  1267,  1268,  1269,  1270,  1271,  1272,  1273,
    1274,  1275,  1276,  1277,  1278,  1279,  1261,  1262,  1263,  1264,
    1265,  1266,  1267,  1268,  1269,  1270,  1271,  1272,  1273,  1274,
    1275,  1276,  1277,  1278,  1279,  1452,  1257,  1258,  1259,  1260,
    1261,  1262,  1263,  1264,  1265,  1266,  1267,  1268,  1269,  1270,
    1271,  1272,  1273,  1274,  1275,  1276,  1277,  1278,  1279,  1262,
    1263,  1264,  1265,  1266,  1267,  1268,  1269,  1270,  1271,  1272,
    1273,  1274,  1275,  1276,  1277,  1278,  1279,   391,  1504,   392,
     393,   394,   395,  1469,  1257,  1258,  1259,  1260,  1261,  1262,
    1263,  1264,  1265,  1266,  1267,  1268,  1269,  1270,  1271,  1272,
    1273,  1274,  1275,  1276,  1277,  1278,  1279,  1263,  1264,  1265,
    1266,  1267,  1268,  1269,  1270,  1271,  1272,  1273,  1274,  1275,
    1276,  1277,  1278,  1279,   396,   397,  1612,  1257,  1258,  1259,
    1260,  1261,  1262,  1263,  1264,  1265,  1266,  1267,  1268,  1269,
    1270,  1271,  1272,  1273,  1274,  1275,  1276,  1277,  1278,  1279,
    1264,  1265,  1266,  1267,  1268,  1269,  1270,  1271,  1272,  1273,
    1274,  1275,  1276,  1277,  1278,  1279,   398,   399,   400,  1614,
     401,   402,   543,   544,   545,   546,   547,   403,   404,   405,
      -2,   470,  1628,   548,   406,   407,   549,   408,  1633,   409,
     410,   411,   412,   413,   -11,   -11,   -13,     2,     3,   -16,
     -18,   -20,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   430,   431,     4,   432,
     433,     5,     6,     7,     8,     9,   434,   435,   436,   437,
     438,   439,   440,   442,   443,   444,   445,    10,  1257,  1258,
    1259,  1260,  1261,  1262,  1263,  1264,  1265,  1266,  1267,  1268,
    1269,  1270,  1271,  1272,  1273,  1274,  1275,  1276,  1277,  1278,
    1279,   446,   447,   448,   449,  1628,   450,   451,   452,   865,
     868,   593,   594,  1558,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,   595,
     596,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,   597,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   598,   599,   600,
     601,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,   171,   172,   173,   174,   175,   176,   177,   602,   178,
     179,   603,   604,   709,   710,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   711,   712,
     812,   841,   842,   860,   861,   871,   874,   881,   884,   885,
     193,   194,   195,   547,   889,  1257,  1258,  1259,  1260,  1261,
    1262,  1263,  1264,  1265,  1266,  1267,  1268,  1269,  1270,  1271,
    1272,  1273,  1274,  1275,  1276,  1277,  1278,  1279,   890,   896,
     897,   898,   899,   900,   902,   982,   983,   196,   984,   988,
     989,   990,   991,  1004,  1013,   197,  1083,  1688,  1159,  1100,
    1161,  1139,   198,  -598,  -598,  -598,  -598,  -598,  -598,  -598,
    -598,  -598,  -598,  -598,  -598,  1109,  1110,  1111,  1112,  1113,
    1122,  1123,  -598,  -598,  -598,  -598,  -598,  -598,  -598,  -598,
    1164,  -598,  -598,  -598,  -598,  -598,  -598,  -598,  -598,  -598,
    -598,  1124,  -598,  1125,  1165,  1175,  -598,  1177,  -598,  -598,
    -598,  -598,  -598,  -598,  -598,  -598,  1167,  1169,  -598,  -598,
    -598,  1171,  1178,  1183,  -598,  -598,  -598,  -598,  -598,  -598,
    1139,  1180,  -566,  -566,  -566,  -566,  -566,  -566,  -566,  -566,
    -566,  -566,  -566,  -566,  1184,  1231,  1232,  1292,  1305,  1309,
    1318,  -566,  -566,  -566,  -566,  -566,  -566,  -566,  -566,  1319,
    -566,  -566,  -566,  -566,  -566,  -566,  -566,  -566,  -566,  -566,
    1320,  -566,  1337,  1338,  1339,  -566,  1340,  -566,  -566,  -566,
    -566,  -566,  -566,  -566,  -566,  1353,  1354,  -566,  -566,  -566,
    1355,  1363,  1364,  -566,  -566,  -566,  -566,  -566,  -566,  1222,
    1365,  -570,  -570,  -570,  -570,  -570,  -570,  -570,  -570,  -570,
    -570,  -570,  -570,  1366,  1367,  1368,  1371,  1373,  1374,  1378,
    -570,  -570,  -570,  -570,  -570,  -570,  -570,  -570,  1444,  -570,
    -570,  -570,  -570,  -570,  -570,  -570,  -570,  -570,  -570,  1389,
    -570,  1398,  1407,  1416,  -570,  1451,  -570,  -570,  -570,  -570,
    -570,  -570,  -570,  -570,  -669,  -670,  -570,  -570,  -570,  -681,
    -682,  1453,  -570,  -570,  -570,  -570,  -570,  -570,  1222,  1454,
    -587,  -587,  -587,  -587,  -587,  -587,  -587,  -587,  -587,  -587,
    -587,  -587,  1471,  1497,  1498,  1499,  1501,  1500,  1533,  -587,
    -587,  -587,  -587,  -587,  -587,  -587,  -587,  1539,  -587,  -587,
    -587,  -587,  -587,  -587,  -587,  -587,  -587,  -587,  1502,  -587,
    1505,  1506,  1507,  -587,  1508,  -587,  -587,  -587,  -587,  -587,
    -587,  -587,  -587,  1509,  1510,  -587,  -587,  -587,  1511,  1512,
    1513,  -587,  -587,  -587,  -587,  -587,  -587,  1514,  1515,  1516,
    1517,  1518,  1519,  1520,  1521,  1522,  1523,  1524,  -598,  1525,
    1526,  1527,  1528,  1529,  1530,  1531,  1534,  1535,  1536,  1537,
    1538,  1541,  1548,  1549,  -598,  -598,  -598,  -598,  -598,  -598,
    -598,  -598,  -598,  -598,  -598,  -598,  -598,  -598,  -598,  -598,
    -598,  -598,  -598,  -598,  -598,  -598,  -598,  1540,  1550,  1551,
    1552,  1553,  1554,  -598,  1555,  1556,  1557,  -598,  1155,  1566,
    1573,  -598,  -598,  1562,  -598,  -598,  -598,  -896,  -598,  1571,
    1572,  1575,  1576,  -598,  1577,  1578,  1582,  -566,  1583,  1588,
    1591,  1592,  1593,  1596,  1597,  1598,  1601,  1602,  1603,  1606,
    1607,  1608,  1610,  -566,  -566,  -566,  -566,  -566,  -566,  -566,
    -566,  -566,  -566,  -566,  -566,  -566,  -566,  -566,  -566,  -566,
    -566,  -566,  -566,  -566,  -566,  -566,  1609,  1611,  1613,  1615,
    1617,  1618,  1624,  1629,  1645,  1646,  -566,  1678,  1681,  1647,
    -566,  -566,  1682,  -566,  -566,  -566,  -896,  -566,  1648,  1649,
    1685,  1650,  -566,  1651,  1652,  1653,  -570,  1654,  1655,  1656,
    1657,  1658,  1659,  1660,  1661,  1662,  1663,  1664,  1665,  1666,
    1667,  1668,  -570,  -570,  -570,  -570,  -570,  -570,  -570,  -570,
    -570,  -570,  -570,  -570,  -570,  -570,  -570,  -570,  -570,  -570,
    -570,  -570,  -570,  -570,  -570,  1669,  1670,  1671,  1679,  1680,
    1687,  1690,  1691,  1692,   471,  -570,  1179,  1439,   901,  -570,
    -570,  1693,  -570,  -570,  -570,  1694,  -570,   903,  1697,  1698,
    1369,  -570,  1442,  1443,  1674,  -587,  1631,   996,   702,  1684,
    1561,   704,     0,     0,     0,  1689,   888,     0,     0,     0,
       0,  -587,  -587,  -587,  -587,  -587,  -587,  -587,  -587,  -587,
    -587,  -587,  -587,  -587,  -587,  -587,  -587,  -587,  -587,  -587,
    -587,  -587,  -587,  -587,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  -587,     0,     0,     0,  -587,  -587,
       1,  -587,  -587,  -587,     0,  -587,     0,     0,     0,     0,
    -587,     0,     0,   -11,   -11,   -13,     2,     3,   -16,   -18,
     -20,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     4,     0,     0,
       5,     6,     7,     8,     9,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    10,  1258,  1259,  1260,
    1261,  1262,  1263,  1264,  1265,  1266,  1267,  1268,  1269,  1270,
    1271,  1272,  1273,  1274,  1275,  1276,  1277,  1278,  1279,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,     0,     0,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,     0,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,     0,     0,     0,     0,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,   173,   174,   175,   176,   177,     0,   178,   179,
       0,     0,     0,     0,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   193,
     194,   195,  1260,  1261,  1262,  1263,  1264,  1265,  1266,  1267,
    1268,  1269,  1270,  1271,  1272,  1273,  1274,  1275,  1276,  1277,
    1278,  1279,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1463,   196,   905,   906,   907,
     908,   909,     0,     0,   197,     0,   914,   915,   916,     0,
       0,   198,     0,     0,     0,     0,   917,   918,   919,   920,
     921,   922,   923,   924,     0,   925,   926,   927,   928,   929,
     930,   931,   932,   933,   934,     0,   935,     0,     0,     0,
       0,     0,   937,   938,   939,   940,   941,   942,   943,     0,
       0,     0,     0,   946,   947,     0,     0,     0,   948,   949,
     950,   951,   952,   953,  1024,  1025,  1026,  1027,  1028,  1029,
    1030,  1031,  1032,  1033,  1034,  1035,  1036,  1037,  1038,  1039,
    1464,  1041,  1699,     0,   905,   906,   907,   908,   909,   910,
     911,   912,   913,   914,   915,   916,     0,     0,     0,     0,
       0,     0,     0,   917,   918,   919,   920,   921,   922,   923,
     924,     0,   925,   926,   927,   928,   929,   930,   931,   932,
     933,   934,     0,   935,     0,     0,     0,   936,     0,   937,
     938,   939,   940,   941,   942,   943,   944,  -630,  -630,   945,
     946,   947,     0,     0,     0,   948,   949,   950,   951,   952,
     953,  1143,     0,   905,   906,   907,   908,   909,   910,   911,
     912,   913,   914,   915,   916,     0,     0,     0,     0,     0,
       0,     0,   917,   918,   919,   920,   921,   922,   923,   924,
       0,   925,   926,   927,   928,   929,   930,   931,   932,   933,
     934,     0,   935,     0,     0,     0,   936,     0,   937,   938,
     939,   940,   941,   942,   943,   944,  -632,  -632,   945,   946,
     947,     0,     0,     0,   948,   949,   950,   951,   952,   953,
       0,  1143,     0,   905,   906,   907,   908,   909,   910,   911,
     912,   913,   914,   915,   916,     0,     0,     0,     0,     0,
       0,     0,   917,   918,   919,   920,   921,   922,   923,   924,
       0,   925,   926,   927,   928,   929,   930,   931,   932,   933,
     934,     0,   935,     0,     0,     0,   936,     0,   937,   938,
     939,   940,   941,   942,   943,   944,  -634,  -634,   945,   946,
     947,     0,   954,  1042,   948,   949,   950,   951,   952,   953,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1043,     0,     0,
       0,  1044,     0,  1045,  1046,  1047,  1048,     0,  1049,  1050,
    1465,  1466,     0,  1051,   547,   956,   957,     0,     0,     0,
       0,  1114,  1053,     0,   549,     0,     0,     0,     0,  1143,
       0,   905,   906,   907,   908,   909,   910,   911,   912,   913,
     914,   915,   916,     0,     0,     0,     0,     0,     0,   954,
     917,   918,   919,   920,   921,   922,   923,   924,     0,   925,
     926,   927,   928,   929,   930,   931,   932,   933,   934,     0,
     935,     0,     0,     0,   936,     0,   937,   938,   939,   940,
     941,   942,   943,   944,  -628,  -628,   945,   946,   947,     0,
       0,     0,   948,   949,   950,   951,   952,   953,   955,     0,
       0,     0,   956,   957,     0,     0,   958,     0,     0,     0,
    -630,     0,     0,     0,     0,     0,     0,     0,   954,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   955,     0,     0,
       0,   956,   957,     0,     0,   958,     0,     0,     0,  -632,
       0,     0,     0,     0,     0,     0,     0,     0,   954,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   955,     0,     0,
       0,   956,   957,     0,     0,   958,     0,     0,     0,  -634,
       0,     0,     0,     0,  1143,     0,   905,   906,   907,   908,
     909,   910,   911,   912,   913,   914,   915,   916,     0,     0,
       0,     0,     0,     0,     0,   917,   918,   919,   920,   921,
     922,   923,   924,     0,   925,   926,   927,   928,   929,   930,
     931,   932,   933,   934,     0,   935,     0,     0,     0,   936,
       0,   937,   938,   939,   940,   941,   942,   943,   944,  -635,
    -635,   945,   946,   947,     0,     0,   954,   948,   949,   950,
     951,   952,   953,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   955,     0,     0,     0,   956,
     957,     0,     0,   958,     0,     0,  1143,  -628,   905,   906,
     907,   908,   909,   910,   911,   912,   913,   914,   915,   916,
       0,     0,     0,     0,     0,     0,     0,   917,   918,   919,
     920,   921,   922,   923,   924,     0,   925,   926,   927,   928,
     929,   930,   931,   932,   933,   934,     0,   935,     0,     0,
       0,   936,     0,   937,   938,   939,   940,   941,   942,   943,
     944,  -629,  -629,   945,   946,   947,     0,     0,     0,   948,
     949,   950,   951,   952,   953,  1143,     0,   905,   906,   907,
     908,   909,   910,   911,   912,   913,   914,   915,   916,     0,
       0,     0,     0,     0,     0,     0,   917,   918,   919,   920,
     921,   922,   923,   924,     0,   925,   926,   927,   928,   929,
     930,   931,   932,   933,   934,     0,   935,     0,     0,     0,
     936,     0,   937,   938,   939,   940,   941,   942,   943,   944,
       0,     0,   945,   946,   947,     0,     0,     0,   948,   949,
     950,   951,   952,   953,     0,     0,     0,     0,     0,     0,
       0,  1143,     0,   905,   906,   907,   908,   909,   910,   911,
     912,   913,   914,   915,   916,     0,     0,     0,     0,     0,
       0,   954,   917,   918,   919,   920,   921,   922,   923,   924,
       0,   925,   926,   927,   928,   929,   930,   931,   932,   933,
     934,     0,   935,     0,     0,     0,   936,     0,   937,   938,
     939,   940,   941,   942,   943,   944,     0,     0,   945,   946,
     947,     0,     0,     0,   948,   949,   950,   951,   952,   953,
     955,     0,     0,     0,   956,   957,     0,     0,   958,     0,
       0,  1143,  -635,   905,   906,   907,   908,   909,   910,   911,
     912,   913,   914,   915,   916,     0,     0,     0,     0,     0,
       0,     0,   917,   918,   919,   920,   921,   922,   923,   924,
       0,   925,   926,   927,   928,   929,   930,   931,   932,   933,
     934,     0,   935,     0,     0,     0,   936,     0,   937,   938,
     939,   940,   941,   942,   943,   944,     0,     0,   945,   946,
     947,     0,     0,   954,   948,   949,   950,   951,   952,   953,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   955,     0,     0,     0,   956,   957,     0,     0,
     958,     0,     0,     0,  -629,     0,     0,     0,     0,     0,
       0,     0,   954,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   955,     0,     0,     0,   956,   957,     0,     0,   958,
       0,     0,     0,  1144,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   954,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   955,     0,     0,
       0,   956,   957,     0,     0,   958,     0,     0,  1143,  1166,
     905,   906,   907,   908,   909,   910,   911,   912,   913,   914,
     915,   916,     0,     0,     0,     0,     0,     0,   954,   917,
     918,   919,   920,   921,   922,   923,   924,     0,   925,   926,
     927,   928,   929,   930,   931,   932,   933,   934,     0,   935,
       0,     0,     0,   936,     0,   937,   938,   939,   940,   941,
     942,   943,   944,     0,     0,   945,   946,   947,     0,     0,
       0,   948,   949,   950,   951,   952,   953,   955,     0,     0,
       0,   956,   957,     0,     0,   958,     0,     0,  1143,  1168,
     905,   906,   907,   908,   909,   910,   911,   912,   913,   914,
     915,   916,     0,     0,     0,     0,     0,     0,     0,   917,
     918,   919,   920,   921,   922,   923,   924,     0,   925,   926,
     927,   928,   929,   930,   931,   932,   933,   934,     0,   935,
       0,     0,     0,   936,     0,   937,   938,   939,   940,   941,
     942,   943,   944,     0,     0,   945,   946,   947,     0,     0,
       0,   948,   949,   950,   951,   952,   953,  1143,     0,   905,
     906,   907,   908,   909,   910,   911,   912,   913,   914,   915,
     916,     0,     0,     0,     0,     0,     0,     0,   917,   918,
     919,   920,   921,   922,   923,   924,     0,   925,   926,   927,
     928,   929,   930,   931,   932,   933,   934,     0,   935,     0,
       0,     0,   936,     0,   937,   938,   939,   940,   941,   942,
     943,   944,     0,     0,   945,   946,   947,     0,     0,     0,
     948,   949,   950,   951,   952,   953,  1143,     0,   905,   906,
     907,   908,   909,   910,   911,   912,   913,   914,   915,   916,
       0,     0,     0,     0,     0,     0,     0,   917,   918,   919,
     920,   921,   922,   923,   924,     0,   925,   926,   927,   928,
     929,   930,   931,   932,   933,   934,     0,   935,     0,     0,
       0,   936,     0,   937,   938,   939,   940,   941,   942,   943,
     944,     0,     0,   945,   946,   947,     0,     0,     0,   948,
     949,   950,   951,   952,   953,   954,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   955,     0,     0,     0,   956,   957,
       0,     0,   958,     0,     0,  1143,  1170,   905,   906,   907,
     908,   909,   910,   911,   912,   913,   914,   915,   916,     0,
       0,     0,     0,     0,     0,   954,   917,   918,   919,   920,
     921,   922,   923,   924,     0,   925,   926,   927,   928,   929,
     930,   931,   932,   933,   934,     0,   935,     0,     0,     0,
     936,     0,   937,   938,   939,   940,   941,   942,   943,   944,
       0,     0,   945,   946,   947,     0,     0,     0,   948,   949,
     950,   951,   952,   953,   955,     0,     0,     0,   956,   957,
       0,     0,   958,     0,     0,     0,  1176,     0,     0,     0,
       0,     0,     0,     0,   954,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   955,     0,     0,     0,   956,   957,     0,
       0,   958,     0,     0,     0,  1455,     0,     0,     0,     0,
       0,     0,     0,   954,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   955,     0,     0,     0,   956,   957,     0,     0,
     958,     0,     0,  1143,  1574,   905,   906,   907,   908,   909,
     910,   911,   912,   913,   914,   915,   916,     0,     0,     0,
       0,     0,     0,     0,   917,   918,   919,   920,   921,   922,
     923,   924,     0,   925,   926,   927,   928,   929,   930,   931,
     932,   933,   934,     0,   935,     0,     0,     0,   936,     0,
     937,   938,   939,   940,   941,   942,   943,   944,     0,     0,
     945,   946,   947,     0,     0,     0,   948,   949,   950,   951,
     952,   953,   954,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   955,     0,     0,     0,   956,   957,     0,     0,   958,
       0,     0,  1143,  1579,   905,   906,   907,   908,   909,   910,
     911,   912,   913,   914,   915,   916,     0,     0,     0,     0,
       0,     0,     0,   917,   918,   919,   920,   921,   922,   923,
     924,     0,   925,   926,   927,   928,   929,   930,   931,   932,
     933,   934,     0,   935,     0,     0,     0,   936,     0,   937,
     938,   939,   940,   941,   942,   943,   944,     0,     0,   945,
     946,   947,     0,     0,     0,   948,   949,   950,   951,   952,
     953,  1143,     0,   905,   906,   907,   908,   909,   910,   911,
     912,   913,   914,   915,   916,     0,     0,     0,     0,     0,
       0,     0,   917,   918,   919,   920,   921,   922,   923,   924,
       0,   925,   926,   927,   928,   929,   930,   931,   932,   933,
     934,     0,   935,     0,     0,     0,   936,     0,   937,   938,
     939,   940,   941,   942,   943,   944,     0,     0,   945,   946,
     947,     0,     0,     0,   948,   949,   950,   951,   952,   953,
    1143,     0,   905,   906,   907,   908,   909,   910,   911,   912,
     913,   914,   915,   916,     0,     0,     0,     0,     0,     0,
     954,   917,   918,   919,   920,   921,   922,   923,   924,     0,
     925,   926,   927,   928,   929,   930,   931,   932,   933,   934,
       0,   935,     0,     0,     0,   936,     0,   937,   938,   939,
     940,   941,   942,   943,   944,     0,     0,   945,   946,   947,
       0,     0,     0,   948,   949,   950,   951,   952,   953,   955,
       0,     0,     0,   956,   957,     0,     0,   958,     0,     0,
    1143,  1619,   905,   906,   907,   908,   909,   910,   911,   912,
     913,   914,   915,   916,     0,     0,     0,     0,     0,     0,
       0,   917,   918,   919,   920,   921,   922,   923,   924,     0,
     925,   926,   927,   928,   929,   930,   931,   932,   933,   934,
       0,   935,     0,     0,     0,   936,     0,   937,   938,   939,
     940,   941,   942,   943,   944,     0,     0,   945,   946,   947,
       0,     0,     0,   948,   949,   950,   951,   952,   953,   954,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   955,     0,
       0,     0,   956,   957,     0,     0,   958,     0,     0,     0,
    1639,     0,     0,     0,     0,     0,     0,     0,   954,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   955,     0,     0,
       0,   956,   957,     0,     0,   958,     0,     0,     0,  1640,
       0,     0,     0,     0,     0,     0,     0,   954,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   955,     0,     0,     0,
     956,   957,     0,     0,   958,     0,     0,     0,  1641,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   954,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   955,     0,     0,     0,
     956,   957,     0,     0,   958,     0,     0,  1428,  1642,   905,
     906,   907,   908,   909,     0,     0,     0,     0,   914,   915,
     916,     0,     0,     0,     0,     0,     0,     0,   917,   918,
     919,   920,   921,   922,   923,   924,     0,   925,   926,   927,
     928,   929,   930,   931,   932,   933,   934,     0,   935,     0,
       0,     0,     0,     0,   937,   938,   939,   940,   941,   942,
     943,     0,     0,     0,     0,   946,   947,     0,     0,     0,
     948,   949,   950,   951,   952,   953,  1024,  1025,  1026,  1027,
    1028,  1029,  1030,  1031,  1032,  1033,  1034,  1035,  1036,  1037,
    1038,  1039,  1040,  1041,  1429,  1430,  1431,  1432,  1433,  1434,
    1438,     0,   905,   906,   907,   908,   909,     0,     0,     0,
       0,   914,   915,   916,     0,     0,     0,     0,     0,     0,
       0,   917,   918,   919,   920,   921,   922,   923,   924,     0,
     925,   926,   927,   928,   929,   930,   931,   932,   933,   934,
       0,   935,     0,     0,     0,     0,     0,   937,   938,   939,
     940,   941,   942,   943,     0,     0,     0,     0,   946,   947,
       0,     0,     0,   948,   949,   950,   951,   952,   953,  1024,
    1025,  1026,  1027,  1028,  1029,  1030,  1031,  1032,  1033,  1034,
    1035,  1036,  1037,  1038,  1039,  1040,  1041,  1429,  1430,  1431,
    1432,  1433,  1434,  1233,     0,   905,   906,   907,   908,   909,
       0,     0,     0,     0,   914,   915,   916,     0,     0,     0,
       0,     0,     0,     0,   917,   918,   919,   920,   921,   922,
     923,   924,     0,   925,   926,   927,   928,   929,   930,   931,
     932,   933,   934,     0,   935,     0,     0,     0,     0,     0,
     937,   938,   939,   940,   941,   942,   943,     0,     0,     0,
       0,   946,   947,     0,     0,     0,   948,   949,   950,   951,
     952,   953,  1024,  1025,  1026,  1027,  1028,  1029,  1030,  1031,
    1032,  1033,  1034,  1035,  1036,  1037,  1038,  1039,  1040,  1041,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   954,  1042,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1043,
    1435,     0,     0,  1044,     0,  1045,  1046,  1047,  1048,     0,
    1049,  1050,   508,   955,     0,  1051,     0,   956,   957,     0,
       0,     0,     0,  1114,  1053,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   954,  1042,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1043,  1435,     0,     0,  1044,     0,  1045,  1046,
    1047,  1048,     0,  1049,  1050,   508,   955,     0,  1051,     0,
     956,   957,     0,     0,     0,     0,  1114,  1053,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     954,  1042,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1043,     0,     0,     0,  1044,
       0,  1045,  1046,  1047,  1048,     0,  1049,  1050,   508,   955,
       0,  1051,     0,   956,   957,     0,     0,     0,  1234,  1114,
    1053,  1233,     0,   905,   906,   907,   908,   909,     0,     0,
       0,     0,   914,   915,   916,     0,     0,     0,     0,     0,
       0,     0,   917,   918,   919,   920,   921,   922,   923,   924,
       0,   925,   926,   927,   928,   929,   930,   931,   932,   933,
     934,     0,   935,     0,     0,     0,     0,     0,   937,   938,
     939,   940,   941,   942,   943,     0,     0,     0,     0,   946,
     947,     0,     0,     0,   948,   949,   950,   951,   952,   953,
    1024,  1025,  1026,  1027,  1028,  1029,  1030,  1031,  1032,  1033,
    1034,  1035,  1036,  1037,  1038,  1039,  1040,  1041,  1233,     0,
     905,   906,   907,   908,   909,     0,     0,     0,     0,   914,
     915,   916,     0,     0,     0,     0,     0,     0,     0,   917,
     918,   919,   920,   921,   922,   923,   924,     0,   925,   926,
     927,   928,   929,   930,   931,   932,   933,   934,     0,   935,
       0,     0,     0,     0,     0,   937,   938,   939,   940,   941,
     942,   943,     0,     0,     0,     0,   946,   947,     0,     0,
       0,   948,   949,   950,   951,   952,   953,  1024,  1025,  1026,
    1027,  1028,  1029,  1030,  1031,  1032,  1033,  1034,  1035,  1036,
    1037,  1038,  1039,  1040,  1041,  1625,     0,   905,   906,   907,
     908,   909,     0,     0,     0,     0,   914,   915,   916,     0,
       0,     0,     0,     0,     0,     0,   917,   918,   919,   920,
     921,   922,   923,   924,     0,   925,   926,   927,   928,   929,
     930,   931,   932,   933,   934,     0,   935,     0,     0,     0,
       0,     0,   937,   938,   939,   940,   941,   942,   943,     0,
       0,     0,     0,   946,   947,     0,     0,     0,   948,   949,
     950,   951,   952,   953,  1024,  1025,  1026,  1027,  1028,  1029,
    1030,  1031,  1032,  1033,  1034,  1035,  1036,  1037,  1038,  1039,
    1040,  1041,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   954,  1042,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1043,     0,     0,     0,  1044,     0,  1045,
    1046,  1047,  1048,     0,  1049,  1050,   508,   955,     0,  1051,
       0,   956,   957,     0,     0,     0,  1282,  1114,  1053,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   954,  1042,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1043,     0,     0,     0,  1044,     0,  1045,  1046,  1047,  1048,
       0,  1049,  1050,   508,   955,     0,  1051,     0,   956,   957,
       0,     0,     0,  1283,  1114,  1053,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   954,  1042,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1043,     0,  1626,
       0,  1044,     0,  1045,  1046,  1047,  1048,     0,  1049,  1050,
     508,   955,     0,  1051,     0,   956,   957,     0,     0,     0,
       0,  1114,  1053,  1126,     0,   905,   906,   907,   908,   909,
       0,     0,     0,     0,   914,   915,   916,     0,     0,     0,
       0,     0,     0,     0,   917,   918,   919,   920,   921,   922,
     923,   924,     0,   925,   926,   927,   928,   929,   930,   931,
     932,   933,   934,     0,   935,     0,     0,     0,     0,     0,
     937,   938,   939,   940,   941,   942,   943,     0,     0,     0,
       0,   946,   947,     0,     0,     0,   948,   949,   950,   951,
     952,   953,  1024,  1025,  1026,  1027,  1028,  1029,  1030,  1031,
    1032,  1033,  1034,  1035,  1036,  1037,  1038,  1039,  1040,  1041,
    1225,     0,   905,   906,   907,   908,   909,     0,     0,     0,
       0,   914,   915,   916,     0,     0,     0,     0,     0,     0,
       0,   917,   918,   919,   920,   921,   922,   923,   924,     0,
     925,   926,   927,   928,   929,   930,   931,   932,   933,   934,
       0,   935,     0,     0,     0,     0,     0,   937,   938,   939,
     940,   941,   942,   943,     0,     0,     0,     0,   946,   947,
       0,     0,     0,   948,   949,   950,   951,   952,   953,  1024,
    1025,  1026,  1027,  1028,  1029,  1030,  1031,  1032,  1033,  1034,
    1035,  1036,  1037,  1038,  1039,  1040,  1041,  1227,     0,   905,
     906,   907,   908,   909,     0,     0,     0,     0,   914,   915,
     916,     0,     0,     0,     0,     0,     0,     0,   917,   918,
     919,   920,   921,   922,   923,   924,     0,   925,   926,   927,
     928,   929,   930,   931,   932,   933,   934,     0,   935,     0,
       0,     0,     0,     0,   937,   938,   939,   940,   941,   942,
     943,     0,     0,     0,     0,   946,   947,     0,     0,     0,
     948,   949,   950,   951,   952,   953,  1024,  1025,  1026,  1027,
    1028,  1029,  1030,  1031,  1032,  1033,  1034,  1035,  1036,  1037,
    1038,  1039,  1040,  1041,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     954,  1042,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1043,     0,     0,     0,  1044,
       0,  1045,  1046,  1047,  1048,     0,  1049,  1050,   508,   955,
       0,  1051,     0,   956,   957,     0,     0,     0,     0,  1114,
    1053,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   954,  1042,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1043,     0,     0,     0,  1044,     0,  1045,  1046,
    1047,  1048,     0,  1049,  1050,   508,   955,     0,  1051,     0,
     956,   957,     0,     0,     0,     0,  1114,  1053,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   954,  1042,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1043,
       0,     0,     0,  1044,     0,  1045,  1046,  1047,  1048,     0,
    1049,  1050,   508,   955,     0,  1051,     0,   956,   957,     0,
       0,     0,     0,  1114,  1053,  1229,     0,   905,   906,   907,
     908,   909,     0,     0,     0,     0,   914,   915,   916,     0,
       0,     0,     0,     0,     0,     0,   917,   918,   919,   920,
     921,   922,   923,   924,     0,   925,   926,   927,   928,   929,
     930,   931,   932,   933,   934,     0,   935,     0,     0,     0,
       0,     0,   937,   938,   939,   940,   941,   942,   943,     0,
       0,     0,     0,   946,   947,     0,     0,     0,   948,   949,
     950,   951,   952,   953,  1024,  1025,  1026,  1027,  1028,  1029,
    1030,  1031,  1032,  1033,  1034,  1035,  1036,  1037,  1038,  1039,
    1040,  1041,  1255,     0,   905,   906,   907,   908,   909,     0,
       0,     0,     0,   914,   915,   916,     0,     0,     0,     0,
       0,     0,     0,   917,   918,   919,   920,   921,   922,   923,
     924,     0,   925,   926,   927,   928,   929,   930,   931,   932,
     933,   934,     0,   935,     0,     0,     0,     0,     0,   937,
     938,   939,   940,   941,   942,   943,     0,     0,     0,     0,
     946,   947,     0,     0,     0,   948,   949,   950,   951,   952,
     953,  1024,  1025,  1026,  1027,  1028,  1029,  1030,  1031,  1032,
    1033,  1034,  1035,  1036,  1037,  1038,  1039,  1040,  1041,  1289,
       0,   905,   906,   907,   908,   909,     0,     0,     0,     0,
     914,   915,   916,     0,     0,     0,     0,     0,     0,     0,
     917,   918,   919,   920,   921,   922,   923,   924,     0,   925,
     926,   927,   928,   929,   930,   931,   932,   933,   934,     0,
     935,     0,     0,     0,     0,     0,   937,   938,   939,   940,
     941,   942,   943,     0,     0,     0,     0,   946,   947,     0,
       0,     0,   948,   949,   950,   951,   952,   953,  1024,  1025,
    1026,  1027,  1028,  1029,  1030,  1031,  1032,  1033,  1034,  1035,
    1036,  1037,  1038,  1039,  1040,  1041,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   954,  1042,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1043,     0,     0,
       0,  1044,     0,  1045,  1046,  1047,  1048,     0,  1049,  1050,
     508,   955,     0,  1051,     0,   956,   957,     0,     0,     0,
       0,  1114,  1053,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   954,
    1042,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1043,     0,     0,     0,  1044,     0,
    1045,  1046,  1047,  1048,     0,  1049,  1050,   508,   955,     0,
    1051,     0,   956,   957,     0,     0,     0,     0,  1114,  1053,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   954,  1042,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1043,     0,     0,     0,  1044,     0,  1045,  1046,  1047,
    1048,     0,  1049,  1050,   508,  1290,     0,  1051,     0,   956,
     957,     0,     0,     0,     0,  1114,  1053,  1233,     0,   905,
     906,   907,   908,   909,     0,     0,     0,     0,   914,   915,
     916,     0,     0,     0,     0,     0,     0,     0,   917,   918,
     919,   920,   921,   922,   923,   924,     0,   925,   926,   927,
     928,   929,   930,   931,   932,   933,   934,     0,   935,     0,
       0,     0,     0,     0,   937,   938,   939,   940,   941,   942,
     943,     0,     0,     0,     0,   946,   947,     0,     0,     0,
     948,   949,   950,   951,   952,   953,  1024,  1025,  1026,  1027,
    1028,  1029,  1030,  1031,  1032,  1033,  1034,  1035,  1036,  1037,
    1038,  1039,  1040,  1041,  1425,     0,   905,   906,   907,   908,
     909,     0,     0,     0,     0,   914,   915,   916,     0,     0,
       0,     0,     0,     0,     0,   917,   918,   919,   920,   921,
     922,   923,   924,     0,   925,   926,   927,   928,   929,   930,
     931,   932,   933,   934,     0,   935,     0,     0,     0,     0,
       0,   937,   938,   939,   940,   941,   942,   943,     0,     0,
       0,     0,   946,   947,     0,     0,     0,   948,   949,   950,
     951,   952,   953,  1024,  1025,  1026,  1027,  1028,  1029,  1030,
    1031,  1032,  1033,  1034,  1035,  1036,  1037,  1038,  1039,  1040,
    1041,  1447,     0,   905,   906,   907,   908,   909,     0,     0,
       0,     0,   914,   915,   916,     0,     0,     0,     0,     0,
       0,     0,   917,   918,   919,   920,   921,   922,   923,   924,
       0,   925,   926,   927,   928,   929,   930,   931,   932,   933,
     934,     0,   935,     0,     0,     0,     0,     0,   937,   938,
     939,   940,   941,   942,   943,     0,     0,     0,     0,   946,
     947,     0,     0,     0,   948,   949,   950,   951,   952,   953,
    1024,  1025,  1026,  1027,  1028,  1029,  1030,  1031,  1032,  1033,
    1034,  1035,  1036,  1037,  1038,  1039,  1040,  1041,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   954,  1042,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1043,
       0,     0,     0,  1044,     0,  1045,  1046,  1047,  1048,     0,
    1049,  1050,   508,   955,     0,  1051,     0,   956,   957,     0,
       0,     0,     0,  1114,  1053,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   954,  1042,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1043,     0,     0,     0,
    1044,     0,  1045,  1046,  1047,  1048,     0,  1049,  1050,   508,
    1426,     0,  1051,     0,   956,   957,     0,     0,     0,     0,
    1114,  1053,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   954,  1042,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1043,     0,     0,     0,  1044,     0,  1045,
    1046,  1047,  1048,     0,  1049,  1050,   508,   955,     0,  1051,
       0,   956,   957,     0,     0,     0,     0,  1114,  1053,  1449,
       0,   905,   906,   907,   908,   909,     0,     0,     0,     0,
     914,   915,   916,     0,     0,     0,     0,     0,     0,     0,
     917,   918,   919,   920,   921,   922,   923,   924,     0,   925,
     926,   927,   928,   929,   930,   931,   932,   933,   934,     0,
     935,     0,     0,     0,     0,     0,   937,   938,   939,   940,
     941,   942,   943,     0,     0,     0,     0,   946,   947,     0,
       0,     0,   948,   949,   950,   951,   952,   953,  1024,  1025,
    1026,  1027,  1028,  1029,  1030,  1031,  1032,  1033,  1034,  1035,
    1036,  1037,  1038,  1039,  1040,  1041,  1456,     0,   905,   906,
     907,   908,   909,     0,     0,     0,     0,   914,   915,   916,
       0,     0,     0,     0,     0,     0,     0,   917,   918,   919,
     920,   921,   922,   923,   924,     0,   925,   926,   927,   928,
     929,   930,   931,   932,   933,   934,     0,   935,     0,     0,
       0,     0,     0,   937,   938,   939,   940,   941,   942,   943,
       0,     0,     0,     0,   946,   947,     0,     0,     0,   948,
     949,   950,   951,   952,   953,  1024,  1025,  1026,  1027,  1028,
    1029,  1030,  1031,  1032,  1033,  1034,  1035,  1036,  1037,  1038,
    1039,  1457,  1041,  1459,     0,   905,   906,   907,   908,   909,
       0,     0,     0,     0,   914,   915,   916,     0,     0,     0,
       0,     0,     0,     0,   917,   918,   919,   920,   921,   922,
     923,   924,     0,   925,   926,   927,   928,   929,   930,   931,
     932,   933,   934,     0,   935,     0,     0,     0,     0,     0,
     937,   938,   939,   940,   941,   942,   943,     0,     0,     0,
       0,   946,   947,     0,     0,     0,   948,   949,   950,   951,
     952,   953,  1024,  1025,  1026,  1027,  1028,  1029,  1030,  1031,
    1032,  1033,  1034,  1035,  1036,  1037,  1038,  1039,  1040,  1041,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   954,  1042,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1043,     0,     0,     0,  1044,     0,  1045,  1046,  1047,
    1048,     0,  1049,  1050,   508,   955,     0,  1051,     0,   956,
     957,     0,     0,     0,     0,  1114,  1053,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   954,  1042,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1043,     0,
       0,     0,  1044,     0,  1045,  1046,  1047,  1048,     0,  1049,
    1050,   508,   955,     0,  1051,     0,   956,   957,     0,     0,
       0,     0,  1114,  1053,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     954,  1042,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1043,     0,     0,     0,  1044,
       0,  1045,  1046,  1047,  1048,     0,  1049,  1050,   508,   955,
       0,  1051,     0,   956,   957,     0,     0,     0,     0,  1114,
    1053,  1461,     0,   905,   906,   907,   908,   909,     0,     0,
       0,     0,   914,   915,   916,     0,     0,     0,     0,     0,
       0,     0,   917,   918,   919,   920,   921,   922,   923,   924,
       0,   925,   926,   927,   928,   929,   930,   931,   932,   933,
     934,     0,   935,     0,     0,     0,     0,     0,   937,   938,
     939,   940,   941,   942,   943,     0,     0,     0,     0,   946,
     947,     0,     0,     0,   948,   949,   950,   951,   952,   953,
    1024,  1025,  1026,  1027,  1028,  1029,  1030,  1031,  1032,  1033,
    1034,  1035,  1036,  1037,  1038,  1039,  1040,  1041,  1472,     0,
     905,   906,   907,   908,   909,     0,     0,     0,     0,   914,
     915,   916,     0,     0,     0,     0,     0,     0,     0,   917,
     918,   919,   920,   921,   922,   923,   924,     0,   925,   926,
     927,   928,   929,   930,   931,   932,   933,   934,     0,   935,
       0,     0,     0,     0,     0,   937,   938,   939,   940,   941,
     942,   943,     0,     0,     0,     0,   946,   947,     0,     0,
       0,   948,   949,   950,   951,   952,   953,  1024,  1025,  1026,
    1027,  1028,  1029,  1030,  1031,  1032,  1033,  1034,  1035,  1036,
    1037,  1038,  1039,  1040,  1041,  1474,     0,   905,   906,   907,
     908,   909,     0,     0,     0,     0,   914,   915,   916,     0,
       0,     0,     0,     0,     0,     0,   917,   918,   919,   920,
     921,   922,   923,   924,     0,   925,   926,   927,   928,   929,
     930,   931,   932,   933,   934,     0,   935,     0,     0,     0,
       0,     0,   937,   938,   939,   940,   941,   942,   943,     0,
       0,     0,     0,   946,   947,     0,     0,     0,   948,   949,
     950,   951,   952,   953,  1024,  1025,  1026,  1027,  1028,  1029,
    1030,  1031,  1032,  1033,  1034,  1035,  1036,  1037,  1038,  1039,
    1040,  1041,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   954,  1042,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1043,     0,     0,     0,  1044,     0,  1045,
    1046,  1047,  1048,     0,  1049,  1050,   508,   955,     0,  1051,
       0,   956,   957,     0,     0,     0,     0,  1114,  1053,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   954,  1042,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1043,     0,     0,     0,  1044,     0,  1045,  1046,  1047,  1048,
       0,  1049,  1050,   508,   955,     0,  1051,     0,   956,   957,
       0,     0,     0,     0,  1114,  1053,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   954,  1042,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1043,     0,     0,
       0,  1044,     0,  1045,  1046,  1047,  1048,     0,  1049,  1050,
     508,   955,     0,  1051,     0,   956,   957,     0,     0,     0,
       0,  1114,  1053,  1476,     0,   905,   906,   907,   908,   909,
       0,     0,     0,     0,   914,   915,   916,     0,     0,     0,
       0,     0,     0,     0,   917,   918,   919,   920,   921,   922,
     923,   924,     0,   925,   926,   927,   928,   929,   930,   931,
     932,   933,   934,     0,   935,     0,     0,     0,     0,     0,
     937,   938,   939,   940,   941,   942,   943,     0,     0,     0,
       0,   946,   947,     0,     0,     0,   948,   949,   950,   951,
     952,   953,  1024,  1025,  1026,  1027,  1028,  1029,  1030,  1031,
    1032,  1033,  1034,  1035,  1036,  1037,  1038,  1039,  1040,  1041,
    1478,     0,   905,   906,   907,   908,   909,     0,     0,     0,
       0,   914,   915,   916,     0,     0,     0,     0,     0,     0,
       0,   917,   918,   919,   920,   921,   922,   923,   924,     0,
     925,   926,   927,   928,   929,   930,   931,   932,   933,   934,
       0,   935,     0,     0,     0,     0,     0,   937,   938,   939,
     940,   941,   942,   943,     0,     0,     0,     0,   946,   947,
       0,     0,     0,   948,   949,   950,   951,   952,   953,  1024,
    1025,  1026,  1027,  1028,  1029,  1030,  1031,  1032,  1033,  1034,
    1035,  1036,  1037,  1038,  1039,  1040,  1041,  1483,     0,   905,
     906,   907,   908,   909,     0,     0,     0,     0,   914,   915,
     916,     0,     0,     0,     0,     0,     0,     0,   917,   918,
     919,   920,   921,   922,   923,   924,     0,   925,   926,   927,
     928,   929,   930,   931,   932,   933,   934,     0,   935,     0,
       0,     0,     0,     0,   937,   938,   939,   940,   941,   942,
     943,     0,     0,     0,     0,   946,   947,     0,     0,     0,
     948,   949,   950,   951,   952,   953,  1024,  1025,  1026,  1027,
    1028,  1029,  1030,  1031,  1032,  1033,  1034,  1035,  1036,  1037,
    1038,  1039,  1040,  1041,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     954,  1042,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1043,     0,     0,     0,  1044,
       0,  1045,  1046,  1047,  1048,     0,  1049,  1050,   508,   955,
       0,  1051,     0,   956,   957,     0,     0,     0,     0,  1114,
    1053,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   954,  1042,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1043,     0,     0,     0,  1044,     0,  1045,  1046,
    1047,  1048,     0,  1049,  1050,   508,   955,     0,  1051,     0,
     956,   957,     0,     0,     0,     0,  1114,  1053,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   954,  1042,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1043,
       0,     0,     0,  1044,     0,  1045,  1046,  1047,  1048,     0,
    1049,  1050,   508,   955,     0,  1051,     0,   956,   957,     0,
       0,     0,     0,  1114,  1053,  1485,     0,   905,   906,   907,
     908,   909,     0,     0,     0,     0,   914,   915,   916,     0,
       0,     0,     0,     0,     0,     0,   917,   918,   919,   920,
     921,   922,   923,   924,     0,   925,   926,   927,   928,   929,
     930,   931,   932,   933,   934,     0,   935,     0,     0,     0,
       0,     0,   937,   938,   939,   940,   941,   942,   943,     0,
       0,     0,     0,   946,   947,     0,     0,     0,   948,   949,
     950,   951,   952,   953,  1024,  1025,  1026,  1027,  1028,  1029,
    1030,  1031,  1032,  1033,  1034,  1035,  1036,  1037,  1038,  1039,
    1040,  1041,  1487,     0,   905,   906,   907,   908,   909,     0,
       0,     0,     0,   914,   915,   916,     0,     0,     0,     0,
       0,     0,     0,   917,   918,   919,   920,   921,   922,   923,
     924,     0,   925,   926,   927,   928,   929,   930,   931,   932,
     933,   934,     0,   935,     0,     0,     0,     0,     0,   937,
     938,   939,   940,   941,   942,   943,     0,     0,     0,     0,
     946,   947,     0,     0,     0,   948,   949,   950,   951,   952,
     953,  1024,  1025,  1026,  1027,  1028,  1029,  1030,  1031,  1032,
    1033,  1034,  1035,  1036,  1037,  1038,  1039,  1040,  1041,  1489,
       0,   905,   906,   907,   908,   909,     0,     0,     0,     0,
     914,   915,   916,     0,     0,     0,     0,     0,     0,     0,
     917,   918,   919,   920,   921,   922,   923,   924,     0,   925,
     926,   927,   928,   929,   930,   931,   932,   933,   934,     0,
     935,     0,     0,     0,     0,     0,   937,   938,   939,   940,
     941,   942,   943,     0,     0,     0,     0,   946,   947,     0,
       0,     0,   948,   949,   950,   951,   952,   953,  1024,  1025,
    1026,  1027,  1028,  1029,  1030,  1031,  1032,  1033,  1034,  1035,
    1036,  1037,  1038,  1039,  1040,  1041,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   954,  1042,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1043,     0,     0,
       0,  1044,     0,  1045,  1046,  1047,  1048,     0,  1049,  1050,
     508,   955,     0,  1051,     0,   956,   957,     0,     0,     0,
       0,  1114,  1053,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   954,
    1042,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1043,     0,     0,     0,  1044,     0,
    1045,  1046,  1047,  1048,     0,  1049,  1050,   508,   955,     0,
    1051,     0,   956,   957,     0,     0,     0,     0,  1114,  1053,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   954,  1042,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1043,     0,     0,     0,  1044,     0,  1045,  1046,  1047,
    1048,     0,  1049,  1050,   508,   955,     0,  1051,     0,   956,
     957,     0,     0,     0,     0,  1114,  1053,  1491,     0,   905,
     906,   907,   908,   909,     0,     0,     0,     0,   914,   915,
     916,     0,     0,     0,     0,     0,     0,     0,   917,   918,
     919,   920,   921,   922,   923,   924,     0,   925,   926,   927,
     928,   929,   930,   931,   932,   933,   934,     0,   935,     0,
       0,     0,     0,     0,   937,   938,   939,   940,   941,   942,
     943,     0,     0,     0,     0,   946,   947,     0,     0,     0,
     948,   949,   950,   951,   952,   953,  1024,  1025,  1026,  1027,
    1028,  1029,  1030,  1031,  1032,  1033,  1034,  1035,  1036,  1037,
    1038,  1039,  1040,  1041,  1493,     0,   905,   906,   907,   908,
     909,     0,     0,     0,     0,   914,   915,   916,     0,     0,
       0,     0,     0,     0,     0,   917,   918,   919,   920,   921,
     922,   923,   924,     0,   925,   926,   927,   928,   929,   930,
     931,   932,   933,   934,     0,   935,     0,     0,     0,     0,
       0,   937,   938,   939,   940,   941,   942,   943,     0,     0,
       0,     0,   946,   947,     0,     0,     0,   948,   949,   950,
     951,   952,   953,  1024,  1025,  1026,  1027,  1028,  1029,  1030,
    1031,  1032,  1033,  1034,  1035,  1036,  1037,  1038,  1039,  1040,
    1041,  1495,     0,   905,   906,   907,   908,   909,     0,     0,
       0,     0,   914,   915,   916,     0,     0,     0,     0,     0,
       0,     0,   917,   918,   919,   920,   921,   922,   923,   924,
       0,   925,   926,   927,   928,   929,   930,   931,   932,   933,
     934,     0,   935,     0,     0,     0,     0,     0,   937,   938,
     939,   940,   941,   942,   943,     0,     0,     0,     0,   946,
     947,     0,     0,     0,   948,   949,   950,   951,   952,   953,
    1024,  1025,  1026,  1027,  1028,  1029,  1030,  1031,  1032,  1033,
    1034,  1035,  1036,  1037,  1038,  1039,  1040,  1041,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   954,  1042,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1043,
       0,     0,     0,  1044,     0,  1045,  1046,  1047,  1048,     0,
    1049,  1050,   508,   955,     0,  1051,     0,   956,   957,     0,
       0,     0,     0,  1114,  1053,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   954,  1042,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1043,     0,     0,     0,
    1044,     0,  1045,  1046,  1047,  1048,     0,  1049,  1050,   508,
     955,     0,  1051,     0,   956,   957,     0,     0,     0,     0,
    1114,  1053,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   954,  1042,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1043,     0,     0,     0,  1044,     0,  1045,
    1046,  1047,  1048,     0,  1049,  1050,   508,   955,     0,  1051,
       0,   956,   957,     0,     0,     0,     0,  1114,  1053,  1683,
       0,   905,   906,   907,   908,   909,     0,     0,     0,     0,
     914,   915,   916,     0,     0,     0,     0,     0,     0,     0,
     917,   918,   919,   920,   921,   922,   923,   924,     0,   925,
     926,   927,   928,   929,   930,   931,   932,   933,   934,     0,
     935,     0,     0,     0,     0,     0,   937,   938,   939,   940,
     941,   942,   943,     0,     0,     0,     0,   946,   947,     0,
       0,     0,   948,   949,   950,   951,   952,   953,  1024,  1025,
    1026,  1027,  1028,  1029,  1030,  1031,  1032,  1033,  1034,  1035,
    1036,  1037,  1038,  1039,  1040,  1041,   905,   906,   907,   908,
     909,   910,   911,   912,   913,   914,   915,   916,     0,     0,
       0,     0,     0,     0,     0,   917,   918,   919,   920,   921,
     922,   923,   924,     0,   925,   926,   927,   928,   929,   930,
     931,   932,   933,   934,     0,   935,     0,     0,     0,   936,
       0,   937,   938,   939,   940,   941,   942,   943,   944,     0,
       0,   945,   946,   947,     0,     0,     0,   948,   949,   950,
     951,   952,   953,   905,   906,   907,   908,   909,     0,     0,
       0,     0,   914,   915,   916,     0,     0,     0,     0,     0,
       0,     0,   917,   918,   919,   920,   921,   922,   923,   924,
       0,   925,   926,   927,   928,   929,   930,   931,   932,   933,
     934,     0,   935,     0,     0,     0,     0,     0,   937,   938,
     939,   940,   941,   942,   943,     0,     0,     0,     0,   946,
     947,     0,     0,     0,   948,   949,   950,   951,   952,   953,
    1024,  1025,  1026,  1027,  1028,  1029,  1030,  1031,  1032,  1033,
    1034,  1035,  1036,  1037,  1038,  1039,  1040,  1041,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   954,  1042,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1043,     0,     0,     0,  1044,     0,  1045,  1046,  1047,
    1048,     0,  1049,  1050,   508,   955,     0,  1051,     0,   956,
     957,     0,     0,     0,     0,  1114,  1053,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   954,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1257,  1258,  1259,
    1260,  1261,  1262,  1263,  1264,  1265,  1266,  1267,  1268,  1269,
    1270,  1271,  1272,  1273,  1274,  1275,  1276,  1277,  1278,  1279,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     955,     0,     0,     0,   956,   957,     0,     0,   958,     0,
       0,  1326,     0,     0,     0,     0,     0,     0,   954,  1042,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1043,     0,     0,     0,  1044,     0,  1045,
    1046,  1047,  1048,     0,  1049,  1050,   508,   955,     0,  1051,
       0,   956,   957,     0,     0,     0,     0,  1052,  1053,   905,
     906,   907,   908,   909,     0,     0,     0,     0,   914,   915,
     916,     0,     0,     0,     0,     0,     0,     0,   917,   918,
     919,   920,   921,   922,   923,   924,     0,   925,   926,   927,
     928,   929,   930,   931,   932,   933,   934,     0,   935,     0,
       0,     0,     0,     0,   937,   938,   939,   940,   941,   942,
     943,     0,     0,     0,     0,   946,   947,     0,     0,     0,
     948,   949,   950,   951,   952,   953,  1024,  1025,  1026,  1027,
    1028,  1029,  1030,  1031,  1032,  1033,  1034,  1035,  1036,  1037,
    1038,  1039,  1040,  1041,   905,   906,   907,   908,   909,     0,
       0,     0,     0,   914,   915,   916,     0,     0,     0,     0,
       0,     0,     0,   917,   918,   919,   920,   921,   922,   923,
     924,     0,   925,   926,   927,   928,   929,   930,   931,   932,
     933,   934,     0,   935,     0,     0,     0,     0,     0,   937,
     938,   939,   940,   941,   942,   943,     0,     0,     0,     0,
     946,   947,     0,     0,     0,   948,   949,   950,   951,   952,
     953,  1024,  1025,  1026,  1027,  1028,  1029,  1030,  1031,  1032,
    1033,  1034,  1035,  1036,  1037,  1038,  1039,  1040,  1041,   905,
     906,   907,   908,   909,     0,     0,     0,     0,   914,   915,
     916,     0,     0,     0,     0,     0,     0,     0,   917,   918,
     919,   920,   921,   922,   923,   924,     0,   925,   926,   927,
     928,   929,   930,   931,   932,   933,   934,     0,   935,     0,
       0,     0,     0,     0,   937,   938,   939,   940,   941,   942,
     943,     0,     0,     0,     0,   946,   947,     0,     0,     0,
     948,   949,   950,   951,   952,   953,  1024,  1025,  1026,  1027,
    1028,  1029,  1030,  1031,  1032,  1033,  1034,  1035,  1036,  1037,
    1038,  1039,  1040,  1041,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   954,  1042,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1043,
       0,     0,     0,  1044,     0,  1045,  1046,  1047,  1048,     0,
    1049,  1050,   508,   955,     0,  1051,     0,   956,   957,     0,
       0,     0,     0,  1073,  1053,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   954,
    1042,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1043,     0,     0,     0,  1044,     0,
    1045,  1046,  1047,  1048,     0,  1049,  1050,   508,   955,     0,
    1051,     0,   956,   957,     0,     0,     0,     0,  1075,  1053,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   954,  1042,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1043,
       0,     0,     0,  1044,     0,  1045,  1046,  1047,  1048,     0,
    1049,  1050,   508,   955,     0,  1051,     0,   956,   957,     0,
       0,     0,     0,  1114,  1053,   905,   906,   907,   908,   909,
       0,     0,     0,     0,   914,   915,   916,     0,     0,     0,
       0,     0,     0,     0,   917,   918,   919,   920,   921,   922,
     923,   924,     0,   925,   926,   927,   928,   929,   930,   931,
     932,   933,   934,     0,   935,     0,     0,     0,     0,     0,
     937,   938,   939,   940,   941,   942,   943,     0,     0,     0,
       0,   946,   947,     0,     0,     0,   948,   949,   950,   951,
     952,   953,  1024,  1025,  1026,  1027,  1028,  1029,  1030,  1031,
    1032,  1033,  1034,  1035,  1036,  1037,  1038,  1039,  1040,  1041,
     905,   906,   907,   908,   909,   910,   911,   912,   913,   914,
     915,   916,     0,     0,     0,     0,     0,     0,     0,   917,
     918,   919,   920,   921,   922,   923,   924,     0,   925,   926,
     927,   928,   929,   930,   931,   932,   933,   934,     0,   935,
       0,     0,     0,   936,     0,   937,   938,   939,   940,   941,
     942,   943,   944,     0,     0,   945,   946,   947,     0,     0,
       0,   948,   949,   950,   951,   952,   953,  1241,     0,   905,
     906,   907,   908,   909,   910,   911,   912,   913,   914,   915,
     916,     0,     0,     0,     0,     0,     0,     0,   917,   918,
     919,   920,   921,   922,   923,   924,     0,   925,   926,   927,
     928,   929,   930,   931,   932,   933,   934,     0,   935,     0,
       0,     0,   936,     0,   937,   938,   939,   940,   941,   942,
     943,   944,     0,     0,   945,   946,   947,     0,     0,     0,
     948,   949,   950,   951,   952,   953,     0,     0,     0,     0,
       0,   905,   906,   907,   908,   909,   910,   911,   912,   913,
     914,   915,   916,     0,     0,     0,     0,     0,     0,     0,
     917,   918,   919,   920,   921,   922,   923,   924,     0,   925,
     926,   927,   928,   929,   930,   931,   932,   933,   934,     0,
     935,     0,     0,     0,   936,     0,   937,   938,   939,   940,
     941,   942,   943,   944,     0,     0,   945,   946,   947,     0,
     954,  1042,   948,   949,   950,   951,   952,   953,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1043,     0,     0,     0,  1044,
       0,  1045,  1046,  1047,  1048,     0,  1049,  1050,  1632,   955,
       0,  1051,     0,   956,   957,     0,     0,     0,     0,  1114,
    1053,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   954,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   955,     0,     0,     0,   956,   957,
       0,     0,   958,     0,     0,  1326,     0,     0,     0,     0,
       0,     0,     0,     0,   954,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   955,     0,     0,     0,   956,   957,     0,
       0,   958,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   954,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   955,     0,     0,     0,   956,
     957,     0,     0,   958
};

static const yytype_int16 yycheck[] =
{
     223,   192,   222,   226,   410,   865,  1128,  1180,   868,     1,
       1,   871,     1,  1015,   874,  1017,     1,  1019,     1,  1021,
     241,  1023,   882,  1063,  1036,     1,  1038,    62,  1040,   252,
     333,   254,     1,   256,     1,   258,     1,   865,     1,     1,
     868,    57,     1,   871,     1,  1057,   874,   350,     1,     1,
       1,   323,   323,    62,   882,     1,     1,     1,   323,     1,
    1052,   333,   333,     1,    62,   303,     1,    62,     1,   110,
       1,   336,   323,   344,     1,   346,     1,     1,   960,     1,
       1,  1073,     0,  1075,   324,   336,   351,     1,   339,     1,
     303,    56,    57,     1,   317,   977,   336,   979,     1,   981,
     960,   303,     1,   985,   327,   328,   329,   330,   331,   332,
     333,     1,     1,     1,     1,     1,     1,   977,     1,   979,
     303,   981,  1114,     1,   323,   985,    88,    89,    90,    91,
       1,     1,   960,     1,   333,     1,     1,     1,     1,   362,
     363,   364,   548,    88,    89,    90,    91,     1,   337,   977,
     339,   979,     1,   981,     1,     1,     1,   985,    61,     1,
     303,   868,  1055,     1,   871,   323,  1059,   874,   344,     1,
     346,   336,   337,     1,   339,   882,     1,   865,   336,   303,
     868,     1,     1,   871,     1,     1,   874,     1,     1,     1,
     303,     1,  1052,  1053,   882,     1,    61,   336,     1,   344,
     339,   346,     1,     1,   336,   337,   338,   339,   340,     1,
     324,   325,   326,  1073,   323,  1075,     1,     1,   350,   442,
       1,     1,   445,   446,  1052,  1053,   344,   336,   346,   303,
     339,   865,     1,  1115,   868,     1,    61,   871,   303,     1,
     874,     1,   303,     1,     1,  1073,  1128,  1075,   882,   303,
       1,  1253,   303,     1,  1114,  1115,   303,     1,     1,    14,
      15,     1,     1,   894,   895,     1,     1,     1,  1128,    61,
     303,     1,   960,     1,     1,     1,     1,    61,     1,     1,
       1,   303,     1,     1,     1,     1,  1114,  1115,     1,   977,
       1,   979,     1,   981,     1,     1,     1,   985,     1,     1,
    1128,   336,     1,  1163,     1,     1,     1,     1,     1,     1,
       1,    19,   353,   227,   228,   229,   230,  1177,     1,  1359,
     336,   337,   303,     1,  1184,     1,   960,   336,    88,    89,
      90,    91,   553,     1,     1,  1163,     1,   303,   336,     1,
     303,   336,   303,   977,   336,   979,  1053,   981,   340,  1177,
     303,   985,    16,   336,   337,   338,  1184,   348,   350,   350,
    1242,   350,   324,   348,  1052,  1053,  1539,   336,   337,   338,
     339,   340,   348,   340,   336,   337,   338,   339,   340,   324,
     303,   350,  1242,   350,   349,  1073,   339,  1075,   350,   348,
     347,   336,   337,   338,   339,   340,   348,   348,   350,   350,
     346,   347,   347,   347,   865,   350,   348,   868,   350,   347,
     871,  1533,   347,   874,  1242,   348,   347,   350,  1052,  1053,
     347,   882,   347,   347,   345,   347,  1114,  1115,   336,   337,
     338,   339,   340,   336,   337,   347,   339,   340,     1,  1073,
    1128,  1075,   350,   346,     1,  1457,   336,   350,   347,   336,
     337,   865,  1464,     1,   868,     1,   346,   871,   347,   347,
     874,   347,   347,     1,   347,     1,  1326,   337,   882,   347,
    1177,   336,   337,   339,   339,   340,   347,  1184,   288,   347,
    1114,  1115,     1,   347,   347,   350,   892,   336,  1370,  1177,
     303,   303,     1,   347,  1128,  1377,  1184,   339,  1326,   960,
     347,   347,   347,  1363,  1364,  1365,  1366,   339,  1681,   347,
    1370,   336,   337,     1,   339,   340,   977,  1377,   979,   347,
     981,     1,   303,   337,   985,   350,   339,   347,   347,   339,
     347,   347,   342,   339,   337,  1363,  1364,  1365,  1366,   337,
     339,   339,  1370,  1177,   336,   337,   960,   339,   340,  1377,
    1184,   336,   336,   337,  1242,   339,   340,   337,   350,   339,
       1,   323,     1,   977,   324,   979,   350,   981,   337,     1,
     339,   985,     1,   339,   336,     1,   336,   337,   338,   339,
     340,   339,   339,   989,   346,     1,   337,   347,   339,   337,
     350,   339,  1053,   337,   337,   339,   339,   337,   337,   339,
     339,   336,   336,   339,   339,   339,     1,   337,  1242,   339,
     336,   339,   339,  1615,   339,     1,   339,   339,   339,  1326,
     339,   339,   339,   339,     1,   303,   339,     1,   339,     1,
     339,     1,   339,   339,   339,     1,   339,   339,  1326,  1053,
     339,   324,   339,   339,   339,   339,   339,   339,   339,     1,
    1532,  1533,     1,   336,  1115,   323,  1363,  1364,  1365,  1366,
     336,   337,   338,     1,    62,     1,     1,  1128,   336,   336,
     861,   336,  1532,  1533,   336,  1363,  1364,  1365,  1366,   303,
       1,     1,  1370,     1,     1,  1567,  1568,  1569,  1570,  1377,
       1,     1,  1326,     1,     1,     1,     1,     1,   109,   110,
       1,  1115,  1163,     1,  1532,  1533,     1,  1567,  1568,  1569,
    1570,  1117,     1,   303,  1128,  1121,  1177,   303,     1,     1,
       1,     1,     1,  1184,     1,     1,     1,    56,    57,  1363,
    1364,  1365,  1366,   303,     1,     1,  1370,     1,     1,  1567,
    1568,  1569,  1570,  1377,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     323,     1,     1,  1177,     1,     1,   323,     1,     1,  1629,
    1184,   303,     1,   336,     1,   323,     1,   323,     1,   336,
       1,  1242,     1,   303,   333,   323,     1,   323,   336,     1,
     336,     1,     1,     1,     1,     1,     1,     1,   336,     1,
     336,  1629,     1,     1,  1686,   324,     1,     1,     1,     1,
       1,     1,     1,     1,  1696,     1,     1,   336,  1700,  1701,
    1702,     1,  1682,     1,     1,  1685,  1686,   336,  1242,     1,
       1,     1,     1,   303,     1,   323,  1696,  1697,  1698,     1,
    1700,  1701,  1702,   323,  1532,  1533,     1,     1,   336,     1,
       1,     1,   303,   303,  1682,     1,   336,  1685,  1686,    88,
      89,    90,    91,   336,   337,  1326,   339,   303,  1696,  1697,
    1698,   303,  1700,  1701,  1702,     1,  1099,     1,     1,  1567,
    1568,  1569,  1570,   344,   323,   346,    88,    89,    90,    91,
       1,   303,    21,  1113,   323,   336,     1,   336,  1532,  1533,
     303,  1121,  1363,  1364,  1365,  1366,     1,   336,   303,  1370,
     336,     1,  1326,   303,     1,     1,  1377,     1,     1,   303,
     336,     1,  1629,   303,     1,   311,   312,   313,     1,     1,
     316,   317,     1,  1567,  1568,  1569,  1570,   344,   336,   346,
       1,  1629,     1,  1134,     1,  1136,   323,  1138,     1,  1363,
    1364,  1365,  1366,   323,     1,     1,  1370,   323,     1,   336,
    1183,     1,   336,  1377,   336,   303,   336,   303,     1,   303,
     336,   323,     1,     1,   323,  1682,   311,   312,  1685,     1,
     303,   316,   317,     1,   336,    20,   348,   336,     1,   303,
    1697,  1698,   303,   336,  1682,  1629,   336,  1685,  1686,   910,
     911,   912,   339,   322,   323,   324,   325,   326,  1696,  1697,
    1698,   303,  1700,  1701,  1702,   336,   336,   303,   336,   336,
     349,   336,   337,   336,   339,   936,   336,   336,   336,   336,
     336,   336,   336,   944,   945,   336,   336,   336,   336,   303,
     336,   336,   303,    88,    89,    90,    91,   336,  1682,   336,
     344,  1685,  1686,   336,   336,   336,   336,   336,   336,   336,
     336,   336,  1696,  1697,  1698,   303,  1700,  1701,  1702,   336,
     336,  1532,  1533,   336,   336,   337,   303,   339,   336,   336,
     336,   336,   336,   336,   336,   336,   336,   336,   336,   336,
     336,   336,   336,   336,   336,   324,   336,   336,   339,   336,
     336,   336,   336,   336,   303,   336,  1567,  1568,  1569,  1570,
     336,   336,   344,   336,   346,   336,   303,   336,  1532,  1533,
     336,   336,   324,   303,   336,   336,   336,   336,   336,   336,
     336,   336,   336,   336,  1540,  1046,  1047,  1048,   336,   303,
     303,   336,   336,   336,   336,   336,   336,   336,   336,   350,
     336,   336,   336,  1567,  1568,  1569,  1570,   303,   336,   336,
    1071,   344,   303,   346,   336,   336,   336,   336,  1629,   336,
     344,  1082,   346,   303,   336,   303,   344,   303,   346,   336,
     303,   336,   336,   303,   336,   336,   336,   311,   312,   323,
     303,   303,   316,   317,   318,   319,   320,   321,   303,   333,
     311,   312,   313,   303,   303,   316,   317,   344,   303,   346,
     344,   303,   346,   303,   303,  1629,   303,   303,   303,   336,
     303,  1682,   303,   303,  1685,  1686,   303,   311,   312,   313,
     303,   303,   316,   317,   303,  1696,  1697,  1698,   303,  1700,
    1701,  1702,   303,   344,   303,   346,   303,   303,  1471,  1160,
     303,   344,     1,   346,   863,   323,   303,   303,   867,   303,
     303,   870,   303,   303,   873,   333,   303,   303,  1682,   303,
     303,  1685,  1686,   303,   303,   303,   344,   303,   346,   324,
     303,   303,  1696,  1697,  1698,   303,  1700,  1701,  1702,   303,
     303,   336,   337,   338,   339,   340,   344,  1017,   346,  1019,
     351,  1021,   347,  1023,   303,   350,   303,   303,  1219,  1220,
    1221,   290,   291,   292,   293,   294,   295,   296,   297,   298,
    1231,  1232,    71,    72,    73,    74,   303,    76,   344,    78,
     346,    80,   303,  1244,   323,   271,   272,   273,   274,  1250,
    1251,   344,  1253,   346,   333,   303,  1257,  1258,  1259,  1260,
    1261,  1262,  1263,   323,   344,   344,   346,   346,   337,   344,
     303,   346,   336,   333,  1275,  1276,  1277,  1278,  1279,  1280,
    1281,   303,  1563,   303,   344,  1566,   346,   318,   319,   320,
     321,   322,   323,   324,   325,   326,  1609,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   348,   311,   312,   303,   303,   303,   316,   317,   303,
     303,   303,  1353,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   346,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   303,   346,   303,
     303,   303,   303,  1253,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   303,   303,   346,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   303,   303,   303,   346,
     303,   303,   336,   337,   338,   339,   340,   303,   303,   303,
       0,     1,  1543,   347,   303,   303,   350,   303,  1549,   303,
     303,   303,   303,   303,    14,    15,    16,    17,    18,    19,
      20,    21,   303,   303,   303,   303,   303,   303,   303,   303,
     303,   303,   303,   303,   303,   303,   303,   303,    38,   303,
     303,    41,    42,    43,    44,    45,   303,   303,   303,   303,
     303,   303,   303,   303,   303,   303,   303,    57,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   303,   303,   303,   303,  1626,   303,   303,   303,   348,
     348,   336,   336,  1634,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   336,
     336,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   336,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   336,   336,   336,
     336,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   336,   269,
     270,   336,   336,   336,   336,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   336,   336,
     336,   336,   336,   353,   344,   348,   348,   336,   336,   333,
     300,   301,   302,   340,   353,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   353,   344,
     303,   303,   303,   303,   336,   343,   303,   337,   351,   336,
     344,   346,   351,   339,   351,   345,   347,   346,   303,   347,
     345,     1,   352,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,   347,   347,   347,   347,   347,
     347,   347,    22,    23,    24,    25,    26,    27,    28,    29,
     345,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,   347,    42,   347,   351,   333,    46,   348,    48,    49,
      50,    51,    52,    53,    54,    55,   351,   351,    58,    59,
      60,   351,   333,   344,    64,    65,    66,    67,    68,    69,
       1,   353,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,   348,   347,   347,   339,   346,   346,
     346,    22,    23,    24,    25,    26,    27,    28,    29,   346,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
     346,    42,   346,   346,   346,    46,   346,    48,    49,    50,
      51,    52,    53,    54,    55,   347,   333,    58,    59,    60,
     350,   348,   348,    64,    65,    66,    67,    68,    69,     1,
     348,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,   348,   268,   268,   336,   339,   336,   346,
      22,    23,    24,    25,    26,    27,    28,    29,   337,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,   346,
      42,   346,   346,   346,    46,   346,    48,    49,    50,    51,
      52,    53,    54,    55,   303,   303,    58,    59,    60,   303,
     303,   346,    64,    65,    66,    67,    68,    69,     1,   349,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,   350,   346,   344,   346,   344,   346,    47,    22,
      23,    24,    25,    26,    27,    28,    29,   353,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,   346,    42,
     346,   346,   346,    46,   346,    48,    49,    50,    51,    52,
      53,    54,    55,   346,   346,    58,    59,    60,   346,   346,
     346,    64,    65,    66,    67,    68,    69,   346,   346,   346,
     346,   346,   346,   346,   346,   346,   346,   346,   288,   346,
     346,   346,   346,   346,   346,   346,   346,   346,   346,   346,
     346,   346,   346,   344,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   353,   346,   346,
     346,   346,   346,   333,   346,   346,   346,   337,   337,   344,
     303,   341,   342,   351,   344,   345,   346,   347,   348,   339,
     339,   333,   110,   353,   346,   346,   336,   288,   336,   336,
     336,   336,   336,   336,   336,   336,   336,   336,   336,   336,
     336,   336,   333,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   350,   346,   346,   325,
     339,   339,   349,   353,   336,   339,   337,   351,   353,   346,
     341,   342,   353,   344,   345,   346,   347,   348,   346,   346,
     353,   346,   353,   346,   346,   346,   288,   346,   346,   346,
     346,   346,   346,   346,   346,   346,   346,   346,   346,   346,
     346,   346,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   346,   346,   346,   346,   346,
     346,   346,   346,   346,   200,   337,   989,  1221,   859,   341,
     342,   351,   344,   345,   346,   351,   348,   861,   353,   353,
    1175,   353,  1223,  1223,  1610,   288,  1547,   890,   369,  1626,
    1354,   370,    -1,    -1,    -1,  1634,   549,    -1,    -1,    -1,
      -1,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   337,    -1,    -1,    -1,   341,   342,
       1,   344,   345,   346,    -1,   348,    -1,    -1,    -1,    -1,
     353,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    38,    -1,    -1,
      41,    42,    43,    44,    45,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    57,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,    -1,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,   173,   174,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,    -1,    -1,    -1,    -1,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,    -1,   269,   270,
      -1,    -1,    -1,    -1,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   300,
     301,   302,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     1,   337,     3,     4,     5,
       6,     7,    -1,    -1,   345,    -1,    12,    13,    14,    -1,
      -1,   352,    -1,    -1,    -1,    -1,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    -1,    42,    -1,    -1,    -1,
      -1,    -1,    48,    49,    50,    51,    52,    53,    54,    -1,
      -1,    -1,    -1,    59,    60,    -1,    -1,    -1,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,     1,    -1,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    42,    -1,    -1,    -1,    46,    -1,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    -1,    -1,    -1,    64,    65,    66,    67,    68,
      69,     1,    -1,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    -1,    42,    -1,    -1,    -1,    46,    -1,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    -1,    -1,    -1,    64,    65,    66,    67,    68,    69,
      -1,     1,    -1,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    -1,    42,    -1,    -1,    -1,    46,    -1,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    -1,   288,   289,    64,    65,    66,    67,    68,    69,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   323,    -1,    -1,
      -1,   327,    -1,   329,   330,   331,   332,    -1,   334,   335,
     336,   337,    -1,   339,   340,   341,   342,    -1,    -1,    -1,
      -1,   347,   348,    -1,   350,    -1,    -1,    -1,    -1,     1,
      -1,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,   288,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    -1,
      42,    -1,    -1,    -1,    46,    -1,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    -1,
      -1,    -1,    64,    65,    66,    67,    68,    69,   337,    -1,
      -1,    -1,   341,   342,    -1,    -1,   345,    -1,    -1,    -1,
     349,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   288,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   337,    -1,    -1,
      -1,   341,   342,    -1,    -1,   345,    -1,    -1,    -1,   349,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   288,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   337,    -1,    -1,
      -1,   341,   342,    -1,    -1,   345,    -1,    -1,    -1,   349,
      -1,    -1,    -1,    -1,     1,    -1,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    -1,    46,
      -1,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    -1,    -1,   288,    64,    65,    66,
      67,    68,    69,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   337,    -1,    -1,    -1,   341,
     342,    -1,    -1,   345,    -1,    -1,     1,   349,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    -1,    -1,
      -1,    46,    -1,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    -1,    -1,    -1,    64,
      65,    66,    67,    68,    69,     1,    -1,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    -1,    42,    -1,    -1,    -1,
      46,    -1,    48,    49,    50,    51,    52,    53,    54,    55,
      -1,    -1,    58,    59,    60,    -1,    -1,    -1,    64,    65,
      66,    67,    68,    69,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,     1,    -1,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,
      -1,   288,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    -1,    42,    -1,    -1,    -1,    46,    -1,    48,    49,
      50,    51,    52,    53,    54,    55,    -1,    -1,    58,    59,
      60,    -1,    -1,    -1,    64,    65,    66,    67,    68,    69,
     337,    -1,    -1,    -1,   341,   342,    -1,    -1,   345,    -1,
      -1,     1,   349,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    -1,    42,    -1,    -1,    -1,    46,    -1,    48,    49,
      50,    51,    52,    53,    54,    55,    -1,    -1,    58,    59,
      60,    -1,    -1,   288,    64,    65,    66,    67,    68,    69,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   337,    -1,    -1,    -1,   341,   342,    -1,    -1,
     345,    -1,    -1,    -1,   349,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   288,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   337,    -1,    -1,    -1,   341,   342,    -1,    -1,   345,
      -1,    -1,    -1,   349,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   288,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   337,    -1,    -1,
      -1,   341,   342,    -1,    -1,   345,    -1,    -1,     1,   349,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    -1,    -1,    -1,    -1,    -1,    -1,   288,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    -1,    42,
      -1,    -1,    -1,    46,    -1,    48,    49,    50,    51,    52,
      53,    54,    55,    -1,    -1,    58,    59,    60,    -1,    -1,
      -1,    64,    65,    66,    67,    68,    69,   337,    -1,    -1,
      -1,   341,   342,    -1,    -1,   345,    -1,    -1,     1,   349,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    -1,    42,
      -1,    -1,    -1,    46,    -1,    48,    49,    50,    51,    52,
      53,    54,    55,    -1,    -1,    58,    59,    60,    -1,    -1,
      -1,    64,    65,    66,    67,    68,    69,     1,    -1,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    -1,    46,    -1,    48,    49,    50,    51,    52,    53,
      54,    55,    -1,    -1,    58,    59,    60,    -1,    -1,    -1,
      64,    65,    66,    67,    68,    69,     1,    -1,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    -1,    -1,
      -1,    46,    -1,    48,    49,    50,    51,    52,    53,    54,
      55,    -1,    -1,    58,    59,    60,    -1,    -1,    -1,    64,
      65,    66,    67,    68,    69,   288,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   337,    -1,    -1,    -1,   341,   342,
      -1,    -1,   345,    -1,    -1,     1,   349,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    -1,
      -1,    -1,    -1,    -1,    -1,   288,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    -1,    42,    -1,    -1,    -1,
      46,    -1,    48,    49,    50,    51,    52,    53,    54,    55,
      -1,    -1,    58,    59,    60,    -1,    -1,    -1,    64,    65,
      66,    67,    68,    69,   337,    -1,    -1,    -1,   341,   342,
      -1,    -1,   345,    -1,    -1,    -1,   349,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   288,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   337,    -1,    -1,    -1,   341,   342,    -1,
      -1,   345,    -1,    -1,    -1,   349,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   288,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   337,    -1,    -1,    -1,   341,   342,    -1,    -1,
     345,    -1,    -1,     1,   349,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    -1,    42,    -1,    -1,    -1,    46,    -1,
      48,    49,    50,    51,    52,    53,    54,    55,    -1,    -1,
      58,    59,    60,    -1,    -1,    -1,    64,    65,    66,    67,
      68,    69,   288,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   337,    -1,    -1,    -1,   341,   342,    -1,    -1,   345,
      -1,    -1,     1,   349,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    42,    -1,    -1,    -1,    46,    -1,    48,
      49,    50,    51,    52,    53,    54,    55,    -1,    -1,    58,
      59,    60,    -1,    -1,    -1,    64,    65,    66,    67,    68,
      69,     1,    -1,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    -1,    42,    -1,    -1,    -1,    46,    -1,    48,    49,
      50,    51,    52,    53,    54,    55,    -1,    -1,    58,    59,
      60,    -1,    -1,    -1,    64,    65,    66,    67,    68,    69,
       1,    -1,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
     288,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    -1,    -1,    -1,    46,    -1,    48,    49,    50,
      51,    52,    53,    54,    55,    -1,    -1,    58,    59,    60,
      -1,    -1,    -1,    64,    65,    66,    67,    68,    69,   337,
      -1,    -1,    -1,   341,   342,    -1,    -1,   345,    -1,    -1,
       1,   349,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    -1,    -1,    -1,    46,    -1,    48,    49,    50,
      51,    52,    53,    54,    55,    -1,    -1,    58,    59,    60,
      -1,    -1,    -1,    64,    65,    66,    67,    68,    69,   288,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   337,    -1,
      -1,    -1,   341,   342,    -1,    -1,   345,    -1,    -1,    -1,
     349,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   288,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   337,    -1,    -1,
      -1,   341,   342,    -1,    -1,   345,    -1,    -1,    -1,   349,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   288,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   337,    -1,    -1,    -1,
     341,   342,    -1,    -1,   345,    -1,    -1,    -1,   349,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   288,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   337,    -1,    -1,    -1,
     341,   342,    -1,    -1,   345,    -1,    -1,     1,   349,     3,
       4,     5,     6,     7,    -1,    -1,    -1,    -1,    12,    13,
      14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    -1,    -1,    -1,    48,    49,    50,    51,    52,    53,
      54,    -1,    -1,    -1,    -1,    59,    60,    -1,    -1,    -1,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
       1,    -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,
      -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    -1,    -1,    -1,    -1,    -1,    48,    49,    50,
      51,    52,    53,    54,    -1,    -1,    -1,    -1,    59,    60,
      -1,    -1,    -1,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,     1,    -1,     3,     4,     5,     6,     7,
      -1,    -1,    -1,    -1,    12,    13,    14,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    -1,    42,    -1,    -1,    -1,    -1,    -1,
      48,    49,    50,    51,    52,    53,    54,    -1,    -1,    -1,
      -1,    59,    60,    -1,    -1,    -1,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   288,   289,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   323,
     324,    -1,    -1,   327,    -1,   329,   330,   331,   332,    -1,
     334,   335,   336,   337,    -1,   339,    -1,   341,   342,    -1,
      -1,    -1,    -1,   347,   348,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   288,   289,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   323,   324,    -1,    -1,   327,    -1,   329,   330,
     331,   332,    -1,   334,   335,   336,   337,    -1,   339,    -1,
     341,   342,    -1,    -1,    -1,    -1,   347,   348,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     288,   289,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   323,    -1,    -1,    -1,   327,
      -1,   329,   330,   331,   332,    -1,   334,   335,   336,   337,
      -1,   339,    -1,   341,   342,    -1,    -1,    -1,   346,   347,
     348,     1,    -1,     3,     4,     5,     6,     7,    -1,    -1,
      -1,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    -1,    42,    -1,    -1,    -1,    -1,    -1,    48,    49,
      50,    51,    52,    53,    54,    -1,    -1,    -1,    -1,    59,
      60,    -1,    -1,    -1,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,     1,    -1,
       3,     4,     5,     6,     7,    -1,    -1,    -1,    -1,    12,
      13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    -1,    42,
      -1,    -1,    -1,    -1,    -1,    48,    49,    50,    51,    52,
      53,    54,    -1,    -1,    -1,    -1,    59,    60,    -1,    -1,
      -1,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,     1,    -1,     3,     4,     5,
       6,     7,    -1,    -1,    -1,    -1,    12,    13,    14,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    -1,    42,    -1,    -1,    -1,
      -1,    -1,    48,    49,    50,    51,    52,    53,    54,    -1,
      -1,    -1,    -1,    59,    60,    -1,    -1,    -1,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   288,   289,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   323,    -1,    -1,    -1,   327,    -1,   329,
     330,   331,   332,    -1,   334,   335,   336,   337,    -1,   339,
      -1,   341,   342,    -1,    -1,    -1,   346,   347,   348,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   288,   289,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     323,    -1,    -1,    -1,   327,    -1,   329,   330,   331,   332,
      -1,   334,   335,   336,   337,    -1,   339,    -1,   341,   342,
      -1,    -1,    -1,   346,   347,   348,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   288,   289,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   323,    -1,   325,
      -1,   327,    -1,   329,   330,   331,   332,    -1,   334,   335,
     336,   337,    -1,   339,    -1,   341,   342,    -1,    -1,    -1,
      -1,   347,   348,     1,    -1,     3,     4,     5,     6,     7,
      -1,    -1,    -1,    -1,    12,    13,    14,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    -1,    42,    -1,    -1,    -1,    -1,    -1,
      48,    49,    50,    51,    52,    53,    54,    -1,    -1,    -1,
      -1,    59,    60,    -1,    -1,    -1,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
       1,    -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,
      -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    -1,    -1,    -1,    -1,    -1,    48,    49,    50,
      51,    52,    53,    54,    -1,    -1,    -1,    -1,    59,    60,
      -1,    -1,    -1,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,     1,    -1,     3,
       4,     5,     6,     7,    -1,    -1,    -1,    -1,    12,    13,
      14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    -1,    -1,    -1,    48,    49,    50,    51,    52,    53,
      54,    -1,    -1,    -1,    -1,    59,    60,    -1,    -1,    -1,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     288,   289,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   323,    -1,    -1,    -1,   327,
      -1,   329,   330,   331,   332,    -1,   334,   335,   336,   337,
      -1,   339,    -1,   341,   342,    -1,    -1,    -1,    -1,   347,
     348,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   288,   289,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   323,    -1,    -1,    -1,   327,    -1,   329,   330,
     331,   332,    -1,   334,   335,   336,   337,    -1,   339,    -1,
     341,   342,    -1,    -1,    -1,    -1,   347,   348,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   288,   289,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   323,
      -1,    -1,    -1,   327,    -1,   329,   330,   331,   332,    -1,
     334,   335,   336,   337,    -1,   339,    -1,   341,   342,    -1,
      -1,    -1,    -1,   347,   348,     1,    -1,     3,     4,     5,
       6,     7,    -1,    -1,    -1,    -1,    12,    13,    14,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    -1,    42,    -1,    -1,    -1,
      -1,    -1,    48,    49,    50,    51,    52,    53,    54,    -1,
      -1,    -1,    -1,    59,    60,    -1,    -1,    -1,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,     1,    -1,     3,     4,     5,     6,     7,    -1,
      -1,    -1,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    42,    -1,    -1,    -1,    -1,    -1,    48,
      49,    50,    51,    52,    53,    54,    -1,    -1,    -1,    -1,
      59,    60,    -1,    -1,    -1,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,     1,
      -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,    -1,
      12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    -1,
      42,    -1,    -1,    -1,    -1,    -1,    48,    49,    50,    51,
      52,    53,    54,    -1,    -1,    -1,    -1,    59,    60,    -1,
      -1,    -1,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   288,   289,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   323,    -1,    -1,
      -1,   327,    -1,   329,   330,   331,   332,    -1,   334,   335,
     336,   337,    -1,   339,    -1,   341,   342,    -1,    -1,    -1,
      -1,   347,   348,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   288,
     289,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   323,    -1,    -1,    -1,   327,    -1,
     329,   330,   331,   332,    -1,   334,   335,   336,   337,    -1,
     339,    -1,   341,   342,    -1,    -1,    -1,    -1,   347,   348,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   288,   289,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   323,    -1,    -1,    -1,   327,    -1,   329,   330,   331,
     332,    -1,   334,   335,   336,   337,    -1,   339,    -1,   341,
     342,    -1,    -1,    -1,    -1,   347,   348,     1,    -1,     3,
       4,     5,     6,     7,    -1,    -1,    -1,    -1,    12,    13,
      14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    -1,    -1,    -1,    48,    49,    50,    51,    52,    53,
      54,    -1,    -1,    -1,    -1,    59,    60,    -1,    -1,    -1,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,     1,    -1,     3,     4,     5,     6,
       7,    -1,    -1,    -1,    -1,    12,    13,    14,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    -1,    -1,
      -1,    48,    49,    50,    51,    52,    53,    54,    -1,    -1,
      -1,    -1,    59,    60,    -1,    -1,    -1,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,     1,    -1,     3,     4,     5,     6,     7,    -1,    -1,
      -1,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    -1,    42,    -1,    -1,    -1,    -1,    -1,    48,    49,
      50,    51,    52,    53,    54,    -1,    -1,    -1,    -1,    59,
      60,    -1,    -1,    -1,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   288,   289,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   323,
      -1,    -1,    -1,   327,    -1,   329,   330,   331,   332,    -1,
     334,   335,   336,   337,    -1,   339,    -1,   341,   342,    -1,
      -1,    -1,    -1,   347,   348,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   288,   289,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   323,    -1,    -1,    -1,
     327,    -1,   329,   330,   331,   332,    -1,   334,   335,   336,
     337,    -1,   339,    -1,   341,   342,    -1,    -1,    -1,    -1,
     347,   348,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   288,   289,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   323,    -1,    -1,    -1,   327,    -1,   329,
     330,   331,   332,    -1,   334,   335,   336,   337,    -1,   339,
      -1,   341,   342,    -1,    -1,    -1,    -1,   347,   348,     1,
      -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,    -1,
      12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    -1,
      42,    -1,    -1,    -1,    -1,    -1,    48,    49,    50,    51,
      52,    53,    54,    -1,    -1,    -1,    -1,    59,    60,    -1,
      -1,    -1,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,     1,    -1,     3,     4,
       5,     6,     7,    -1,    -1,    -1,    -1,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    -1,    -1,
      -1,    -1,    -1,    48,    49,    50,    51,    52,    53,    54,
      -1,    -1,    -1,    -1,    59,    60,    -1,    -1,    -1,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,     1,    -1,     3,     4,     5,     6,     7,
      -1,    -1,    -1,    -1,    12,    13,    14,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    -1,    42,    -1,    -1,    -1,    -1,    -1,
      48,    49,    50,    51,    52,    53,    54,    -1,    -1,    -1,
      -1,    59,    60,    -1,    -1,    -1,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   288,   289,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   323,    -1,    -1,    -1,   327,    -1,   329,   330,   331,
     332,    -1,   334,   335,   336,   337,    -1,   339,    -1,   341,
     342,    -1,    -1,    -1,    -1,   347,   348,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   288,   289,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   323,    -1,
      -1,    -1,   327,    -1,   329,   330,   331,   332,    -1,   334,
     335,   336,   337,    -1,   339,    -1,   341,   342,    -1,    -1,
      -1,    -1,   347,   348,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     288,   289,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   323,    -1,    -1,    -1,   327,
      -1,   329,   330,   331,   332,    -1,   334,   335,   336,   337,
      -1,   339,    -1,   341,   342,    -1,    -1,    -1,    -1,   347,
     348,     1,    -1,     3,     4,     5,     6,     7,    -1,    -1,
      -1,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    -1,    42,    -1,    -1,    -1,    -1,    -1,    48,    49,
      50,    51,    52,    53,    54,    -1,    -1,    -1,    -1,    59,
      60,    -1,    -1,    -1,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,     1,    -1,
       3,     4,     5,     6,     7,    -1,    -1,    -1,    -1,    12,
      13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    -1,    42,
      -1,    -1,    -1,    -1,    -1,    48,    49,    50,    51,    52,
      53,    54,    -1,    -1,    -1,    -1,    59,    60,    -1,    -1,
      -1,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,     1,    -1,     3,     4,     5,
       6,     7,    -1,    -1,    -1,    -1,    12,    13,    14,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    -1,    42,    -1,    -1,    -1,
      -1,    -1,    48,    49,    50,    51,    52,    53,    54,    -1,
      -1,    -1,    -1,    59,    60,    -1,    -1,    -1,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   288,   289,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   323,    -1,    -1,    -1,   327,    -1,   329,
     330,   331,   332,    -1,   334,   335,   336,   337,    -1,   339,
      -1,   341,   342,    -1,    -1,    -1,    -1,   347,   348,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   288,   289,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     323,    -1,    -1,    -1,   327,    -1,   329,   330,   331,   332,
      -1,   334,   335,   336,   337,    -1,   339,    -1,   341,   342,
      -1,    -1,    -1,    -1,   347,   348,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   288,   289,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   323,    -1,    -1,
      -1,   327,    -1,   329,   330,   331,   332,    -1,   334,   335,
     336,   337,    -1,   339,    -1,   341,   342,    -1,    -1,    -1,
      -1,   347,   348,     1,    -1,     3,     4,     5,     6,     7,
      -1,    -1,    -1,    -1,    12,    13,    14,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    -1,    42,    -1,    -1,    -1,    -1,    -1,
      48,    49,    50,    51,    52,    53,    54,    -1,    -1,    -1,
      -1,    59,    60,    -1,    -1,    -1,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
       1,    -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,
      -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    -1,    -1,    -1,    -1,    -1,    48,    49,    50,
      51,    52,    53,    54,    -1,    -1,    -1,    -1,    59,    60,
      -1,    -1,    -1,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,     1,    -1,     3,
       4,     5,     6,     7,    -1,    -1,    -1,    -1,    12,    13,
      14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    -1,    -1,    -1,    48,    49,    50,    51,    52,    53,
      54,    -1,    -1,    -1,    -1,    59,    60,    -1,    -1,    -1,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     288,   289,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   323,    -1,    -1,    -1,   327,
      -1,   329,   330,   331,   332,    -1,   334,   335,   336,   337,
      -1,   339,    -1,   341,   342,    -1,    -1,    -1,    -1,   347,
     348,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   288,   289,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   323,    -1,    -1,    -1,   327,    -1,   329,   330,
     331,   332,    -1,   334,   335,   336,   337,    -1,   339,    -1,
     341,   342,    -1,    -1,    -1,    -1,   347,   348,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   288,   289,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   323,
      -1,    -1,    -1,   327,    -1,   329,   330,   331,   332,    -1,
     334,   335,   336,   337,    -1,   339,    -1,   341,   342,    -1,
      -1,    -1,    -1,   347,   348,     1,    -1,     3,     4,     5,
       6,     7,    -1,    -1,    -1,    -1,    12,    13,    14,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    -1,    42,    -1,    -1,    -1,
      -1,    -1,    48,    49,    50,    51,    52,    53,    54,    -1,
      -1,    -1,    -1,    59,    60,    -1,    -1,    -1,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,     1,    -1,     3,     4,     5,     6,     7,    -1,
      -1,    -1,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    42,    -1,    -1,    -1,    -1,    -1,    48,
      49,    50,    51,    52,    53,    54,    -1,    -1,    -1,    -1,
      59,    60,    -1,    -1,    -1,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,     1,
      -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,    -1,
      12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    -1,
      42,    -1,    -1,    -1,    -1,    -1,    48,    49,    50,    51,
      52,    53,    54,    -1,    -1,    -1,    -1,    59,    60,    -1,
      -1,    -1,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   288,   289,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   323,    -1,    -1,
      -1,   327,    -1,   329,   330,   331,   332,    -1,   334,   335,
     336,   337,    -1,   339,    -1,   341,   342,    -1,    -1,    -1,
      -1,   347,   348,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   288,
     289,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   323,    -1,    -1,    -1,   327,    -1,
     329,   330,   331,   332,    -1,   334,   335,   336,   337,    -1,
     339,    -1,   341,   342,    -1,    -1,    -1,    -1,   347,   348,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   288,   289,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   323,    -1,    -1,    -1,   327,    -1,   329,   330,   331,
     332,    -1,   334,   335,   336,   337,    -1,   339,    -1,   341,
     342,    -1,    -1,    -1,    -1,   347,   348,     1,    -1,     3,
       4,     5,     6,     7,    -1,    -1,    -1,    -1,    12,    13,
      14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    -1,    -1,    -1,    48,    49,    50,    51,    52,    53,
      54,    -1,    -1,    -1,    -1,    59,    60,    -1,    -1,    -1,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,     1,    -1,     3,     4,     5,     6,
       7,    -1,    -1,    -1,    -1,    12,    13,    14,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    -1,    -1,
      -1,    48,    49,    50,    51,    52,    53,    54,    -1,    -1,
      -1,    -1,    59,    60,    -1,    -1,    -1,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,     1,    -1,     3,     4,     5,     6,     7,    -1,    -1,
      -1,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    -1,    42,    -1,    -1,    -1,    -1,    -1,    48,    49,
      50,    51,    52,    53,    54,    -1,    -1,    -1,    -1,    59,
      60,    -1,    -1,    -1,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   288,   289,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   323,
      -1,    -1,    -1,   327,    -1,   329,   330,   331,   332,    -1,
     334,   335,   336,   337,    -1,   339,    -1,   341,   342,    -1,
      -1,    -1,    -1,   347,   348,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   288,   289,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   323,    -1,    -1,    -1,
     327,    -1,   329,   330,   331,   332,    -1,   334,   335,   336,
     337,    -1,   339,    -1,   341,   342,    -1,    -1,    -1,    -1,
     347,   348,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   288,   289,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   323,    -1,    -1,    -1,   327,    -1,   329,
     330,   331,   332,    -1,   334,   335,   336,   337,    -1,   339,
      -1,   341,   342,    -1,    -1,    -1,    -1,   347,   348,     1,
      -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,    -1,
      12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    -1,
      42,    -1,    -1,    -1,    -1,    -1,    48,    49,    50,    51,
      52,    53,    54,    -1,    -1,    -1,    -1,    59,    60,    -1,
      -1,    -1,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    -1,    46,
      -1,    48,    49,    50,    51,    52,    53,    54,    55,    -1,
      -1,    58,    59,    60,    -1,    -1,    -1,    64,    65,    66,
      67,    68,    69,     3,     4,     5,     6,     7,    -1,    -1,
      -1,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    -1,    42,    -1,    -1,    -1,    -1,    -1,    48,    49,
      50,    51,    52,    53,    54,    -1,    -1,    -1,    -1,    59,
      60,    -1,    -1,    -1,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   288,   289,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   323,    -1,    -1,    -1,   327,    -1,   329,   330,   331,
     332,    -1,   334,   335,   336,   337,    -1,   339,    -1,   341,
     342,    -1,    -1,    -1,    -1,   347,   348,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   288,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     337,    -1,    -1,    -1,   341,   342,    -1,    -1,   345,    -1,
      -1,   348,    -1,    -1,    -1,    -1,    -1,    -1,   288,   289,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   323,    -1,    -1,    -1,   327,    -1,   329,
     330,   331,   332,    -1,   334,   335,   336,   337,    -1,   339,
      -1,   341,   342,    -1,    -1,    -1,    -1,   347,   348,     3,
       4,     5,     6,     7,    -1,    -1,    -1,    -1,    12,    13,
      14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    -1,    -1,    -1,    48,    49,    50,    51,    52,    53,
      54,    -1,    -1,    -1,    -1,    59,    60,    -1,    -1,    -1,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,     3,     4,     5,     6,     7,    -1,
      -1,    -1,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    42,    -1,    -1,    -1,    -1,    -1,    48,
      49,    50,    51,    52,    53,    54,    -1,    -1,    -1,    -1,
      59,    60,    -1,    -1,    -1,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,     3,
       4,     5,     6,     7,    -1,    -1,    -1,    -1,    12,    13,
      14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    -1,    -1,    -1,    48,    49,    50,    51,    52,    53,
      54,    -1,    -1,    -1,    -1,    59,    60,    -1,    -1,    -1,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   288,   289,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   323,
      -1,    -1,    -1,   327,    -1,   329,   330,   331,   332,    -1,
     334,   335,   336,   337,    -1,   339,    -1,   341,   342,    -1,
      -1,    -1,    -1,   347,   348,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   288,
     289,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   323,    -1,    -1,    -1,   327,    -1,
     329,   330,   331,   332,    -1,   334,   335,   336,   337,    -1,
     339,    -1,   341,   342,    -1,    -1,    -1,    -1,   347,   348,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   288,   289,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   323,
      -1,    -1,    -1,   327,    -1,   329,   330,   331,   332,    -1,
     334,   335,   336,   337,    -1,   339,    -1,   341,   342,    -1,
      -1,    -1,    -1,   347,   348,     3,     4,     5,     6,     7,
      -1,    -1,    -1,    -1,    12,    13,    14,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    -1,    42,    -1,    -1,    -1,    -1,    -1,
      48,    49,    50,    51,    52,    53,    54,    -1,    -1,    -1,
      -1,    59,    60,    -1,    -1,    -1,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    -1,    42,
      -1,    -1,    -1,    46,    -1,    48,    49,    50,    51,    52,
      53,    54,    55,    -1,    -1,    58,    59,    60,    -1,    -1,
      -1,    64,    65,    66,    67,    68,    69,     1,    -1,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    -1,    46,    -1,    48,    49,    50,    51,    52,    53,
      54,    55,    -1,    -1,    58,    59,    60,    -1,    -1,    -1,
      64,    65,    66,    67,    68,    69,    -1,    -1,    -1,    -1,
      -1,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    -1,
      42,    -1,    -1,    -1,    46,    -1,    48,    49,    50,    51,
      52,    53,    54,    55,    -1,    -1,    58,    59,    60,    -1,
     288,   289,    64,    65,    66,    67,    68,    69,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   323,    -1,    -1,    -1,   327,
      -1,   329,   330,   331,   332,    -1,   334,   335,   336,   337,
      -1,   339,    -1,   341,   342,    -1,    -1,    -1,    -1,   347,
     348,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   288,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   337,    -1,    -1,    -1,   341,   342,
      -1,    -1,   345,    -1,    -1,   348,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   288,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   337,    -1,    -1,    -1,   341,   342,    -1,
      -1,   345,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   288,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   337,    -1,    -1,    -1,   341,
     342,    -1,    -1,   345
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,     1,    17,    18,    38,    41,    42,    43,    44,    45,
      57,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   269,   270,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   300,   301,   302,   337,   345,   352,   355,
     356,   357,   358,   359,   360,   361,   362,   373,   377,   380,
     381,   383,   384,   394,   395,   404,   303,     1,   350,     1,
     303,   303,   303,   303,   303,   303,   303,   303,   303,   303,
     303,   303,   303,   303,   303,   303,   303,   303,   303,   303,
     303,   303,   303,   303,   303,     1,   303,     1,   303,     1,
     303,     1,   303,     1,   303,     1,   303,     1,   303,     1,
     303,     1,   303,     1,   303,     1,   303,     1,   303,     1,
     303,     1,   303,     1,   303,     1,   303,     1,   303,     1,
     303,     1,   303,     1,   303,     1,   303,     1,   303,     1,
     303,     1,   303,     1,   303,     1,   303,     1,   303,     1,
     303,     1,   303,     1,   303,     1,   303,     1,   303,     1,
     303,     1,   303,     1,   303,     1,   303,   303,   303,   303,
     303,   303,   303,   303,   303,   303,   303,   303,   303,   303,
     303,   303,   303,   303,   303,   303,   303,   303,   303,     1,
     339,     1,   303,   339,     1,   347,     1,   303,   339,   303,
     303,   303,   303,   303,   303,   303,   303,   303,   303,   303,
     303,   303,   303,   303,   303,   303,   303,   303,   303,   303,
     303,   303,   303,     1,   303,     1,   303,     1,   303,     1,
     303,   303,   303,   303,   303,   303,   303,   303,   303,   303,
     303,   303,   303,   303,   303,   303,   303,   303,   303,   303,
     303,   303,   303,   303,   303,   303,   303,   303,   303,   303,
     303,   303,   303,   303,   303,   303,   303,   303,   303,   303,
     303,   303,   303,   303,   303,   303,   303,   303,     1,   303,
     303,   303,   303,   303,   303,   303,   303,   303,   303,   303,
     303,   333,   303,   303,   303,   303,   303,   303,   303,   303,
     303,   303,   303,     1,   337,   339,   374,   375,   376,     1,
     376,   378,   379,     1,   339,     1,   339,     1,   339,     0,
       1,   357,    14,    15,   390,   391,    16,   392,   393,    19,
     398,   399,    20,   400,   401,    21,   402,   403,   333,   350,
     348,   336,   337,   339,   389,     1,   336,     1,   336,     1,
      88,    89,    90,    91,   324,   366,     1,   323,   336,   372,
       1,   336,     1,   336,     1,   372,     1,   336,     1,   336,
       1,   336,     1,   336,     1,   337,     1,   339,     1,   336,
       1,   339,     1,   336,     1,   339,     1,   339,     1,   339,
       1,   339,     1,   336,   337,   338,   339,   340,   347,   350,
     363,   365,   366,   370,   371,   385,   386,   387,   388,   418,
     419,     1,   371,     1,   336,     1,   336,     1,   336,   336,
     336,   336,   372,   372,   372,   372,   336,   336,   336,   336,
     336,   336,   336,   336,   336,   336,   336,   336,   336,   336,
     336,   336,   336,   336,   336,   336,   336,   336,   336,   336,
     336,   336,   336,   336,   336,     1,   372,     1,   336,     1,
     339,     1,   336,     1,   336,     1,   336,     1,   336,     1,
     336,     1,   336,     1,   336,     1,   372,     1,   372,     1,
     372,     1,   372,     1,   372,     1,   372,     1,   372,     1,
     336,     1,   336,     1,   339,     1,   339,     1,   336,     1,
     339,   339,     1,   339,     1,   336,     1,   336,     1,   337,
     339,     1,   337,   339,     1,   337,   339,     1,   337,   339,
       1,   337,   339,     1,   336,     1,   336,     1,   336,     1,
     336,     1,   336,     1,   336,     1,   372,     1,   372,     1,
     372,     1,   337,   339,     1,   336,     1,   336,     1,   336,
       1,   336,   386,     1,   388,     1,   336,     1,   336,   336,
     336,   336,   336,     1,   336,     1,   336,     1,   336,     1,
     336,     1,   336,     1,   336,     1,   336,     1,   336,     1,
     336,     1,   336,     1,   336,     1,   336,     1,   336,     1,
     336,     1,   336,     1,   336,     1,   336,     1,   336,     1,
     227,   228,   229,   230,     1,   336,     1,   336,     1,   336,
       1,   336,     1,   339,     1,   339,     1,   339,     1,   336,
       1,   336,     1,   336,     1,   363,     1,   336,     1,   336,
       1,   336,     1,   336,     1,   336,     1,   336,     1,   336,
       1,   336,     1,   336,     1,   336,     1,   336,     1,   336,
       1,   336,     1,   336,     1,   336,     1,   337,   339,     1,
     336,   337,   336,     1,   336,     1,   336,     1,   336,     1,
     336,     1,   336,     1,   336,     1,   336,     1,   339,     1,
     336,     1,   336,     1,   336,   271,   272,   273,   274,     1,
     372,   336,   336,     1,   372,     1,   372,     1,   336,     1,
     336,     1,   336,     1,   336,     1,   336,     1,   339,   344,
     353,   344,     1,   350,     1,   348,     1,   350,   348,     1,
     350,   348,     1,   350,   348,     1,   350,    57,   336,   337,
     382,   336,   396,   351,   336,   333,   363,   364,   387,   353,
     353,   371,   109,   110,   323,   333,   344,   303,   303,   303,
     303,   374,   336,   378,   389,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    22,    23,    24,
      25,    26,    27,    28,    29,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    42,    46,    48,    49,    50,
      51,    52,    53,    54,    55,    58,    59,    60,    64,    65,
      66,    67,    68,    69,   288,   337,   341,   342,   345,   420,
     422,   423,   424,   428,   429,   437,   438,   440,   441,   444,
     445,   447,   451,   452,   453,   457,   389,   422,   389,   422,
     389,   422,   343,   303,   351,   422,     1,   397,   336,   344,
     346,   351,     1,   324,   336,   368,   365,   363,   339,     1,
     336,   418,     1,   418,   339,     1,   339,     1,   339,     1,
     339,     1,   339,   351,     1,   347,     1,   347,     1,   347,
       1,   347,     1,   347,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,   289,   323,   327,   329,   330,   331,   332,   334,
     335,   339,   347,   348,   372,   410,   411,   412,   413,   414,
     415,   420,   432,   437,   438,   439,   440,   442,   444,   445,
     448,   449,   450,   347,   450,   347,   450,     1,   347,     1,
     347,     1,   347,   347,     1,   347,     1,   347,     1,   347,
       1,   347,     1,   347,     1,   347,     1,   347,     1,   347,
     347,     1,   347,     1,   347,     1,   347,     1,   347,   347,
     347,   347,   347,   347,   347,   450,     1,   347,     1,   347,
       1,   347,   347,   347,   347,   347,     1,   450,   450,     1,
     347,     1,   347,     1,   347,     1,   347,     1,   347,     1,
     454,     1,   345,     1,   349,   423,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   337,   434,   435,   436,   303,
     446,   345,     1,   347,   345,   351,   349,   351,   349,   351,
     349,   351,     1,   336,   339,   333,   349,   348,   333,   364,
     353,   110,   353,   344,   348,     1,    61,   337,   339,   346,
     385,   417,     1,    61,   339,   385,   417,     1,    61,   339,
     385,   417,     1,    61,   339,   385,   417,     1,    61,   339,
     385,   417,     1,   311,   312,   313,   316,   317,   405,   407,
     405,   405,     1,   405,   433,     1,   450,     1,   450,     1,
     450,   347,   347,     1,   346,   438,   440,   444,   445,   450,
     451,     1,   422,     1,   407,     1,   318,   319,   320,   321,
     405,   406,     1,   407,   436,     1,   450,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     408,   409,   346,   346,     1,   336,   339,     1,   339,     1,
     337,   450,   339,     1,   339,     1,   339,     1,   339,     1,
     339,     1,   336,     1,   336,   346,     1,   346,   372,   346,
       1,   339,     1,   339,     1,   339,     1,   339,   346,   346,
     346,     1,   336,   346,     1,   366,   348,   421,   423,     1,
     363,     1,   336,     1,   363,   366,   369,   346,   346,   346,
     346,   348,   421,     1,   339,     1,   339,   336,   376,   336,
     376,   336,   376,   347,   333,   350,   450,     1,   339,   437,
     438,   443,   445,   348,   348,   348,   348,   268,   268,   382,
     422,   336,   368,   339,   336,   339,   372,   422,   346,   344,
     346,   344,   346,   344,   346,   323,   333,   344,   346,   346,
     344,   346,   344,   346,   344,   346,   344,   346,   346,   344,
     346,   344,   346,   344,   346,   344,   346,   346,   344,   346,
     344,   346,   344,   346,   344,   346,   346,   344,   346,   344,
     346,   344,   346,   344,   346,     1,   337,   450,     1,    88,
      89,    90,    91,    92,    93,   324,   367,   450,     1,   367,
     450,     1,   410,   414,   337,   430,   431,     1,   450,     1,
     450,   346,   346,   346,   349,   349,     1,    86,   450,     1,
     450,     1,   450,     1,    86,   336,   337,   385,   416,   417,
     450,   350,     1,   450,     1,   450,     1,   450,     1,   450,
     450,   450,   450,     1,   450,     1,   450,     1,   450,     1,
     450,     1,   450,     1,   450,     1,   450,   346,   344,   346,
     346,   344,   346,   346,   346,   346,   346,   346,   346,   346,
     346,   346,   346,   346,   346,   346,   346,   346,   346,   346,
     346,   346,   346,   346,   346,   346,   346,   346,   346,   346,
     346,   346,   422,    47,   346,   346,   346,   346,   346,   353,
     353,   346,     1,    56,    57,   349,   426,   427,   346,   344,
     346,   346,   346,   346,   346,   346,   346,   346,   450,   455,
     456,   435,   351,   344,   346,   436,   344,   422,   422,   422,
     422,   339,   339,   303,   349,   333,   110,   346,   346,   349,
      62,   336,   336,   336,     1,   337,     1,   337,   336,    62,
     336,   336,   336,   336,    62,   336,   336,   336,   336,    62,
     336,   336,   336,   336,    62,   336,   336,   336,   336,   350,
     333,   346,   346,   346,   346,   325,   372,   339,   339,   349,
     421,     1,   368,   363,   349,     1,   325,   425,   450,   353,
     349,   426,   336,   450,   344,   346,   376,     1,   376,   349,
     349,   349,   349,   336,   339,   336,   339,   346,   346,   346,
     346,   346,   346,   346,   346,   346,   346,   346,   346,   346,
     346,   346,   346,   346,   346,   346,   346,   346,   346,   346,
     346,   346,   339,   372,   430,     1,   336,   385,   351,   346,
     346,   353,   353,     1,   425,   353,   422,   346,   346,   456,
     346,   346,   346,   351,   351,   368,   422,   353,   353,     1,
     422,   422,   422
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   354,   355,   356,   356,   356,   357,   357,   357,   357,
     357,   358,   357,   359,   357,   357,   360,   357,   361,   357,
     362,   357,   357,   357,   363,   363,   363,   364,   364,   365,
     365,   366,   366,   366,   366,   366,   367,   367,   367,   367,
     367,   367,   367,   368,   368,   369,   369,   369,   369,   369,
     370,   370,   370,   370,   370,   371,   371,   372,   372,   373,
     373,   374,   374,   375,   375,   376,   376,   377,   377,   378,
     378,   379,   380,   380,   380,   380,   380,   380,   380,   380,
     380,   380,   380,   380,   380,   380,   380,   380,   380,   380,
     380,   380,   380,   380,   380,   380,   380,   380,   380,   380,
     380,   380,   380,   380,   380,   380,   380,   380,   380,   380,
     380,   380,   380,   380,   380,   380,   380,   380,   380,   380,
     380,   380,   380,   380,   380,   380,   380,   380,   380,   380,
     380,   380,   380,   380,   380,   380,   380,   380,   380,   380,
     380,   380,   380,   380,   380,   380,   380,   380,   380,   380,
     380,   380,   380,   380,   380,   380,   380,   380,   380,   380,
     380,   380,   380,   380,   380,   380,   380,   380,   380,   380,
     380,   380,   380,   380,   380,   380,   380,   380,   380,   380,
     380,   380,   380,   380,   380,   380,   380,   380,   380,   380,
     380,   380,   380,   380,   380,   380,   380,   380,   380,   380,
     380,   380,   380,   380,   380,   380,   380,   380,   380,   380,
     380,   380,   380,   380,   380,   380,   380,   380,   380,   380,
     380,   380,   380,   380,   380,   380,   380,   380,   380,   380,
     380,   380,   380,   380,   380,   380,   380,   380,   380,   380,
     380,   380,   380,   380,   380,   380,   380,   380,   380,   380,
     380,   380,   380,   380,   380,   380,   380,   380,   380,   380,
     380,   380,   380,   380,   380,   380,   380,   380,   380,   380,
     380,   380,   380,   380,   380,   380,   380,   380,   380,   380,
     380,   380,   380,   380,   380,   380,   380,   380,   380,   380,
     380,   380,   380,   380,   380,   380,   380,   380,   380,   380,
     380,   380,   380,   380,   380,   380,   380,   380,   380,   380,
     380,   380,   380,   380,   380,   380,   380,   380,   380,   380,
     380,   380,   380,   380,   380,   380,   380,   380,   380,   380,
     380,   380,   380,   380,   380,   380,   380,   380,   380,   380,
     380,   380,   380,   380,   380,   380,   380,   380,   380,   380,
     380,   380,   380,   380,   380,   380,   380,   380,   380,   380,
     380,   380,   380,   380,   380,   380,   380,   380,   380,   380,
     380,   380,   380,   380,   380,   380,   380,   380,   380,   380,
     380,   380,   380,   380,   380,   380,   380,   380,   380,   380,
     380,   380,   380,   380,   380,   380,   380,   380,   380,   380,
     380,   380,   380,   380,   380,   380,   380,   380,   380,   380,
     380,   380,   380,   380,   380,   380,   380,   380,   380,   380,
     380,   380,   380,   380,   380,   380,   380,   380,   380,   380,
     380,   380,   380,   380,   380,   380,   380,   380,   380,   380,
     380,   380,   380,   380,   380,   380,   380,   380,   380,   380,
     380,   380,   380,   380,   380,   380,   380,   380,   381,   381,
     382,   382,   382,   383,   383,   383,   383,   383,   383,   383,
     384,   384,   384,   384,   384,   384,   384,   384,   384,   384,
     384,   384,   384,   385,   385,   386,   387,   388,   388,   389,
     389,   389,   390,   390,   391,   391,   391,   391,   392,   393,
     393,   393,   394,   394,   396,   395,   395,   395,   397,   395,
     395,   398,   399,   399,   399,   400,   401,   401,   401,   402,
     403,   403,   404,   404,   404,   404,   404,   404,   405,   405,
     405,   405,   406,   406,   406,   406,   407,   407,   408,   408,
     408,   408,   408,   408,   408,   409,   409,   409,   409,   410,
     410,   410,   411,   411,   411,   412,   412,   412,   412,   412,
     413,   413,   414,   414,   414,   415,   415,   415,   415,   415,
     415,   415,   415,   415,   415,   415,   415,   415,   415,   415,
     415,   415,   415,   415,   415,   415,   415,   415,   415,   415,
     415,   415,   415,   415,   416,   416,   416,   416,   417,   417,
     417,   417,   417,   418,   418,   418,   419,   419,   419,   419,
     419,   420,   421,   421,   422,   422,   422,   423,   423,   423,
     423,   423,   423,   423,   423,   424,   424,   425,   426,   426,
     426,   426,   426,   426,   426,   426,   426,   426,   426,   427,
     427,   428,   428,   428,   428,   429,   430,   430,   430,   431,
     431,   433,   432,   434,   434,   434,   434,   434,   434,   434,
     434,   434,   435,   436,   436,   437,   438,   439,   440,   441,
     441,   442,   442,   442,   443,   443,   443,   444,   445,   446,
     447,   447,   447,   448,   448,   448,   448,   448,   448,   448,
     448,   448,   448,   448,   448,   449,   449,   449,   450,   450,
     450,   450,   450,   450,   450,   450,   450,   450,   450,   450,
     450,   450,   450,   450,   450,   450,   450,   450,   450,   450,
     450,   450,   450,   450,   450,   450,   450,   450,   450,   450,
     450,   450,   450,   450,   450,   450,   450,   451,   452,   452,
     452,   453,   453,   453,   453,   453,   453,   453,   453,   453,
     453,   453,   453,   453,   453,   453,   453,   453,   453,   453,
     453,   453,   453,   453,   453,   453,   453,   453,   453,   453,
     453,   453,   453,   453,   453,   453,   453,   453,   453,   453,
     453,   453,   453,   453,   453,   453,   453,   453,   453,   453,
     453,   453,   453,   453,   453,   453,   453,   453,   453,   453,
     453,   453,   453,   453,   453,   453,   453,   453,   453,   453,
     453,   453,   453,   453,   453,   453,   453,   453,   453,   453,
     453,   453,   453,   453,   453,   453,   453,   453,   453,   453,
     453,   453,   453,   453,   453,   453,   453,   453,   453,   453,
     453,   453,   453,   453,   453,   453,   453,   453,   453,   453,
     453,   453,   453,   453,   453,   453,   453,   453,   453,   453,
     453,   453,   453,   453,   453,   453,   453,   453,   453,   453,
     453,   453,   453,   453,   453,   453,   453,   453,   453,   453,
     453,   453,   453,   453,   453,   453,   453,   453,   453,   453,
     453,   453,   453,   453,   453,   453,   454,   453,   453,   455,
     455,   455,   456,   457,   457,   457,   457,   457,   457,   457,
     457,   457,   457
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     2,     1,     2,     1,     1,     1,     1,
       1,     0,     2,     0,     2,     1,     0,     2,     0,     2,
       0,     2,     1,     1,     1,     1,     1,     1,     3,     3,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     3,     5,     3,
       1,     3,     3,     5,     3,     1,     2,     1,     2,     2,
       2,     1,     3,     1,     3,     1,     1,     2,     2,     1,
       3,     1,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     2,     3,     2,     3,     2,
       3,     2,     3,     2,     3,     2,     3,     2,     3,     2,
       3,     2,     3,     2,     3,     2,     3,     2,     3,     2,
       3,     2,     3,     2,     3,     2,     3,     2,     3,     2,
       3,     2,     3,     2,     3,     2,     3,     2,     3,     2,
       3,     2,     3,     2,     3,     2,     3,     2,     3,     2,
       3,     2,     3,     2,     3,     2,     3,     2,     3,     2,
       3,     2,     3,     2,     3,     2,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     2,
       3,     2,     3,     2,     3,     2,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     5,     7,
       9,     5,     7,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     2,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     5,     5,
       5,     5,     5,     5,     5,     5,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     1,     2,     1,     1,
       1,     1,     1,     5,     5,     7,     7,     5,     8,     8,
       2,     2,     2,     2,     3,     3,     8,     8,     2,     2,
       2,     3,     3,     1,     1,     7,     1,     1,     3,     1,
       1,     1,     1,     1,     4,     7,     2,     2,     1,     4,
       7,     2,     1,     1,     0,     5,     2,     2,     0,     8,
       5,     1,     4,     7,     2,     1,     4,     7,     2,     1,
       7,     2,     2,     2,     2,     2,     2,     2,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     3,     3,     3,     2,     3,
       3,     3,     2,     3,     3,     3,     3,     2,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     2,
       3,     3,     3,     2,     3,     3,     1,     3,     1,     3,
       3,     3,     3,     1,     1,     1,     1,     3,     3,     3,
       3,     1,     1,     3,     2,     1,     2,     2,     1,     1,
       1,     2,     2,     1,     2,     3,     5,     1,     4,     5,
       3,     4,     3,     2,     4,     5,     3,     4,     4,     2,
       1,     5,     4,     2,     5,     3,     1,     4,     4,     3,
       1,     0,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     3,     1,     2,     5,     4,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     3,     3,     3,     3,     1,     1,     1,     1,     2,
       2,     2,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     4,     4,     2,
       2,     2,     2,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     4,     4,     2,     3,     1,     1,
       1,     3,     4,     4,     4,     6,     6,     6,     6,     6,
       4,     2,     4,     4,     4,     4,     6,     6,     6,     6,
       6,     4,     2,     4,     4,     4,     4,     6,     6,     6,
       6,     6,     4,     2,     4,     4,     4,     4,     6,     6,
       6,     6,     6,     4,     2,     4,     4,     4,     4,     6,
       6,     6,     6,     6,     4,     2,     4,     4,     6,     2,
       4,     4,     4,     2,     4,     4,     2,     4,     4,     2,
       6,     6,     6,     4,     2,     6,     2,     4,     4,     4,
       2,     4,     4,     4,     2,     4,     4,     2,     4,     4,
       2,     4,     4,     2,     4,     3,     2,     4,     3,     2,
       4,     3,     4,     2,     4,     4,     2,     4,     4,     2,
       4,     4,     2,     4,     4,     2,     4,     4,     2,     4,
       3,     1,     3,     1,     3,     1,     4,     3,     1,     4,
       4,     4,     4,     4,     2,     4,     4,     2,     4,     4,
       2,     3,     1,     3,     1,     3,     1,     3,     1,     6,
       6,     2,     4,     4,     2,     4,     0,     5,     2,     0,
       3,     1,     1,     3,     2,     1,     3,     2,     1,     1,
       3,     2,     1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 3:
#line 631 "core/cfg.y" /* yacc.c:1646  */
    {}
#line 5122 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 4:
#line 632 "core/cfg.y" /* yacc.c:1646  */
    {}
#line 5128 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 5:
#line 633 "core/cfg.y" /* yacc.c:1646  */
    { yyerror(""); YYABORT;}
#line 5134 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 11:
#line 641 "core/cfg.y" /* yacc.c:1646  */
    {rt=REQUEST_ROUTE;}
#line 5140 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 13:
#line 642 "core/cfg.y" /* yacc.c:1646  */
    {rt=FAILURE_ROUTE;}
#line 5146 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 16:
#line 644 "core/cfg.y" /* yacc.c:1646  */
    {rt=BRANCH_ROUTE;}
#line 5152 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 18:
#line 645 "core/cfg.y" /* yacc.c:1646  */
    {rt=ONSEND_ROUTE;}
#line 5158 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 20:
#line 646 "core/cfg.y" /* yacc.c:1646  */
    {rt=EVENT_ROUTE;}
#line 5164 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 24:
#line 651 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[0].ipaddr)){
			tmp=ip_addr2a((yyvsp[0].ipaddr));
			if (tmp==0) {
				LM_CRIT("cfg. parser: bad ip address.\n");
				(yyval.strval)=0;
			} else {
				(yyval.strval)=pkg_malloc(strlen(tmp)+1);
				if ((yyval.strval)==0) {
					PKG_MEM_CRITICAL;
				} else {
					strncpy((yyval.strval), tmp, strlen(tmp)+1);
				}
			}
		}
	}
#line 5185 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 25:
#line 667 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.strval)=pkg_malloc(strlen((yyvsp[0].strval))+1);
		if ((yyval.strval)==0) {
				PKG_MEM_CRITICAL;
		} else {
				strncpy((yyval.strval), (yyvsp[0].strval), strlen((yyvsp[0].strval))+1);
		}
	}
#line 5198 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 26:
#line 675 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[0].strval)){
			(yyval.strval)=pkg_malloc(strlen((yyvsp[0].strval))+1);
			if ((yyval.strval)==0) {
					PKG_MEM_CRITICAL;
			} else {
					strncpy((yyval.strval), (yyvsp[0].strval), strlen((yyvsp[0].strval))+1);
			}
		}
	}
#line 5213 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 27:
#line 689 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.name_l)=mk_name_lst((yyvsp[0].strval), SI_IS_MHOMED); }
#line 5219 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 28:
#line 690 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.name_l)=mk_name_lst((yyvsp[-2].strval), SI_IS_MHOMED);
										if ((yyval.name_l)) (yyval.name_l)->next=(yyvsp[0].name_l);
									}
#line 5227 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 29:
#line 696 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.name_l)=(yyvsp[-1].name_l); }
#line 5233 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 30:
#line 697 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.name_l)=mk_name_lst((yyvsp[0].strval), 0); }
#line 5239 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 31:
#line 701 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=PROTO_UDP; }
#line 5245 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 32:
#line 702 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=PROTO_TCP; }
#line 5251 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 33:
#line 703 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=PROTO_TLS; }
#line 5257 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 34:
#line 704 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=PROTO_SCTP; }
#line 5263 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 35:
#line 705 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=0; }
#line 5269 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 36:
#line 708 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=PROTO_UDP; }
#line 5275 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 37:
#line 709 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=PROTO_TCP; }
#line 5281 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 38:
#line 710 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=PROTO_TLS; }
#line 5287 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 39:
#line 711 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=PROTO_SCTP; }
#line 5293 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 40:
#line 712 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=PROTO_WS; }
#line 5299 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 41:
#line 713 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=PROTO_WSS; }
#line 5305 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 42:
#line 714 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=0; }
#line 5311 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 43:
#line 717 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=(yyvsp[0].intval); }
#line 5317 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 44:
#line 718 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=0; }
#line 5323 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 45:
#line 721 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=mk_listen_id((yyvsp[0].strval), 0, 0); }
#line 5329 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 46:
#line 722 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=mk_listen_id((yyvsp[-2].strval), 0, (yyvsp[0].intval)); }
#line 5335 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 47:
#line 723 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=mk_listen_id((yyvsp[0].strval), (yyvsp[-2].intval), 0); }
#line 5341 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 48:
#line 724 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=mk_listen_id((yyvsp[-2].strval), (yyvsp[-4].intval), (yyvsp[0].intval));}
#line 5347 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 49:
#line 725 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=0; yyerror("port number expected"); }
#line 5353 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 50:
#line 729 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=mk_listen_id2((yyvsp[0].name_l), 0, 0); }
#line 5359 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 51:
#line 730 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=mk_listen_id2((yyvsp[-2].name_l), 0, (yyvsp[0].intval)); }
#line 5365 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 52:
#line 731 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=mk_listen_id2((yyvsp[0].name_l), (yyvsp[-2].intval), 0); }
#line 5371 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 53:
#line 732 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=mk_listen_id2((yyvsp[-2].name_l), (yyvsp[-4].intval), (yyvsp[0].intval));}
#line 5377 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 54:
#line 733 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=0; yyerror("port number expected"); }
#line 5383 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 55:
#line 737 "core/cfg.y" /* yacc.c:1646  */
    {  (yyval.sockid)=(yyvsp[0].sockid) ; }
#line 5389 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 56:
#line 738 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=(yyvsp[-1].sockid);  if ((yyval.sockid)) (yyval.sockid)->next=(yyvsp[0].sockid); }
#line 5395 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 58:
#line 742 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=-(yyvsp[0].intval); }
#line 5401 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 60:
#line 746 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("flag list expected\n"); }
#line 5407 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 63:
#line 752 "core/cfg.y" /* yacc.c:1646  */
    { if (register_flag((yyvsp[0].strval),-1)<0)
								yyerror("register flag failed");
						}
#line 5415 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 64:
#line 755 "core/cfg.y" /* yacc.c:1646  */
    {
						if (register_flag((yyvsp[-2].strval), (yyvsp[0].intval))<0)
								yyerror("register flag failed");
										}
#line 5424 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 65:
#line 761 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.strval)=(yyvsp[0].strval); }
#line 5430 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 66:
#line 762 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.strval)=(yyvsp[0].strval); }
#line 5436 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 68:
#line 767 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("avpflag list expected\n"); }
#line 5442 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 71:
#line 774 "core/cfg.y" /* yacc.c:1646  */
    {
		if (register_avpflag((yyvsp[0].strval))==0)
			yyerror("cannot declare avpflag");
	}
#line 5451 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 72:
#line 780 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.debug=(yyvsp[0].intval); }
#line 5457 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 73:
#line 781 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number  expected"); }
#line 5463 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 74:
#line 782 "core/cfg.y" /* yacc.c:1646  */
    { dont_fork= ! (yyvsp[0].intval); }
#line 5469 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 75:
#line 783 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5475 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 76:
#line 784 "core/cfg.y" /* yacc.c:1646  */
    { set_fork_delay((yyvsp[0].intval)); }
#line 5481 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 77:
#line 785 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 5487 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 78:
#line 786 "core/cfg.y" /* yacc.c:1646  */
    { set_modinit_delay((yyvsp[0].intval)); }
#line 5493 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 79:
#line 787 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 5499 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 80:
#line 788 "core/cfg.y" /* yacc.c:1646  */
    { if (!config_check)  /* if set from cmd line, don't overwrite from yyparse()*/
					if(log_stderr == 0) log_stderr=(yyvsp[0].intval);
				   }
#line 5507 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 81:
#line 791 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5513 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 82:
#line 792 "core/cfg.y" /* yacc.c:1646  */
    {
		if ( (i_tmp=str2facility((yyvsp[0].strval)))==-1)
			yyerror("bad facility (see syslog(3) man page)");
		if (!config_check)
			default_core_cfg.log_facility=i_tmp;
	}
#line 5524 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 83:
#line 798 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("ID expected"); }
#line 5530 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 84:
#line 799 "core/cfg.y" /* yacc.c:1646  */
    { log_name=(yyvsp[0].strval); }
#line 5536 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 85:
#line 800 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 5542 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 86:
#line 801 "core/cfg.y" /* yacc.c:1646  */
    { log_color=(yyvsp[0].intval); }
#line 5548 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 87:
#line 802 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5554 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 88:
#line 803 "core/cfg.y" /* yacc.c:1646  */
    { log_prefix_fmt=(yyvsp[0].strval); }
#line 5560 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 89:
#line 804 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 5566 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 90:
#line 805 "core/cfg.y" /* yacc.c:1646  */
    { log_prefix_mode=(yyvsp[0].intval); }
#line 5572 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 91:
#line 806 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 5578 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 92:
#line 807 "core/cfg.y" /* yacc.c:1646  */
    { _km_log_engine_type=(yyvsp[0].strval); }
#line 5584 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 93:
#line 808 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 5590 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 94:
#line 809 "core/cfg.y" /* yacc.c:1646  */
    { _km_log_engine_data=(yyvsp[0].strval); }
#line 5596 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 95:
#line 810 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 5602 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 96:
#line 811 "core/cfg.y" /* yacc.c:1646  */
    { _ksr_xavp_via_params.s=(yyvsp[0].strval);
			_ksr_xavp_via_params.len=strlen((yyvsp[0].strval));
		}
#line 5610 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 97:
#line 814 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 5616 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 98:
#line 815 "core/cfg.y" /* yacc.c:1646  */
    { _ksr_xavp_via_params.s=(yyvsp[0].strval);
			_ksr_xavp_via_fields.len=strlen((yyvsp[0].strval));
		}
#line 5624 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 99:
#line 818 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 5630 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 100:
#line 819 "core/cfg.y" /* yacc.c:1646  */
    { received_dns|= ((yyvsp[0].intval))?DO_DNS:0; }
#line 5636 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 101:
#line 820 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5642 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 102:
#line 821 "core/cfg.y" /* yacc.c:1646  */
    { received_dns|= ((yyvsp[0].intval))?DO_REV_DNS:0; }
#line 5648 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 103:
#line 822 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5654 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 104:
#line 823 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.dns_try_ipv6=(yyvsp[0].intval); }
#line 5660 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 105:
#line 824 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5666 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 106:
#line 825 "core/cfg.y" /* yacc.c:1646  */
    { IF_NAPTR(default_core_cfg.dns_try_naptr=(yyvsp[0].intval)); }
#line 5672 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 107:
#line 826 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5678 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 108:
#line 827 "core/cfg.y" /* yacc.c:1646  */
    { IF_DNS_FAILOVER(default_core_cfg.dns_srv_lb=(yyvsp[0].intval)); }
#line 5684 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 109:
#line 828 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5690 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 110:
#line 829 "core/cfg.y" /* yacc.c:1646  */
    { IF_NAPTR(default_core_cfg.dns_udp_pref=(yyvsp[0].intval));}
#line 5696 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 111:
#line 830 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 5702 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 112:
#line 831 "core/cfg.y" /* yacc.c:1646  */
    { IF_NAPTR(default_core_cfg.dns_tcp_pref=(yyvsp[0].intval));}
#line 5708 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 113:
#line 832 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 5714 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 114:
#line 833 "core/cfg.y" /* yacc.c:1646  */
    { IF_NAPTR(default_core_cfg.dns_tls_pref=(yyvsp[0].intval));}
#line 5720 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 115:
#line 834 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 5726 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 116:
#line 835 "core/cfg.y" /* yacc.c:1646  */
    {
								IF_NAPTR(default_core_cfg.dns_sctp_pref=(yyvsp[0].intval)); }
#line 5733 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 117:
#line 837 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 5739 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 118:
#line 838 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.dns_retr_time=(yyvsp[0].intval); }
#line 5745 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 119:
#line 839 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 5751 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 120:
#line 840 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.dns_slow_query_ms=(yyvsp[0].intval); }
#line 5757 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 121:
#line 841 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 5763 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 122:
#line 842 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.dns_retr_no=(yyvsp[0].intval); }
#line 5769 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 123:
#line 843 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 5775 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 124:
#line 844 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.dns_servers_no=(yyvsp[0].intval); }
#line 5781 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 125:
#line 845 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 5787 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 126:
#line 846 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.dns_search_list=(yyvsp[0].intval); }
#line 5793 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 127:
#line 847 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5799 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 128:
#line 848 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.dns_search_fmatch=(yyvsp[0].intval); }
#line 5805 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 129:
#line 849 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5811 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 130:
#line 850 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.dns_naptr_ignore_rfc=(yyvsp[0].intval); }
#line 5817 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 131:
#line 851 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5823 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 132:
#line 852 "core/cfg.y" /* yacc.c:1646  */
    { IF_DNS_CACHE(dns_cache_init=(yyvsp[0].intval)); }
#line 5829 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 133:
#line 853 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5835 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 134:
#line 854 "core/cfg.y" /* yacc.c:1646  */
    { IF_DNS_CACHE(default_core_cfg.use_dns_cache=(yyvsp[0].intval)); }
#line 5841 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 135:
#line 855 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5847 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 136:
#line 856 "core/cfg.y" /* yacc.c:1646  */
    { IF_DNS_FAILOVER(default_core_cfg.use_dns_failover=(yyvsp[0].intval));}
#line 5853 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 137:
#line 857 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5859 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 138:
#line 858 "core/cfg.y" /* yacc.c:1646  */
    { IF_DNS_CACHE(default_core_cfg.dns_cache_flags=(yyvsp[0].intval)); }
#line 5865 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 139:
#line 859 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5871 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 140:
#line 860 "core/cfg.y" /* yacc.c:1646  */
    { IF_DNS_CACHE(default_core_cfg.dns_neg_cache_ttl=(yyvsp[0].intval)); }
#line 5877 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 141:
#line 861 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5883 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 142:
#line 862 "core/cfg.y" /* yacc.c:1646  */
    { IF_DNS_CACHE(default_core_cfg.dns_cache_max_ttl=(yyvsp[0].intval)); }
#line 5889 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 143:
#line 863 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5895 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 144:
#line 864 "core/cfg.y" /* yacc.c:1646  */
    { IF_DNS_CACHE(default_core_cfg.dns_cache_min_ttl=(yyvsp[0].intval)); }
#line 5901 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 145:
#line 865 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5907 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 146:
#line 866 "core/cfg.y" /* yacc.c:1646  */
    { IF_DNS_CACHE(default_core_cfg.dns_cache_max_mem=(yyvsp[0].intval)); }
#line 5913 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 147:
#line 867 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5919 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 148:
#line 868 "core/cfg.y" /* yacc.c:1646  */
    { IF_DNS_CACHE(dns_timer_interval=(yyvsp[0].intval)); }
#line 5925 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 149:
#line 869 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5931 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 150:
#line 870 "core/cfg.y" /* yacc.c:1646  */
    { IF_DNS_CACHE(default_core_cfg.dns_cache_del_nonexp=(yyvsp[0].intval)); }
#line 5937 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 151:
#line 871 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5943 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 152:
#line 872 "core/cfg.y" /* yacc.c:1646  */
    { IF_DNS_CACHE(default_core_cfg.dns_cache_rec_pref=(yyvsp[0].intval)); }
#line 5949 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 153:
#line 873 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5955 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 154:
#line 874 "core/cfg.y" /* yacc.c:1646  */
    {IF_AUTO_BIND_IPV6(auto_bind_ipv6 = (yyvsp[0].intval));}
#line 5961 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 155:
#line 875 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5967 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 156:
#line 876 "core/cfg.y" /* yacc.c:1646  */
    {sr_bind_ipv6_link_local = (yyvsp[0].intval);}
#line 5973 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 157:
#line 877 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5979 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 158:
#line 878 "core/cfg.y" /* yacc.c:1646  */
    { IF_DST_BLACKLIST(dst_blacklist_init=(yyvsp[0].intval)); }
#line 5985 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 159:
#line 879 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5991 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 160:
#line 880 "core/cfg.y" /* yacc.c:1646  */
    {
		IF_DST_BLACKLIST(default_core_cfg.use_dst_blacklist=(yyvsp[0].intval));
	}
#line 5999 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 161:
#line 883 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6005 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 162:
#line 884 "core/cfg.y" /* yacc.c:1646  */
    {
		IF_DST_BLACKLIST(default_core_cfg.blst_max_mem=(yyvsp[0].intval));
	}
#line 6013 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 163:
#line 887 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6019 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 164:
#line 888 "core/cfg.y" /* yacc.c:1646  */
    {
		IF_DST_BLACKLIST(default_core_cfg.blst_timeout=(yyvsp[0].intval));
	}
#line 6027 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 165:
#line 891 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6033 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 166:
#line 892 "core/cfg.y" /* yacc.c:1646  */
    { IF_DST_BLACKLIST(blst_timer_interval=(yyvsp[0].intval));}
#line 6039 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 167:
#line 893 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6045 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 168:
#line 894 "core/cfg.y" /* yacc.c:1646  */
    {
		IF_DST_BLACKLIST(default_core_cfg.blst_udp_imask=(yyvsp[0].intval));
	}
#line 6053 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 169:
#line 897 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number(flags) expected"); }
#line 6059 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 170:
#line 898 "core/cfg.y" /* yacc.c:1646  */
    {
		IF_DST_BLACKLIST(default_core_cfg.blst_tcp_imask=(yyvsp[0].intval));
	}
#line 6067 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 171:
#line 901 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number(flags) expected"); }
#line 6073 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 172:
#line 902 "core/cfg.y" /* yacc.c:1646  */
    {
		IF_DST_BLACKLIST(default_core_cfg.blst_tls_imask=(yyvsp[0].intval));
	}
#line 6081 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 173:
#line 905 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number(flags) expected"); }
#line 6087 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 174:
#line 906 "core/cfg.y" /* yacc.c:1646  */
    {
		IF_DST_BLACKLIST(default_core_cfg.blst_sctp_imask=(yyvsp[0].intval));
	}
#line 6095 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 175:
#line 909 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number(flags) expected"); }
#line 6101 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 176:
#line 910 "core/cfg.y" /* yacc.c:1646  */
    { _sr_ip_free_bind=(yyvsp[0].intval); }
#line 6107 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 177:
#line 911 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 6113 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 178:
#line 912 "core/cfg.y" /* yacc.c:1646  */
    { port_no=(yyvsp[0].intval); }
#line 6119 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 179:
#line 913 "core/cfg.y" /* yacc.c:1646  */
    { maxbuffer=(yyvsp[0].intval); }
#line 6125 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 180:
#line 914 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6131 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 181:
#line 915 "core/cfg.y" /* yacc.c:1646  */
    { sql_buffer_size=(yyvsp[0].intval); }
#line 6137 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 182:
#line 916 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6143 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 183:
#line 917 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6149 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 184:
#line 918 "core/cfg.y" /* yacc.c:1646  */
    { children_no=(yyvsp[0].intval); }
#line 6155 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 185:
#line 919 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6161 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 186:
#line 920 "core/cfg.y" /* yacc.c:1646  */
    { ksr_stats_namesep=(yyvsp[0].strval); }
#line 6167 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 187:
#line 921 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 6173 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 188:
#line 922 "core/cfg.y" /* yacc.c:1646  */
    { socket_workers=(yyvsp[0].intval); }
#line 6179 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 189:
#line 923 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6185 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 190:
#line 924 "core/cfg.y" /* yacc.c:1646  */
    { async_task_set_workers((yyvsp[0].intval)); }
#line 6191 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 191:
#line 925 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6197 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 192:
#line 926 "core/cfg.y" /* yacc.c:1646  */
    { async_task_set_usleep((yyvsp[0].intval)); }
#line 6203 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 193:
#line 927 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6209 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 194:
#line 928 "core/cfg.y" /* yacc.c:1646  */
    { async_task_set_nonblock((yyvsp[0].intval)); }
#line 6215 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 195:
#line 929 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6221 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 196:
#line 930 "core/cfg.y" /* yacc.c:1646  */
    { check_via=(yyvsp[0].intval); }
#line 6227 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 197:
#line 931 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6233 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 198:
#line 932 "core/cfg.y" /* yacc.c:1646  */
    { phone2tel=(yyvsp[0].intval); }
#line 6239 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 199:
#line 933 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6245 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 200:
#line 934 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.memlog=(yyvsp[0].intval); }
#line 6251 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 201:
#line 935 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 6257 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 202:
#line 936 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.memdbg=(yyvsp[0].intval); }
#line 6263 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 203:
#line 937 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 6269 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 204:
#line 938 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.mem_summary=(yyvsp[0].intval); }
#line 6275 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 205:
#line 939 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 6281 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 206:
#line 940 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.mem_safety=(yyvsp[0].intval); }
#line 6287 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 207:
#line 941 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 6293 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 208:
#line 942 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.mem_join=(yyvsp[0].intval); }
#line 6299 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 209:
#line 943 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 6305 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 210:
#line 944 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.mem_status_mode=(yyvsp[0].intval); }
#line 6311 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 211:
#line 945 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 6317 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 212:
#line 946 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.corelog=(yyvsp[0].intval); }
#line 6323 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 213:
#line 947 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 6329 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 214:
#line 948 "core/cfg.y" /* yacc.c:1646  */
    { sip_warning=(yyvsp[0].intval); }
#line 6335 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 215:
#line 949 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6341 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 216:
#line 950 "core/cfg.y" /* yacc.c:1646  */
    { version_table.s=(yyvsp[0].strval);
			version_table.len=strlen(version_table.s);
	}
#line 6349 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 217:
#line 953 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 6355 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 218:
#line 954 "core/cfg.y" /* yacc.c:1646  */
    {
		if (shm_initialized())
			yyerror("user must be before any modparam or the"
					" route blocks");
		else if (user==0)
			user=(yyvsp[0].strval);
	}
#line 6367 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 219:
#line 961 "core/cfg.y" /* yacc.c:1646  */
    {
		if (shm_initialized())
			yyerror("user must be before any modparam or the"
					" route blocks");
		else if (user==0)
			user=(yyvsp[0].strval);
	}
#line 6379 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 220:
#line 968 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 6385 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 221:
#line 969 "core/cfg.y" /* yacc.c:1646  */
    { group=(yyvsp[0].strval); }
#line 6391 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 222:
#line 970 "core/cfg.y" /* yacc.c:1646  */
    { group=(yyvsp[0].strval); }
#line 6397 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 223:
#line 971 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 6403 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 224:
#line 972 "core/cfg.y" /* yacc.c:1646  */
    { chroot_dir=(yyvsp[0].strval); }
#line 6409 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 225:
#line 973 "core/cfg.y" /* yacc.c:1646  */
    { chroot_dir=(yyvsp[0].strval); }
#line 6415 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 226:
#line 974 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 6421 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 227:
#line 975 "core/cfg.y" /* yacc.c:1646  */
    { working_dir=(yyvsp[0].strval); }
#line 6427 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 228:
#line 976 "core/cfg.y" /* yacc.c:1646  */
    { working_dir=(yyvsp[0].strval); }
#line 6433 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 229:
#line 977 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 6439 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 230:
#line 978 "core/cfg.y" /* yacc.c:1646  */
    { runtime_dir=(yyvsp[0].strval); }
#line 6445 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 231:
#line 979 "core/cfg.y" /* yacc.c:1646  */
    { runtime_dir=(yyvsp[0].strval); }
#line 6451 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 232:
#line 980 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 6457 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 233:
#line 981 "core/cfg.y" /* yacc.c:1646  */
    { mhomed=(yyvsp[0].intval); }
#line 6463 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 234:
#line 982 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6469 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 235:
#line 983 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_disable=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6481 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 236:
#line 990 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6487 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 237:
#line 991 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.accept_aliases=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6499 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 238:
#line 998 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6505 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 239:
#line 999 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_accept_unique=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6517 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 240:
#line 1006 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6523 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 241:
#line 1007 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_connection_match=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6535 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 242:
#line 1014 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6541 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 243:
#line 1015 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_cfg_children_no=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6553 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 244:
#line 1022 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6559 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 245:
#line 1023 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.connect_timeout_s=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6571 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 246:
#line 1030 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6577 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 247:
#line 1031 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.send_timeout=S_TO_TICKS((yyvsp[0].intval));
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6589 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 248:
#line 1038 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6595 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 249:
#line 1039 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			if ((yyvsp[0].intval)<0)
				tcp_default_cfg.con_lifetime=-1;
			else
				tcp_default_cfg.con_lifetime=S_TO_TICKS((yyvsp[0].intval));
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6610 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 250:
#line 1049 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6616 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 251:
#line 1050 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_poll_method=get_poll_type((yyvsp[0].strval));
			if (tcp_poll_method==POLL_NONE) {
				LOG(L_CRIT, "bad poll method name:"
						" %s\n, try one of %s.\n",
						(yyvsp[0].strval), poll_support);
				yyerror("bad tcp_poll_method "
						"value");
			}
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6635 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 252:
#line 1064 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_poll_method=get_poll_type((yyvsp[0].strval));
			if (tcp_poll_method==POLL_NONE) {
				LOG(L_CRIT, "bad poll method name:"
						" %s\n, try one of %s.\n",
						(yyvsp[0].strval), poll_support);
				yyerror("bad tcp_poll_method "
						"value");
			}
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6654 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 253:
#line 1078 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("poll method name expected"); }
#line 6660 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 254:
#line 1079 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_max_connections=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6672 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 255:
#line 1086 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6678 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 256:
#line 1087 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TLS
			tls_max_connections=(yyvsp[0].intval);
		#else
			warn("tls support not compiled in");
		#endif
	}
#line 6690 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 257:
#line 1094 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6696 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 258:
#line 1095 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.no_connect=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6708 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 259:
#line 1102 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6714 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 260:
#line 1103 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			if (tcp_set_src_addr((yyvsp[0].ipaddr))<0)
				warn("tcp_source_ipv4 failed");
		#else
			warn("tcp support not compiled in");
		#endif
		pkg_free((yyvsp[0].ipaddr));
	}
#line 6728 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 261:
#line 1112 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("IPv4 address expected"); }
#line 6734 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 262:
#line 1113 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
				if (tcp_set_src_addr((yyvsp[0].ipaddr))<0)
					warn("tcp_source_ipv6 failed");
		#else
			warn("tcp support not compiled in");
		#endif
		pkg_free((yyvsp[0].ipaddr));
	}
#line 6748 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 263:
#line 1122 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("IPv6 address expected"); }
#line 6754 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 264:
#line 1123 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.fd_cache=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6766 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 265:
#line 1130 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6772 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 266:
#line 1131 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.async=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6784 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 267:
#line 1138 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6790 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 268:
#line 1139 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.tcpconn_wq_max=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6802 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 269:
#line 1146 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6808 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 270:
#line 1147 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.tcp_wq_max=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6820 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 271:
#line 1154 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6826 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 272:
#line 1155 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.rd_buf_size=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6838 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 273:
#line 1162 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6844 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 274:
#line 1163 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.wq_blk_size=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6856 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 275:
#line 1170 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6862 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 276:
#line 1171 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.defer_accept=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6874 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 277:
#line 1178 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6880 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 278:
#line 1179 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.delayed_ack=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6892 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 279:
#line 1186 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6898 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 280:
#line 1187 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.syncnt=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6910 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 281:
#line 1194 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6916 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 282:
#line 1195 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.linger2=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6928 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 283:
#line 1202 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6934 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 284:
#line 1203 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.keepalive=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6946 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 285:
#line 1210 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected");}
#line 6952 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 286:
#line 1211 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.keepidle=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6964 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 287:
#line 1218 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6970 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 288:
#line 1219 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.keepintvl=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6982 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 289:
#line 1226 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6988 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 290:
#line 1227 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.keepcnt=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7000 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 291:
#line 1234 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7006 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 292:
#line 1235 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.crlf_ping=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7018 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 293:
#line 1242 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7024 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 294:
#line 1243 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.accept_no_cl=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7036 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 295:
#line 1250 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7042 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 296:
#line 1251 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			ksr_tcp_accept_hep3=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7054 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 297:
#line 1258 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7060 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 298:
#line 1259 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			ksr_tcp_accept_haproxy=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7072 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 299:
#line 1266 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7078 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 300:
#line 1268 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_set_clone_rcvbuf((yyvsp[0].intval));
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7090 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 301:
#line 1275 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7096 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 302:
#line 1276 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
		#ifdef SO_REUSEPORT
			tcp_default_cfg.reuse_port=(yyvsp[0].intval);
		#else
			warn("support for SO_REUSEPORT not compiled in");
		#endif
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7112 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 303:
#line 1287 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7118 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 304:
#line 1288 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TLS
			tls_disable=(yyvsp[0].intval);
		#else
			warn("tls support not compiled in");
		#endif
	}
#line 7130 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 305:
#line 1295 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7136 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 306:
#line 1296 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TLS
			tls_disable=!((yyvsp[0].intval));
		#else
			warn("tls support not compiled in");
		#endif
	}
#line 7148 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 307:
#line 1303 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7154 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 308:
#line 1304 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef CORE_TLS
			tls_log=(yyvsp[0].intval);
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7166 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 309:
#line 1311 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 7172 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 310:
#line 1312 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TLS
			tls_port_no=(yyvsp[0].intval);
		#else
			warn("tls support not compiled in");
		#endif
	}
#line 7184 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 311:
#line 1319 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7190 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 312:
#line 1320 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef CORE_TLS
			tls_method=TLS_USE_SSLv23;
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7202 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 313:
#line 1327 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef CORE_TLS
			tls_method=TLS_USE_SSLv2;
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7214 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 314:
#line 1334 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef CORE_TLS
			tls_method=TLS_USE_SSLv3;
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7226 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 315:
#line 1341 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef CORE_TLS
			tls_method=TLS_USE_TLSv1;
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7238 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 316:
#line 1348 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef CORE_TLS
			yyerror("SSLv23, SSLv2, SSLv3 or TLSv1 expected");
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7250 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 317:
#line 1355 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef CORE_TLS
			tls_verify_cert=(yyvsp[0].intval);
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7262 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 318:
#line 1362 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7268 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 319:
#line 1363 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef CORE_TLS
			tls_require_cert=(yyvsp[0].intval);
		#else
			warn( "tls-in-core support not compiled in");
		#endif
	}
#line 7280 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 320:
#line 1370 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7286 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 321:
#line 1371 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef CORE_TLS
			tls_cert_file=(yyvsp[0].strval);
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7298 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 322:
#line 1378 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 7304 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 323:
#line 1379 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef CORE_TLS
			tls_pkey_file=(yyvsp[0].strval);
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7316 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 324:
#line 1386 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 7322 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 325:
#line 1387 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef CORE_TLS
			tls_ca_file=(yyvsp[0].strval);
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7334 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 326:
#line 1394 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 7340 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 327:
#line 1395 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef CORE_TLS
			tls_handshake_timeout=(yyvsp[0].intval);
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7352 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 328:
#line 1402 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7358 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 329:
#line 1403 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef CORE_TLS
			tls_send_timeout=(yyvsp[0].intval);
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7370 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 330:
#line 1410 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7376 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 331:
#line 1411 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_SCTP
			sctp_disable=(yyvsp[0].intval);
		#else
			warn("sctp support not compiled in");
		#endif
	}
#line 7388 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 332:
#line 1418 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7394 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 333:
#line 1419 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_SCTP
			sctp_disable=((yyvsp[0].intval)<=1)?!(yyvsp[0].intval):(yyvsp[0].intval);
		#else
			warn("sctp support not compiled in");
		#endif
	}
#line 7406 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 334:
#line 1426 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean or number expected"); }
#line 7412 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 335:
#line 1427 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_SCTP
			sctp_children_no=(yyvsp[0].intval);
		#else
			warn("sctp support not compiled in");
		#endif
	}
#line 7424 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 336:
#line 1434 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7430 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 337:
#line 1435 "core/cfg.y" /* yacc.c:1646  */
    { server_signature=(yyvsp[0].intval); }
#line 7436 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 338:
#line 1436 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7442 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 339:
#line 1437 "core/cfg.y" /* yacc.c:1646  */
    { server_hdr.s=(yyvsp[0].strval);
			server_hdr.len=strlen(server_hdr.s);
	}
#line 7450 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 340:
#line 1440 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 7456 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 341:
#line 1441 "core/cfg.y" /* yacc.c:1646  */
    { user_agent_hdr.s=(yyvsp[0].strval);
			user_agent_hdr.len=strlen(user_agent_hdr.s);
	}
#line 7464 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 342:
#line 1444 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 7470 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 343:
#line 1445 "core/cfg.y" /* yacc.c:1646  */
    { _sr_uri_host_extra_chars=(yyvsp[0].strval); }
#line 7476 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 344:
#line 1446 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 7482 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 345:
#line 1447 "core/cfg.y" /* yacc.c:1646  */
    { reply_to_via=(yyvsp[0].intval); }
#line 7488 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 346:
#line 1448 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7494 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 347:
#line 1449 "core/cfg.y" /* yacc.c:1646  */
    {
		for(lst_tmp=(yyvsp[0].sockid); lst_tmp; lst_tmp=lst_tmp->next) {
			if (add_listen_iface(	lst_tmp->addr_lst->name,
									lst_tmp->addr_lst->next,
									lst_tmp->port, lst_tmp->proto,
									lst_tmp->flags)!=0) {
				LM_CRIT("cfg. parser: failed to add listen address\n");
				break;
			}
		}
		free_socket_id_lst((yyvsp[0].sockid));
	}
#line 7511 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 348:
#line 1461 "core/cfg.y" /* yacc.c:1646  */
    {
		for(lst_tmp=(yyvsp[-2].sockid); lst_tmp; lst_tmp=lst_tmp->next) {
			if (add_listen_iface_name(lst_tmp->addr_lst->name,
									lst_tmp->addr_lst->next,
									lst_tmp->port, lst_tmp->proto, (yyvsp[0].strval),
									lst_tmp->flags)!=0) {
				LM_CRIT("cfg. parser: failed to add listen address\n");
				break;
			}
		}
		free_socket_id_lst((yyvsp[-2].sockid));
	}
#line 7528 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 349:
#line 1473 "core/cfg.y" /* yacc.c:1646  */
    {
		for(lst_tmp=(yyvsp[-4].sockid); lst_tmp; lst_tmp=lst_tmp->next) {
			if (add_listen_advertise_iface(	lst_tmp->addr_lst->name,
									lst_tmp->addr_lst->next,
									lst_tmp->port, lst_tmp->proto,
									(yyvsp[-2].strval), (yyvsp[0].intval),
									lst_tmp->flags)!=0) {
				LM_CRIT("cfg. parser: failed to add listen address\n");
				break;
			}
		}
		free_socket_id_lst((yyvsp[-4].sockid));
	}
#line 7546 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 350:
#line 1486 "core/cfg.y" /* yacc.c:1646  */
    {
		for(lst_tmp=(yyvsp[-6].sockid); lst_tmp; lst_tmp=lst_tmp->next) {
			if (add_listen_advertise_iface_name(lst_tmp->addr_lst->name,
									lst_tmp->addr_lst->next,
									lst_tmp->port, lst_tmp->proto,
									(yyvsp[-4].strval), (yyvsp[-2].intval), (yyvsp[0].strval),
									lst_tmp->flags)!=0) {
				LM_CRIT("cfg. parser: failed to add listen address\n");
				break;
			}
		}
		free_socket_id_lst((yyvsp[-6].sockid));
	}
#line 7564 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 351:
#line 1499 "core/cfg.y" /* yacc.c:1646  */
    {
		for(lst_tmp=(yyvsp[-2].sockid); lst_tmp; lst_tmp=lst_tmp->next) {
			if (add_listen_advertise_iface(	lst_tmp->addr_lst->name,
									lst_tmp->addr_lst->next,
									lst_tmp->port, lst_tmp->proto,
									(yyvsp[0].strval), 0,
									lst_tmp->flags)!=0) {
				LM_CRIT("cfg. parser: failed to add listen address\n");
				break;
			}
		}
		free_socket_id_lst((yyvsp[-2].sockid));
	}
#line 7582 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 352:
#line 1512 "core/cfg.y" /* yacc.c:1646  */
    {
		for(lst_tmp=(yyvsp[-4].sockid); lst_tmp; lst_tmp=lst_tmp->next) {
			if (add_listen_advertise_iface_name(lst_tmp->addr_lst->name,
									lst_tmp->addr_lst->next,
									lst_tmp->port, lst_tmp->proto,
									(yyvsp[-2].strval), 0, (yyvsp[0].strval),
									lst_tmp->flags)!=0) {
				LM_CRIT("cfg. parser: failed to add listen address\n");
				break;
			}
		}
		free_socket_id_lst((yyvsp[-4].sockid));
	}
#line 7600 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 353:
#line 1525 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("ip address, interface name or"
									" hostname expected"); }
#line 7607 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 354:
#line 1527 "core/cfg.y" /* yacc.c:1646  */
    {
		for(lst_tmp=(yyvsp[0].sockid); lst_tmp; lst_tmp=lst_tmp->next){
			add_alias(	lst_tmp->addr_lst->name,
						strlen(lst_tmp->addr_lst->name),
						lst_tmp->port, lst_tmp->proto);
			for (nl_tmp=lst_tmp->addr_lst->next; nl_tmp; nl_tmp=nl_tmp->next)
				add_alias(nl_tmp->name, strlen(nl_tmp->name),
							lst_tmp->port, lst_tmp->proto);
		}
		free_socket_id_lst((yyvsp[0].sockid));
	}
#line 7623 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 355:
#line 1538 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("hostname expected"); }
#line 7629 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 356:
#line 1539 "core/cfg.y" /* yacc.c:1646  */
    { sr_auto_aliases=(yyvsp[0].intval); }
#line 7635 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 357:
#line 1540 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7641 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 358:
#line 1541 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[0].strval)){
			default_global_address.s=(yyvsp[0].strval);
			default_global_address.len=strlen((yyvsp[0].strval));
		}
	}
#line 7652 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 359:
#line 1547 "core/cfg.y" /* yacc.c:1646  */
    {yyerror("ip address or hostname expected"); }
#line 7658 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 360:
#line 1548 "core/cfg.y" /* yacc.c:1646  */
    {
		tmp=int2str((yyvsp[0].intval), &i_tmp);
		if ((default_global_port.s=pkg_malloc(i_tmp))==0) {
			PKG_MEM_CRITICAL;
			default_global_port.len=0;
		} else {
			default_global_port.len=i_tmp;
			memcpy(default_global_port.s, tmp, default_global_port.len);
		};
	}
#line 7673 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 361:
#line 1558 "core/cfg.y" /* yacc.c:1646  */
    {yyerror("ip address or hostname expected"); }
#line 7679 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 362:
#line 1559 "core/cfg.y" /* yacc.c:1646  */
    { disable_core_dump=(yyvsp[0].intval); }
#line 7685 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 363:
#line 1560 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7691 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 364:
#line 1561 "core/cfg.y" /* yacc.c:1646  */
    { open_files_limit=(yyvsp[0].intval); }
#line 7697 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 365:
#line 1562 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7703 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 366:
#line 1563 "core/cfg.y" /* yacc.c:1646  */
    {
		if (shm_initialized())
			yyerror("shm/shm_mem_size must be before any modparam or the"
					" route blocks");
		else if (shm_mem_size == 0 || shm_mem_size == SHM_MEM_POOL_SIZE)
			shm_mem_size=(yyvsp[0].intval) * 1024 * 1024;
	}
#line 7715 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 367:
#line 1570 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7721 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 368:
#line 1571 "core/cfg.y" /* yacc.c:1646  */
    {
		if (shm_initialized())
			yyerror("shm_force_alloc must be before any modparam or the"
					" route blocks");
		else
			shm_force_alloc=(yyvsp[0].intval);
	}
#line 7733 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 369:
#line 1578 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7739 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 370:
#line 1579 "core/cfg.y" /* yacc.c:1646  */
    { mlock_pages=(yyvsp[0].intval); }
#line 7745 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 371:
#line 1580 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7751 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 372:
#line 1581 "core/cfg.y" /* yacc.c:1646  */
    { real_time=(yyvsp[0].intval); }
#line 7757 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 373:
#line 1582 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7763 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 374:
#line 1583 "core/cfg.y" /* yacc.c:1646  */
    { rt_prio=(yyvsp[0].intval); }
#line 7769 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 375:
#line 1584 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7775 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 376:
#line 1585 "core/cfg.y" /* yacc.c:1646  */
    { rt_policy=(yyvsp[0].intval); }
#line 7781 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 377:
#line 1586 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7787 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 378:
#line 1587 "core/cfg.y" /* yacc.c:1646  */
    { rt_timer1_prio=(yyvsp[0].intval); }
#line 7793 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 379:
#line 1588 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7799 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 380:
#line 1589 "core/cfg.y" /* yacc.c:1646  */
    { rt_timer1_policy=(yyvsp[0].intval); }
#line 7805 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 381:
#line 1590 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7811 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 382:
#line 1591 "core/cfg.y" /* yacc.c:1646  */
    { rt_timer2_prio=(yyvsp[0].intval); }
#line 7817 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 383:
#line 1592 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7823 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 384:
#line 1593 "core/cfg.y" /* yacc.c:1646  */
    { rt_timer2_policy=(yyvsp[0].intval); }
#line 7829 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 385:
#line 1594 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7835 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 386:
#line 1595 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_MCAST
			mcast_loopback=(yyvsp[0].intval);
		#else
			warn("no multicast support compiled in");
		#endif
	}
#line 7847 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 387:
#line 1602 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7853 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 388:
#line 1603 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_MCAST
			mcast_ttl=(yyvsp[0].intval);
		#else
			warn("no multicast support compiled in");
		#endif
	}
#line 7865 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 389:
#line 1610 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7871 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 390:
#line 1611 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_MCAST
			mcast=(yyvsp[0].strval);
		#else
			warn("no multicast support compiled in");
		#endif
	}
#line 7883 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 391:
#line 1618 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_MCAST
			mcast=(yyvsp[0].strval);
		#else
			warn("no multicast support compiled in");
		#endif
	}
#line 7895 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 392:
#line 1625 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string expected"); }
#line 7901 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 393:
#line 1626 "core/cfg.y" /* yacc.c:1646  */
    { tos=(yyvsp[0].intval); }
#line 7907 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 394:
#line 1627 "core/cfg.y" /* yacc.c:1646  */
    { if (strcasecmp((yyvsp[0].strval),"IPTOS_LOWDELAY")) {
			tos=IPTOS_LOWDELAY;
		} else if (strcasecmp((yyvsp[0].strval),"IPTOS_THROUGHPUT")) {
			tos=IPTOS_THROUGHPUT;
		} else if (strcasecmp((yyvsp[0].strval),"IPTOS_RELIABILITY")) {
			tos=IPTOS_RELIABILITY;
#if defined(IPTOS_MINCOST)
		} else if (strcasecmp((yyvsp[0].strval),"IPTOS_MINCOST")) {
			tos=IPTOS_MINCOST;
#endif
#if defined(IPTOS_LOWCOST)
		} else if (strcasecmp((yyvsp[0].strval),"IPTOS_LOWCOST")) {
			tos=IPTOS_LOWCOST;
#endif
		} else {
			yyerror("invalid tos value - allowed: "
				"IPTOS_LOWDELAY,IPTOS_THROUGHPUT,"
				"IPTOS_RELIABILITY"
#if defined(IPTOS_LOWCOST)
				",IPTOS_LOWCOST"
#endif
#if !defined(IPTOS_MINCOST)
				",IPTOS_MINCOST"
#endif
				"\n");
		}
	}
#line 7939 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 395:
#line 1654 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7945 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 396:
#line 1655 "core/cfg.y" /* yacc.c:1646  */
    { pmtu_discovery=(yyvsp[0].intval); }
#line 7951 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 397:
#line 1656 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7957 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 398:
#line 1657 "core/cfg.y" /* yacc.c:1646  */
    { ser_kill_timeout=(yyvsp[0].intval); }
#line 7963 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 399:
#line 1658 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7969 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 400:
#line 1659 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.max_while_loops=(yyvsp[0].intval); }
#line 7975 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 401:
#line 1660 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7981 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 402:
#line 1661 "core/cfg.y" /* yacc.c:1646  */
    { pv_set_buffer_size((yyvsp[0].intval)); }
#line 7987 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 403:
#line 1662 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7993 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 404:
#line 1663 "core/cfg.y" /* yacc.c:1646  */
    { pv_set_buffer_slots((yyvsp[0].intval)); }
#line 7999 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 405:
#line 1664 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 8005 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 406:
#line 1665 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.pv_cache_limit=(yyvsp[0].intval); }
#line 8011 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 407:
#line 1666 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 8017 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 408:
#line 1667 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.pv_cache_action=(yyvsp[0].intval); }
#line 8023 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 409:
#line 1668 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 8029 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 410:
#line 1669 "core/cfg.y" /* yacc.c:1646  */
    { http_reply_parse=(yyvsp[0].intval); }
#line 8035 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 411:
#line 1670 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 8041 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 412:
#line 1671 "core/cfg.y" /* yacc.c:1646  */
    { ksr_verbose_startup=(yyvsp[0].intval); }
#line 8047 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 413:
#line 1672 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 8053 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 414:
#line 1673 "core/cfg.y" /* yacc.c:1646  */
    { ksr_route_locks_size=(yyvsp[0].intval); }
#line 8059 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 415:
#line 1674 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 8065 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 416:
#line 1675 "core/cfg.y" /* yacc.c:1646  */
    { server_id=(yyvsp[0].intval); }
#line 8071 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 417:
#line 1676 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 8077 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 418:
#line 1677 "core/cfg.y" /* yacc.c:1646  */
    {
			kemi_onsend_route_callback.s = (yyvsp[0].strval);
			kemi_onsend_route_callback.len = strlen((yyvsp[0].strval));
			if(kemi_onsend_route_callback.len==4
					&& strcasecmp(kemi_onsend_route_callback.s, "none")==0) {
				kemi_onsend_route_callback.s = "";
				kemi_onsend_route_callback.len = 0;
			}
		}
#line 8091 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 419:
#line 1686 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string expected"); }
#line 8097 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 420:
#line 1687 "core/cfg.y" /* yacc.c:1646  */
    {
			kemi_reply_route_callback.s = (yyvsp[0].strval);
			kemi_reply_route_callback.len = strlen((yyvsp[0].strval));
			if(kemi_reply_route_callback.len==4
					&& strcasecmp(kemi_reply_route_callback.s, "none")==0) {
				kemi_reply_route_callback.s = "";
				kemi_reply_route_callback.len = 0;
			}
		}
#line 8111 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 421:
#line 1696 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string expected"); }
#line 8117 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 422:
#line 1697 "core/cfg.y" /* yacc.c:1646  */
    {
			kemi_event_route_callback.s = (yyvsp[0].strval);
			kemi_event_route_callback.len = strlen((yyvsp[0].strval));
			if(kemi_event_route_callback.len==4
					&& strcasecmp(kemi_event_route_callback.s, "none")==0) {
				kemi_event_route_callback.s = "";
				kemi_event_route_callback.len = 0;
			}
		}
#line 8131 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 423:
#line 1706 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string expected"); }
#line 8137 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 424:
#line 1707 "core/cfg.y" /* yacc.c:1646  */
    {
			kemi_received_route_callback.s = (yyvsp[0].strval);
			kemi_received_route_callback.len = strlen((yyvsp[0].strval));
			if(kemi_received_route_callback.len==4
					&& strcasecmp(kemi_received_route_callback.s, "none")==0) {
				kemi_received_route_callback.s = "";
				kemi_received_route_callback.len = 0;
			}
		}
#line 8151 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 425:
#line 1716 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string expected"); }
#line 8157 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 426:
#line 1717 "core/cfg.y" /* yacc.c:1646  */
    { ksr_evrt_received_mode=(yyvsp[0].intval); }
#line 8163 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 427:
#line 1718 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number  expected"); }
#line 8169 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 428:
#line 1719 "core/cfg.y" /* yacc.c:1646  */
    { set_max_recursive_level((yyvsp[0].intval)); }
#line 8175 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 429:
#line 1720 "core/cfg.y" /* yacc.c:1646  */
    { sr_dst_max_branches = (yyvsp[0].intval); }
#line 8181 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 430:
#line 1721 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.latency_log=(yyvsp[0].intval); }
#line 8187 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 431:
#line 1722 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number  expected"); }
#line 8193 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 432:
#line 1723 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.latency_cfg_log=(yyvsp[0].intval); }
#line 8199 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 433:
#line 1724 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number  expected"); }
#line 8205 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 434:
#line 1725 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.latency_limit_db=(yyvsp[0].intval); }
#line 8211 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 435:
#line 1726 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number  expected"); }
#line 8217 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 436:
#line 1727 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.latency_limit_action=(yyvsp[0].intval); }
#line 8223 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 437:
#line 1728 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number  expected"); }
#line 8229 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 438:
#line 1729 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.latency_limit_cfg=(yyvsp[0].intval); }
#line 8235 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 439:
#line 1730 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number  expected"); }
#line 8241 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 440:
#line 1731 "core/cfg.y" /* yacc.c:1646  */
    { sr_msg_time=(yyvsp[0].intval); }
#line 8247 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 441:
#line 1732 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number  expected"); }
#line 8253 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 442:
#line 1733 "core/cfg.y" /* yacc.c:1646  */
    { onsend_route_reply=(yyvsp[0].intval); }
#line 8259 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 443:
#line 1734 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 8265 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 444:
#line 1735 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.udp_mtu=(yyvsp[0].intval); }
#line 8271 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 445:
#line 1736 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 8277 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 446:
#line 1738 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.force_rport=(yyvsp[0].intval); fix_global_req_flags(0, 0); }
#line 8283 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 447:
#line 1739 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 8289 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 448:
#line 1741 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.udp_mtu_try_proto=(yyvsp[0].intval); fix_global_req_flags(0, 0); }
#line 8295 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 449:
#line 1743 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("TCP, TLS, SCTP or UDP expected"); }
#line 8301 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 450:
#line 1744 "core/cfg.y" /* yacc.c:1646  */
    { IF_RAW_SOCKS(default_core_cfg.udp4_raw=(yyvsp[0].intval)); }
#line 8307 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 451:
#line 1745 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 8313 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 452:
#line 1746 "core/cfg.y" /* yacc.c:1646  */
    {
		IF_RAW_SOCKS(default_core_cfg.udp4_raw_mtu=(yyvsp[0].intval));
	}
#line 8321 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 453:
#line 1749 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 8327 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 454:
#line 1750 "core/cfg.y" /* yacc.c:1646  */
    {
		IF_RAW_SOCKS(default_core_cfg.udp4_raw_ttl=(yyvsp[0].intval));
	}
#line 8335 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 455:
#line 1753 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 8341 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 457:
#line 1755 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("unknown config variable"); }
#line 8347 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 459:
#line 1759 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.strval)="default" ; }
#line 8353 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 461:
#line 1763 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.strval)="default" ; }
#line 8359 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 462:
#line 1764 "core/cfg.y" /* yacc.c:1646  */
    {
		yyerror("cfg var field name - use of number or reserved token not allowed: %s",
				yy_number_str);
		YYERROR;
	}
#line 8369 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 463:
#line 1772 "core/cfg.y" /* yacc.c:1646  */
    {
		if (cfg_declare_int((yyvsp[-4].strval), (yyvsp[-2].strval), (yyvsp[0].intval), 0, 0, NULL)) {
			yyerror("variable cannot be declared");
		}
	}
#line 8379 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 464:
#line 1777 "core/cfg.y" /* yacc.c:1646  */
    {
		if (cfg_declare_str((yyvsp[-4].strval), (yyvsp[-2].strval), (yyvsp[0].strval), NULL)) {
			yyerror("variable cannot be declared");
		}
	}
#line 8389 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 465:
#line 1782 "core/cfg.y" /* yacc.c:1646  */
    {
		if (cfg_declare_int((yyvsp[-6].strval), (yyvsp[-4].strval), (yyvsp[-2].intval), 0, 0, (yyvsp[0].strval))) {
			yyerror("variable cannot be declared");
		}
	}
#line 8399 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 466:
#line 1787 "core/cfg.y" /* yacc.c:1646  */
    {
		if (cfg_declare_str((yyvsp[-6].strval), (yyvsp[-4].strval), (yyvsp[-2].strval), (yyvsp[0].strval))) {
			yyerror("variable cannot be declared");
		}
	}
#line 8409 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 467:
#line 1792 "core/cfg.y" /* yacc.c:1646  */
    {
		yyerror("number or string expected");
	}
#line 8417 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 468:
#line 1795 "core/cfg.y" /* yacc.c:1646  */
    {
		if (cfg_ginst_var_int((yyvsp[-7].strval), (yyvsp[-5].intval), (yyvsp[-2].strval), (yyvsp[0].intval))) {
			yyerror("variable cannot be added to the group instance");
		}
	}
#line 8427 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 469:
#line 1800 "core/cfg.y" /* yacc.c:1646  */
    {
		if (cfg_ginst_var_string((yyvsp[-7].strval), (yyvsp[-5].intval), (yyvsp[-2].strval), (yyvsp[0].strval))) {
			yyerror("variable cannot be added to the group instance");
		}
	}
#line 8437 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 470:
#line 1808 "core/cfg.y" /* yacc.c:1646  */
    {
		LM_DBG("loading module %s\n", (yyvsp[0].strval));
			if (load_module((yyvsp[0].strval))!=0) {
				yyerror("failed to load module");
			}
	}
#line 8448 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 471:
#line 1814 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string expected"); }
#line 8454 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 472:
#line 1815 "core/cfg.y" /* yacc.c:1646  */
    {
		if(mods_dir_cmd==0) {
			LM_DBG("loading modules under %s\n", (yyvsp[0].strval));
			printf("loading modules under config path: %s\n", (yyvsp[0].strval));
			mods_dir = (yyvsp[0].strval);
		} else {
			LM_DBG("ignoring mod path given in config: %s\n", (yyvsp[0].strval));
			printf("loading modules under command line path: %s\n", mods_dir);
		}
	}
#line 8469 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 473:
#line 1825 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string expected"); }
#line 8475 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 474:
#line 1826 "core/cfg.y" /* yacc.c:1646  */
    {
		if(mods_dir_cmd==0) {
			LM_DBG("loading modules under %s\n", (yyvsp[0].strval));
			printf("loading modules under config path: %s\n", (yyvsp[0].strval));
			mods_dir = (yyvsp[0].strval);
		} else {
			LM_DBG("ignoring mod path given in config: %s\n", (yyvsp[0].strval));
			printf("loading modules under command line path: %s\n", mods_dir);
		}
	}
#line 8490 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 475:
#line 1836 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string expected"); }
#line 8496 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 476:
#line 1837 "core/cfg.y" /* yacc.c:1646  */
    {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		if (set_mod_param_regex((yyvsp[-5].strval), (yyvsp[-3].strval), PARAM_STRING, (yyvsp[-1].strval)) != 0) {
			 yyerror("Can't set module parameter");
		}
	}
#line 8510 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 477:
#line 1846 "core/cfg.y" /* yacc.c:1646  */
    {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		if (set_mod_param_regex((yyvsp[-5].strval), (yyvsp[-3].strval), PARAM_INT, (void*)(yyvsp[-1].intval)) != 0) {
			 yyerror("Can't set module parameter");
		}
	}
#line 8524 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 478:
#line 1855 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("Invalid arguments"); }
#line 8530 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 479:
#line 1856 "core/cfg.y" /* yacc.c:1646  */
    {
		if(sr_kemi_eng_setz((yyvsp[0].strval), NULL)) {
			yyerror("Can't set config routing engine");
			YYABORT;
		}
	}
#line 8541 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 480:
#line 1862 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string expected"); }
#line 8547 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 481:
#line 1863 "core/cfg.y" /* yacc.c:1646  */
    {
		if(sr_kemi_eng_setz((yyvsp[0].strval), NULL)) {
			yyerror("Can't set config routing engine");
			YYABORT;
		}
	}
#line 8558 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 482:
#line 1869 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string expected"); }
#line 8564 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 483:
#line 1873 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.ipaddr)=(yyvsp[0].ipaddr); }
#line 8570 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 484:
#line 1874 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.ipaddr)=(yyvsp[0].ipaddr); }
#line 8576 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 485:
#line 1877 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.ipaddr)=pkg_malloc(sizeof(struct ip_addr));
		if ((yyval.ipaddr)==0) {
			PKG_MEM_CRITICAL;
		} else {
			memset((yyval.ipaddr), 0, sizeof(struct ip_addr));
			(yyval.ipaddr)->af=AF_INET;
			(yyval.ipaddr)->len=4;
			if (((yyvsp[-6].intval)>255) || ((yyvsp[-6].intval)<0) ||
				((yyvsp[-4].intval)>255) || ((yyvsp[-4].intval)<0) ||
				((yyvsp[-2].intval)>255) || ((yyvsp[-2].intval)<0) ||
				((yyvsp[0].intval)>255) || ((yyvsp[0].intval)<0)) {
				yyerror("invalid ipv4 address");
				(yyval.ipaddr)->u.addr32[0]=0;
				/* $$=0; */
			} else {
				(yyval.ipaddr)->u.addr[0]=(yyvsp[-6].intval);
				(yyval.ipaddr)->u.addr[1]=(yyvsp[-4].intval);
				(yyval.ipaddr)->u.addr[2]=(yyvsp[-2].intval);
				(yyval.ipaddr)->u.addr[3]=(yyvsp[0].intval);
				/*
				$$=htonl( ($1<<24)|
				($3<<16)| ($5<<8)|$7 );
				*/
			}
		}
	}
#line 8608 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 486:
#line 1906 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.ipaddr)=pkg_malloc(sizeof(struct ip_addr));
		if ((yyval.ipaddr)==0) {
			PKG_MEM_CRITICAL;
		} else {
			memset((yyval.ipaddr), 0, sizeof(struct ip_addr));
			(yyval.ipaddr)->af=AF_INET6;
			(yyval.ipaddr)->len=16;
			if (inet_pton(AF_INET6, (yyvsp[0].strval), (yyval.ipaddr)->u.addr)<=0) {
				yyerror("bad ipv6 address");
			}
		}
	}
#line 8626 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 487:
#line 1921 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.ipaddr)=(yyvsp[0].ipaddr); }
#line 8632 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 488:
#line 1922 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.ipaddr)=(yyvsp[-1].ipaddr); }
#line 8638 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 489:
#line 1926 "core/cfg.y" /* yacc.c:1646  */
    {
					tmp=int2str((yyvsp[0].intval), &i_tmp);
					if (((yyval.strval)=pkg_malloc(i_tmp+1))==0) {
						yyerror("out of  memory");
						YYABORT;
					} else {
						memcpy((yyval.strval), tmp, i_tmp);
						(yyval.strval)[i_tmp]=0;
					}
					routename = tmp;
						}
#line 8654 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 490:
#line 1937 "core/cfg.y" /* yacc.c:1646  */
    { routename = (yyvsp[0].strval); (yyval.strval)=(yyvsp[0].strval); }
#line 8660 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 491:
#line 1938 "core/cfg.y" /* yacc.c:1646  */
    { routename = (yyvsp[0].strval); (yyval.strval)=(yyvsp[0].strval); }
#line 8666 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 492:
#line 1942 "core/cfg.y" /* yacc.c:1646  */
    { routename=NULL; }
#line 8672 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 493:
#line 1943 "core/cfg.y" /* yacc.c:1646  */
    { routename=NULL; }
#line 8678 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 494:
#line 1947 "core/cfg.y" /* yacc.c:1646  */
    {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		push((yyvsp[-1].action), &main_rt.rlist[DEFAULT_RT]);
	}
#line 8690 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 495:
#line 1954 "core/cfg.y" /* yacc.c:1646  */
    {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		i_tmp=route_get(&main_rt, (yyvsp[-4].strval));
		if (i_tmp==-1){
			yyerror("internal error");
			YYABORT;
		}
		if (main_rt.rlist[i_tmp]){
			yyerror("duplicate route");
			YYABORT;
		}
		push((yyvsp[-1].action), &main_rt.rlist[i_tmp]);
	}
#line 8711 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 496:
#line 1970 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("invalid  route  statement"); }
#line 8717 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 497:
#line 1971 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("invalid  request_route  statement"); }
#line 8723 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 498:
#line 1974 "core/cfg.y" /* yacc.c:1646  */
    { routename=NULL; }
#line 8729 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 499:
#line 1977 "core/cfg.y" /* yacc.c:1646  */
    {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		push((yyvsp[-1].action), &failure_rt.rlist[DEFAULT_RT]);
	}
#line 8741 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 500:
#line 1984 "core/cfg.y" /* yacc.c:1646  */
    {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		i_tmp=route_get(&failure_rt, (yyvsp[-4].strval));
		if (i_tmp==-1){
			yyerror("internal error");
			YYABORT;
		}
		if (failure_rt.rlist[i_tmp]){
			yyerror("duplicate route");
			YYABORT;
		}
		push((yyvsp[-1].action), &failure_rt.rlist[i_tmp]);
	}
#line 8762 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 501:
#line 2000 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("invalid failure_route statement"); }
#line 8768 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 502:
#line 2004 "core/cfg.y" /* yacc.c:1646  */
    { routename=NULL; }
#line 8774 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 503:
#line 2005 "core/cfg.y" /* yacc.c:1646  */
    { routename=NULL; }
#line 8780 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 504:
#line 2010 "core/cfg.y" /* yacc.c:1646  */
    {rt=CORE_ONREPLY_ROUTE;}
#line 8786 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 505:
#line 2010 "core/cfg.y" /* yacc.c:1646  */
    {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		push((yyvsp[-1].action), &onreply_rt.rlist[DEFAULT_RT]);
	}
#line 8798 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 506:
#line 2017 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("invalid onreply_route statement"); }
#line 8804 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 507:
#line 2018 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("invalid onreply_route statement"); }
#line 8810 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 508:
#line 2020 "core/cfg.y" /* yacc.c:1646  */
    {rt=(*(yyvsp[-1].strval)=='0' && (yyvsp[-1].strval)[1]==0)?CORE_ONREPLY_ROUTE:TM_ONREPLY_ROUTE;}
#line 8816 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 509:
#line 2021 "core/cfg.y" /* yacc.c:1646  */
    {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		if (*(yyvsp[-5].strval)=='0' && (yyvsp[-5].strval)[1]==0){
			/* onreply_route[0] {} is equivalent with onreply_route {}*/
			push((yyvsp[-1].action), &onreply_rt.rlist[DEFAULT_RT]);
		}else{
			i_tmp=route_get(&onreply_rt, (yyvsp[-5].strval));
			if (i_tmp==-1){
				yyerror("internal error");
				YYABORT;
			}
			if (onreply_rt.rlist[i_tmp]){
				yyerror("duplicate route");
				YYABORT;
			}
			push((yyvsp[-1].action), &onreply_rt.rlist[i_tmp]);
		}
	}
#line 8842 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 510:
#line 2042 "core/cfg.y" /* yacc.c:1646  */
    {
		yyerror("invalid onreply_route statement");
	}
#line 8850 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 511:
#line 2047 "core/cfg.y" /* yacc.c:1646  */
    { routename=NULL; }
#line 8856 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 512:
#line 2050 "core/cfg.y" /* yacc.c:1646  */
    {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		push((yyvsp[-1].action), &branch_rt.rlist[DEFAULT_RT]);
	}
#line 8868 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 513:
#line 2057 "core/cfg.y" /* yacc.c:1646  */
    {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		i_tmp=route_get(&branch_rt, (yyvsp[-4].strval));
		if (i_tmp==-1){
			yyerror("internal error");
			YYABORT;
		}
		if (branch_rt.rlist[i_tmp]){
			yyerror("duplicate route");
			YYABORT;
		}
		push((yyvsp[-1].action), &branch_rt.rlist[i_tmp]);
	}
#line 8889 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 514:
#line 2073 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("invalid branch_route statement"); }
#line 8895 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 515:
#line 2076 "core/cfg.y" /* yacc.c:1646  */
    { routename=NULL; }
#line 8901 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 516:
#line 2079 "core/cfg.y" /* yacc.c:1646  */
    {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		push((yyvsp[-1].action), &onsend_rt.rlist[DEFAULT_RT]);
	}
#line 8913 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 517:
#line 2086 "core/cfg.y" /* yacc.c:1646  */
    {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		i_tmp=route_get(&onsend_rt, (yyvsp[-4].strval));
		if (i_tmp==-1){
			yyerror("internal error");
			YYABORT;
		}
		if (onsend_rt.rlist[i_tmp]){
			yyerror("duplicate route");
			YYABORT;
		}
		push((yyvsp[-1].action), &onsend_rt.rlist[i_tmp]);
	}
#line 8934 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 518:
#line 2102 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("invalid onsend_route statement"); }
#line 8940 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 519:
#line 2105 "core/cfg.y" /* yacc.c:1646  */
    { routename=NULL; }
#line 8946 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 520:
#line 2108 "core/cfg.y" /* yacc.c:1646  */
    {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		i_tmp=route_get(&event_rt, (yyvsp[-4].strval));
		if (i_tmp==-1){
			yyerror("internal error");
			YYABORT;
		}
		if (event_rt.rlist[i_tmp]){
			yyerror("duplicate route");
			YYABORT;
		}
		push((yyvsp[-1].action), &event_rt.rlist[i_tmp]);
	}
#line 8967 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 521:
#line 2125 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("invalid event_route statement"); }
#line 8973 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 522:
#line 2128 "core/cfg.y" /* yacc.c:1646  */
    { if(pp_subst_add((yyvsp[0].strval))<0) YYERROR; }
#line 8979 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 523:
#line 2129 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("invalid subst preprocess statement"); }
#line 8985 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 524:
#line 2130 "core/cfg.y" /* yacc.c:1646  */
    { if(pp_substdef_add((yyvsp[0].strval), 0)<0) YYERROR; }
#line 8991 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 525:
#line 2131 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("invalid substdef preprocess statement"); }
#line 8997 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 526:
#line 2132 "core/cfg.y" /* yacc.c:1646  */
    { if(pp_substdef_add((yyvsp[0].strval), 1)<0) YYERROR; }
#line 9003 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 527:
#line 2133 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("invalid substdefs preprocess statement"); }
#line 9009 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 528:
#line 2155 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=EQUAL_OP; }
#line 9015 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 529:
#line 2156 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=DIFF_OP; }
#line 9021 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 530:
#line 2157 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=EQUAL_OP; }
#line 9027 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 531:
#line 2158 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=DIFF_OP; }
#line 9033 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 532:
#line 2161 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=GT_OP; }
#line 9039 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 533:
#line 2162 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=LT_OP; }
#line 9045 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 534:
#line 2163 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=GTE_OP; }
#line 9051 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 535:
#line 2164 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=LTE_OP; }
#line 9057 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 536:
#line 2167 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=(yyvsp[0].intval); }
#line 9063 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 537:
#line 2168 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=MATCH_OP; }
#line 9069 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 538:
#line 2174 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=RVE_EQ_OP; }
#line 9075 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 539:
#line 2175 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=RVE_DIFF_OP; }
#line 9081 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 540:
#line 2176 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=RVE_IEQ_OP; }
#line 9087 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 541:
#line 2177 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=RVE_IDIFF_OP; }
#line 9093 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 542:
#line 2178 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=RVE_STREQ_OP; }
#line 9099 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 543:
#line 2179 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=RVE_STRDIFF_OP; }
#line 9105 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 544:
#line 2180 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=RVE_MATCH_OP; }
#line 9111 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 545:
#line 2183 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=RVE_GT_OP; }
#line 9117 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 546:
#line 2184 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=RVE_LT_OP; }
#line 9123 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 547:
#line 2185 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=RVE_GTE_OP; }
#line 9129 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 548:
#line 2186 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=RVE_LTE_OP; }
#line 9135 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 549:
#line 2193 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=URI_O;}
#line 9141 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 550:
#line 2194 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=FROM_URI_O;}
#line 9147 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 551:
#line 2195 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=TO_URI_O;}
#line 9153 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 552:
#line 2202 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=SNDPORT_O; }
#line 9159 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 553:
#line 2203 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=TOPORT_O; }
#line 9165 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 554:
#line 2204 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=SNDAF_O; }
#line 9171 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 555:
#line 2208 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=SRCPORT_O; }
#line 9177 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 556:
#line 2209 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=DSTPORT_O; }
#line 9183 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 557:
#line 2210 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=AF_O; }
#line 9189 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 558:
#line 2211 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=MSGLEN_O; }
#line 9195 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 560:
#line 2217 "core/cfg.y" /* yacc.c:1646  */
    { onsend_check("snd_ip"); (yyval.intval)=SNDIP_O; }
#line 9201 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 561:
#line 2218 "core/cfg.y" /* yacc.c:1646  */
    { onsend_check("to_ip");  (yyval.intval)=TOIP_O; }
#line 9207 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 562:
#line 2221 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=SRCIP_O; }
#line 9213 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 563:
#line 2222 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=DSTIP_O; }
#line 9219 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 565:
#line 2230 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.expr)= mk_elem((yyvsp[-1].intval), METHOD_O, 0, RVE_ST, (yyvsp[0].rv_expr));}
#line 9225 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 566:
#line 2232 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.expr) = mk_elem((yyvsp[-1].intval), METHOD_O, 0, STRING_ST,(yyvsp[0].strval)); }
#line 9231 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 567:
#line 2233 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=0; yyerror("string expected"); }
#line 9237 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 568:
#line 2235 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=0; yyerror("invalid operator,== , !=, or =~ expected"); }
#line 9243 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 569:
#line 2237 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.expr) = mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, RVE_ST, (yyvsp[0].rv_expr)); }
#line 9249 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 570:
#line 2239 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, MYSELF_ST, 0); }
#line 9255 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 571:
#line 2241 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=0; yyerror("string or MYSELF expected"); }
#line 9261 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 572:
#line 2243 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=0; yyerror("invalid operator, == , != or =~ expected"); }
#line 9267 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 573:
#line 2244 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, RVE_ST, (yyvsp[0].rv_expr) ); }
#line 9273 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 574:
#line 2246 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, RVE_ST, (yyvsp[0].rv_expr) ); }
#line 9279 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 575:
#line 2247 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=0; yyerror("number expected"); }
#line 9285 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 576:
#line 2248 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=0; yyerror("number expected"); }
#line 9291 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 577:
#line 2249 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=0; yyerror("==, !=, <,>, >= or <=  expected"); }
#line 9297 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 578:
#line 2251 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_elem((yyvsp[-1].intval), PROTO_O, 0, NUMBER_ST, (void*)(yyvsp[0].intval) ); }
#line 9303 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 579:
#line 2253 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_elem((yyvsp[-1].intval), PROTO_O, 0, RVE_ST, (yyvsp[0].rv_expr) ); }
#line 9309 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 580:
#line 2255 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=0; yyerror("protocol expected (udp, tcp, tls, sctp, ws, or wss)"); }
#line 9315 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 581:
#line 2257 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_elem((yyvsp[-1].intval), SNDPROTO_O, 0, NUMBER_ST, (void*)(yyvsp[0].intval) ); }
#line 9321 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 582:
#line 2259 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_elem((yyvsp[-1].intval), SNDPROTO_O, 0, RVE_ST, (yyvsp[0].rv_expr) ); }
#line 9327 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 583:
#line 2261 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=0; yyerror("protocol expected (udp, tcp, tls, sctp, ws, or wss)"); }
#line 9333 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 584:
#line 2262 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, NET_ST, (yyvsp[0].ipnet)); }
#line 9339 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 585:
#line 2263 "core/cfg.y" /* yacc.c:1646  */
    {
			s_tmp.s=0;
			(yyval.expr)=0;
			if (rve_is_constant((yyvsp[0].rv_expr))){
				i_tmp=rve_guess_type((yyvsp[0].rv_expr));
				if (i_tmp==RV_INT)
					yyerror("string expected");
				else if (i_tmp==RV_STR){
					if (((rval_tmp=rval_expr_eval(0, 0, (yyvsp[0].rv_expr)))==0) ||
								(rval_get_str(0, 0, &s_tmp, rval_tmp, 0)<0)){
						rval_destroy(rval_tmp);
						yyerror("bad rvalue expression");
					}else{
						rval_destroy(rval_tmp);
					}
				}else{
					yyerror("BUG: unexpected dynamic type");
				}
			}else{
					/* warn("non constant rvalue in ip comparison") */;
			}
			if (s_tmp.s){
				ip_tmp=str2ip(&s_tmp);
				if (ip_tmp==0)
					ip_tmp=str2ip6(&s_tmp);
				pkg_free(s_tmp.s);
				if (ip_tmp) {
					(yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, NET_ST,
								mk_new_net_bitlen(ip_tmp, ip_tmp->len*8) );
				} else {
					(yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, RVE_ST, (yyvsp[0].rv_expr));
				}
			}else{
				(yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, RVE_ST, (yyvsp[0].rv_expr));
			}
		}
#line 9380 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 586:
#line 2300 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, STRING_ST, (yyvsp[0].strval)); }
#line 9386 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 587:
#line 2302 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, MYSELF_ST, 0); }
#line 9392 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 588:
#line 2304 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=0; yyerror( "ip address or hostname expected" ); }
#line 9398 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 589:
#line 2306 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=0; yyerror("invalid operator, ==, != or =~ expected");}
#line 9404 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 590:
#line 2309 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[0].intval), 0, MYSELF_ST, 0); }
#line 9410 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 591:
#line 2311 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[0].intval), 0, MYSELF_ST, 0); }
#line 9416 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 592:
#line 2313 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=0; yyerror("URI, SRCIP or DSTIP expected"); }
#line 9422 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 593:
#line 2314 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=0; yyerror ("invalid operator, == or != expected"); }
#line 9428 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 594:
#line 2318 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.ipnet)=mk_new_net((yyvsp[-2].ipaddr), (yyvsp[0].ipaddr)); }
#line 9434 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 595:
#line 2319 "core/cfg.y" /* yacc.c:1646  */
    {
		if (((yyvsp[0].intval)<0) || ((yyvsp[0].intval)>(yyvsp[-2].ipaddr)->len*8)) {
			yyerror("invalid bit number in netmask");
			(yyval.ipnet)=0;
		} else {
			(yyval.ipnet)=mk_new_net_bitlen((yyvsp[-2].ipaddr), (yyvsp[0].intval));
		/*
			$$=mk_new_net($1, htonl( ($3)?~( (1<<(32-$3))-1 ):0 ) );
		*/
		}
	}
#line 9450 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 596:
#line 2330 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.ipnet)=mk_new_net_bitlen((yyvsp[0].ipaddr), (yyvsp[0].ipaddr)->len*8); }
#line 9456 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 597:
#line 2331 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.ipnet)=0; yyerror("netmask (eg:255.0.0.0 or 8) expected"); }
#line 9462 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 598:
#line 2335 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.strval)=(yyvsp[0].strval); }
#line 9468 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 599:
#line 2336 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-2].strval)){
			(yyval.strval)=(char*)pkg_malloc(strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))+1);
			if ((yyval.strval)==0) {
				PKG_MEM_CRITICAL;
			} else {
				memcpy((yyval.strval), (yyvsp[-2].strval), strlen((yyvsp[-2].strval)));
				(yyval.strval)[strlen((yyvsp[-2].strval))]='.';
				memcpy((yyval.strval)+strlen((yyvsp[-2].strval))+1, (yyvsp[0].strval), strlen((yyvsp[0].strval)));
				(yyval.strval)[strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))]=0;
			}
			pkg_free((yyvsp[-2].strval));
		}
		if ((yyvsp[0].strval)) pkg_free((yyvsp[0].strval));
	}
#line 9488 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 600:
#line 2351 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-2].strval)){
			(yyval.strval)=(char*)pkg_malloc(strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))+1);
			if ((yyval.strval)==0) {
				PKG_MEM_CRITICAL;
			} else {
				memcpy((yyval.strval), (yyvsp[-2].strval), strlen((yyvsp[-2].strval)));
				(yyval.strval)[strlen((yyvsp[-2].strval))]='-';
				memcpy((yyval.strval)+strlen((yyvsp[-2].strval))+1, (yyvsp[0].strval), strlen((yyvsp[0].strval)));
				(yyval.strval)[strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))]=0;
			}
			pkg_free((yyvsp[-2].strval));
		}
		if ((yyvsp[0].strval)) pkg_free((yyvsp[0].strval));
	}
#line 9508 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 601:
#line 2366 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.strval)=0; pkg_free((yyvsp[-2].strval)); yyerror("invalid hostname"); }
#line 9514 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 602:
#line 2367 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.strval)=0; pkg_free((yyvsp[-2].strval)); yyerror("invalid hostname"); }
#line 9520 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 605:
#line 2372 "core/cfg.y" /* yacc.c:1646  */
    {
			/* get string version */
			(yyval.strval)=pkg_malloc(strlen(yy_number_str)+1);
			if ((yyval.strval)==0) {
				PKG_MEM_ERROR;
			} else {
				strcpy((yyval.strval), yy_number_str);
			}
		}
#line 9534 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 606:
#line 2384 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.strval)=(yyvsp[0].strval); }
#line 9540 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 607:
#line 2385 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-2].strval)){
			(yyval.strval)=(char*)pkg_malloc(strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))+1);
			if ((yyval.strval)==0) {
				PKG_MEM_CRITICAL;
			} else {
				memcpy((yyval.strval), (yyvsp[-2].strval), strlen((yyvsp[-2].strval)));
				(yyval.strval)[strlen((yyvsp[-2].strval))]='.';
				memcpy((yyval.strval)+strlen((yyvsp[-2].strval))+1, (yyvsp[0].strval), strlen((yyvsp[0].strval)));
				(yyval.strval)[strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))]=0;
			}
			pkg_free((yyvsp[-2].strval));
		}
		if ((yyvsp[0].strval)) pkg_free((yyvsp[0].strval));
	}
#line 9560 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 608:
#line 2400 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-2].strval)){
			(yyval.strval)=(char*)pkg_malloc(strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))+1);
			if ((yyval.strval)==0) {
				PKG_MEM_CRITICAL;
			} else {
				memcpy((yyval.strval), (yyvsp[-2].strval), strlen((yyvsp[-2].strval)));
				(yyval.strval)[strlen((yyvsp[-2].strval))]='-';
				memcpy((yyval.strval)+strlen((yyvsp[-2].strval))+1, (yyvsp[0].strval), strlen((yyvsp[0].strval)));
				(yyval.strval)[strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))]=0;
			}
			pkg_free((yyvsp[-2].strval));
		}
		if ((yyvsp[0].strval)) pkg_free((yyvsp[0].strval));
	}
#line 9580 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 609:
#line 2415 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.strval)=0; pkg_free((yyvsp[-2].strval));
								yyerror("invalid host or interface name"); }
#line 9587 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 610:
#line 2417 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.strval)=0; pkg_free((yyvsp[-2].strval));
								yyerror("invalid host or interface name"); }
#line 9594 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 611:
#line 2424 "core/cfg.y" /* yacc.c:1646  */
    {
		/* check if allowed */
		if ((yyvsp[0].action) && rt==ONSEND_ROUTE) {
			switch((yyvsp[0].action)->type) {
				case DROP_T:
				case LOG_T:
				case SETFLAG_T:
				case RESETFLAG_T:
				case ISFLAGSET_T:
				case IF_T:
				case MODULE0_T:
				case MODULE1_T:
				case MODULE2_T:
				case MODULE3_T:
				case MODULE4_T:
				case MODULE5_T:
				case MODULE6_T:
				case MODULEX_T:
				case SET_FWD_NO_CONNECT_T:
				case SET_RPL_NO_CONNECT_T:
				case SET_FWD_CLOSE_T:
				case SET_RPL_CLOSE_T:
					(yyval.action)=(yyvsp[0].action);
					break;
				default:
					(yyval.action)=0;
					yyerror("command not allowed in onsend_route\n");
			}
		} else {
			(yyval.action)=(yyvsp[0].action);
		}
	}
#line 9631 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 612:
#line 2466 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=(yyvsp[0].action); }
#line 9637 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 613:
#line 2467 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=(yyvsp[-1].action); }
#line 9643 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 614:
#line 2470 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=append_action((yyvsp[-1].action), (yyvsp[0].action)); }
#line 9649 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 615:
#line 2471 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[0].action);}
#line 9655 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 616:
#line 2472 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad command"); }
#line 9661 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 617:
#line 2475 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[-1].action);}
#line 9667 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 618:
#line 2476 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[0].action);}
#line 9673 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 619:
#line 2477 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[0].action);}
#line 9679 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 620:
#line 2478 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=(yyvsp[0].action); }
#line 9685 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 621:
#line 2479 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=(yyvsp[-1].action); }
#line 9691 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 622:
#line 2480 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[-1].action);}
#line 9697 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 623:
#line 2481 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=0;}
#line 9703 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 624:
#line 2482 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad command: missing ';'?"); }
#line 9709 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 625:
#line 2485 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-1].rv_expr) && rval_expr_int_check((yyvsp[-1].rv_expr))>=0){
			warn_ct_rve((yyvsp[-1].rv_expr), "if");
			(yyval.action)=mk_action( IF_T, 3, RVE_ST, (yyvsp[-1].rv_expr), ACTIONS_ST, (yyvsp[0].action), NOSUBTYPE, 0);
			set_cfg_pos((yyval.action));
		}else
			YYERROR;
	}
#line 9722 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 626:
#line 2493 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-3].rv_expr) && rval_expr_int_check((yyvsp[-3].rv_expr))>=0){
			warn_ct_rve((yyvsp[-3].rv_expr), "if");
			(yyval.action)=mk_action( IF_T, 3, RVE_ST, (yyvsp[-3].rv_expr), ACTIONS_ST, (yyvsp[-2].action), ACTIONS_ST, (yyvsp[0].action));
			set_cfg_pos((yyval.action));
		}else
			YYERROR;
	}
#line 9735 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 627:
#line 2503 "core/cfg.y" /* yacc.c:1646  */
    {
			(yyval.rv_expr)=0;
			if ((yyvsp[0].rv_expr) && !rve_is_constant((yyvsp[0].rv_expr))){
				yyerror("constant expected");
				YYERROR;
			/*
			} else if ($1 &&
						!rve_check_type((enum rval_type*)&i_tmp, $1, 0, 0 ,0)){
				yyerror("invalid expression (bad type)");
			}else if ($1 && i_tmp!=RV_INT){
				yyerror("invalid expression type, int expected\n");
			*/
			}else
				(yyval.rv_expr)=(yyvsp[0].rv_expr);
		}
#line 9755 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 628:
#line 2520 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.case_stms)=0;
		if ((yyvsp[-2].rv_expr)==0) { yyerror ("bad case label"); YYERROR; }
		else if ((((yyval.case_stms)=mk_case_stm((yyvsp[-2].rv_expr), 0, (yyvsp[0].action), &i_tmp))==0) && (i_tmp==-10)){
				YYABORT;
		}
	}
#line 9767 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 629:
#line 2527 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.case_stms)=0;
		if ((yyvsp[-2].rv_expr)==0) { yyerror ("bad case label"); YYERROR; }
		else if ((((yyval.case_stms)=mk_case_stm((yyvsp[-2].rv_expr), 1, (yyvsp[0].action), &i_tmp))==0) && (i_tmp==-10)){
				YYABORT;
		}
	}
#line 9779 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 630:
#line 2534 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.case_stms)=0;
		if ((yyvsp[-1].rv_expr)==0) { yyerror ("bad case label"); YYERROR; }
		else if ((((yyval.case_stms)=mk_case_stm((yyvsp[-1].rv_expr), 0, 0, &i_tmp))==0) && (i_tmp==-10)){
				YYABORT;
		}
	}
#line 9791 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 631:
#line 2541 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.case_stms)=0;
		if ((yyvsp[-1].rv_expr)==0) { yyerror ("bad regex case label"); YYERROR; }
		else if ((((yyval.case_stms)=mk_case_stm((yyvsp[-1].rv_expr), 1, 0, &i_tmp))==0) && (i_tmp==-10)){
				YYABORT;
		}
	}
#line 9803 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 632:
#line 2548 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((((yyval.case_stms)=mk_case_stm(0, 0, (yyvsp[0].action), &i_tmp))==0) && (i_tmp==-10)){
				YYABORT;
		}
	}
#line 9813 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 633:
#line 2553 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((((yyval.case_stms)=mk_case_stm(0, 0, 0, &i_tmp))==0) && (i_tmp==-10)){
				YYABORT;
		}
	}
#line 9823 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 634:
#line 2558 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.case_stms)=0; yyerror("bad case label"); }
#line 9829 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 635:
#line 2559 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.case_stms)=0; yyerror("bad case regex label"); }
#line 9835 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 636:
#line 2560 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.case_stms)=0; yyerror("bad case label"); }
#line 9841 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 637:
#line 2561 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.case_stms)=0; yyerror("bad case regex label"); }
#line 9847 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 638:
#line 2562 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.case_stms)=0; yyerror ("bad case body"); }
#line 9853 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 639:
#line 2565 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.case_stms)=(yyvsp[-1].case_stms);
		if ((yyvsp[0].case_stms)==0) yyerror ("bad case");
		if ((yyval.case_stms)){
			*((yyval.case_stms)->append)=(yyvsp[0].case_stms);
			if (*((yyval.case_stms)->append)!=0)
				(yyval.case_stms)->append=&((*((yyval.case_stms)->append))->next);
		}
	}
#line 9867 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 640:
#line 2574 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.case_stms)=(yyvsp[0].case_stms);
		if ((yyvsp[0].case_stms)==0) yyerror ("bad case");
		else (yyval.case_stms)->append=&((yyval.case_stms)->next);
	}
#line 9877 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 641:
#line 2581 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=0;
		if ((yyvsp[-3].rv_expr)==0){
			yyerror("bad expression in switch(...)");
			YYERROR;
		}else if ((yyvsp[-1].case_stms)==0){
			yyerror ("bad switch body");
			YYERROR;
		}else if (case_check_default((yyvsp[-1].case_stms))!=0){
			yyerror_at(&(yyvsp[-3].rv_expr)->fpos, "bad switch(): too many "
							"\"default:\" labels\n");
			YYERROR;
		}else if (case_check_type((yyvsp[-1].case_stms))!=0){
			yyerror_at(&(yyvsp[-3].rv_expr)->fpos, "bad switch(): mixed integer and"
							" string/RE cases not allowed\n");
			YYERROR;
		}else{
			(yyval.action)=mk_action(SWITCH_T, 2, RVE_ST, (yyvsp[-3].rv_expr), CASE_ST, (yyvsp[-1].case_stms));
			if ((yyval.action)==0) {
				yyerror("internal error");
				YYABORT;
			}
			set_cfg_pos((yyval.action));
		}
	}
#line 9907 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 642:
#line 2606 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=0;
		warn("empty switch()");
		if ((yyvsp[-2].rv_expr)==0){
			yyerror("bad expression in switch(...)");
			YYERROR;
		}else{
			/* it might have sideffects, so leave it for the optimizer */
			(yyval.action)=mk_action(SWITCH_T, 2, RVE_ST, (yyvsp[-2].rv_expr), CASE_ST, 0);
			if ((yyval.action)==0) {
				yyerror("internal error");
				YYABORT;
			}
			set_cfg_pos((yyval.action));
		}
	}
#line 9928 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 643:
#line 2622 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror ("bad expression in switch(...)"); }
#line 9934 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 644:
#line 2624 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=0; yyerror ("bad switch body"); }
#line 9940 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 645:
#line 2628 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-1].rv_expr) && rval_expr_int_check((yyvsp[-1].rv_expr))>=0){
			warn_ct_rve((yyvsp[-1].rv_expr), "while");
			(yyval.action)=mk_action( WHILE_T, 2, RVE_ST, (yyvsp[-1].rv_expr), ACTIONS_ST, (yyvsp[0].action));
			set_cfg_pos((yyval.action));
		}else{
			yyerror_at(&(yyvsp[-1].rv_expr)->fpos, "bad while(...) expression");
			YYERROR;
		}
	}
#line 9955 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 646:
#line 2647 "core/cfg.y" /* yacc.c:1646  */
    {
		if (sel.n >= MAX_SELECT_PARAMS-1) {
			yyerror("Select identifier too long\n");
		}
		sel.params[sel.n].type = SEL_PARAM_STR;
		sel.params[sel.n].v.s.s = (yyvsp[0].strval);
		sel.params[sel.n].v.s.len = strlen((yyvsp[0].strval));
		sel.n++;
	}
#line 9969 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 647:
#line 2656 "core/cfg.y" /* yacc.c:1646  */
    {
		if (sel.n >= MAX_SELECT_PARAMS-2) {
			yyerror("Select identifier too long\n");
		}
		sel.params[sel.n].type = SEL_PARAM_STR;
		sel.params[sel.n].v.s.s = (yyvsp[-3].strval);
		sel.params[sel.n].v.s.len = strlen((yyvsp[-3].strval));
		sel.n++;
		sel.params[sel.n].type = SEL_PARAM_INT;
		sel.params[sel.n].v.i = (yyvsp[-1].intval);
		sel.n++;
	}
#line 9986 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 648:
#line 2668 "core/cfg.y" /* yacc.c:1646  */
    {
		if (sel.n >= MAX_SELECT_PARAMS-2) {
			yyerror("Select identifier too long\n");
		}
		sel.params[sel.n].type = SEL_PARAM_STR;
		sel.params[sel.n].v.s.s = (yyvsp[-3].strval);
		sel.params[sel.n].v.s.len = strlen((yyvsp[-3].strval));
		sel.n++;
		sel.params[sel.n].type = SEL_PARAM_STR;
		sel.params[sel.n].v.s.s = (yyvsp[-1].strval);
		sel.params[sel.n].v.s.len = strlen((yyvsp[-1].strval));
		sel.n++;
	}
#line 10004 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 651:
#line 2687 "core/cfg.y" /* yacc.c:1646  */
    { sel.n = 0; sel.f[0] = 0; }
#line 10010 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 652:
#line 2687 "core/cfg.y" /* yacc.c:1646  */
    {
		sel_ptr = (select_t*)pkg_malloc(sizeof(select_t));
		if (!sel_ptr) {
			yyerror("No memory left to allocate select structure\n");
		}
		memcpy(sel_ptr, &sel, sizeof(select_t));
		(yyval.select) = sel_ptr;
	}
#line 10023 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 653:
#line 2697 "core/cfg.y" /* yacc.c:1646  */
    { s_attr->type |= AVP_TRACK_FROM; }
#line 10029 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 654:
#line 2698 "core/cfg.y" /* yacc.c:1646  */
    { s_attr->type |= AVP_TRACK_TO; }
#line 10035 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 655:
#line 2699 "core/cfg.y" /* yacc.c:1646  */
    { s_attr->type |= AVP_TRACK_FROM | AVP_CLASS_URI; }
#line 10041 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 656:
#line 2700 "core/cfg.y" /* yacc.c:1646  */
    { s_attr->type |= AVP_TRACK_TO | AVP_CLASS_URI; }
#line 10047 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 657:
#line 2701 "core/cfg.y" /* yacc.c:1646  */
    { s_attr->type |= AVP_TRACK_FROM | AVP_CLASS_USER; }
#line 10053 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 658:
#line 2702 "core/cfg.y" /* yacc.c:1646  */
    { s_attr->type |= AVP_TRACK_TO | AVP_CLASS_USER; }
#line 10059 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 659:
#line 2703 "core/cfg.y" /* yacc.c:1646  */
    { s_attr->type |= AVP_TRACK_FROM | AVP_CLASS_DOMAIN; }
#line 10065 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 660:
#line 2704 "core/cfg.y" /* yacc.c:1646  */
    { s_attr->type |= AVP_TRACK_TO | AVP_CLASS_DOMAIN; }
#line 10071 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 661:
#line 2705 "core/cfg.y" /* yacc.c:1646  */
    { s_attr->type |= AVP_TRACK_ALL | AVP_CLASS_GLOBAL; }
#line 10077 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 662:
#line 2708 "core/cfg.y" /* yacc.c:1646  */
    { s_attr->type |= AVP_NAME_STR; s_attr->name.s.s = (yyvsp[0].strval); s_attr->name.s.len = strlen ((yyvsp[0].strval)); }
#line 10083 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 665:
#line 2715 "core/cfg.y" /* yacc.c:1646  */
    {
		s_attr = (struct avp_spec*)pkg_malloc(sizeof(struct avp_spec));
		if (!s_attr) { yyerror("No memory left"); YYABORT; }
		else { memset(s_attr, 0, (sizeof(struct avp_spec))); }
	}
#line 10093 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 666:
#line 2722 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.attr) = s_attr; }
#line 10099 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 667:
#line 2725 "core/cfg.y" /* yacc.c:1646  */
    {
		s_attr->type|= (AVP_NAME_STR | ((yyvsp[-1].intval)<0?AVP_INDEX_BACKWARD:AVP_INDEX_FORWARD));
		s_attr->index = ((yyvsp[-1].intval)<0?-(yyvsp[-1].intval):(yyvsp[-1].intval));
		(yyval.attr) = s_attr;
	}
#line 10109 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 668:
#line 2732 "core/cfg.y" /* yacc.c:1646  */
    {
		s_attr->type|= AVP_INDEX_ALL;
		(yyval.attr) = s_attr;
	}
#line 10118 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 675:
#line 2754 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[0].lval)->type==LV_AVP){
			s_attr = pkg_malloc(sizeof(struct avp_spec));
			if (!s_attr) { yyerror("No memory left"); YYABORT; }
			else{
				*s_attr=(yyvsp[0].lval)->lv.avps;
			}
			(yyval.attr)=s_attr;
		}else
			(yyval.attr)=0; /* not an avp, a pvar */
		pkg_free((yyvsp[0].lval));
	}
#line 10135 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 676:
#line 2766 "core/cfg.y" /* yacc.c:1646  */
    {
		avp_spec_t *avp_spec;
		str s;
		int type, idx;
		avp_spec = pkg_malloc(sizeof(*avp_spec));
		if (!avp_spec) {
			yyerror("Not enough memory");
			YYABORT;
		}
		s.s = (yyvsp[0].strval);
		if (s.s[0] == '$')
			s.s++;
		s.len = strlen(s.s);
		if (parse_avp_name(&s, &type, &avp_spec->name, &idx)) {
			yyerror("error when parsing AVP");
			pkg_free(avp_spec);
			YYABORT;
		}
		avp_spec->type = type;
		avp_spec->index = idx;
		(yyval.attr) = avp_spec;
	}
#line 10162 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 677:
#line 2790 "core/cfg.y" /* yacc.c:1646  */
    {
			s_tmp.s=(yyvsp[0].strval); s_tmp.len=strlen((yyvsp[0].strval));
			pv_spec=pv_cache_get(&s_tmp);
			if (!pv_spec) {
				yyerror("Can't get from cache: %s", (yyvsp[0].strval));
				YYABORT;
			}
			(yyval.pvar)=pv_spec;
		}
#line 10176 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 678:
#line 2801 "core/cfg.y" /* yacc.c:1646  */
    {
				lval_tmp=pkg_malloc(sizeof(*lval_tmp));
				if (!lval_tmp) {
					yyerror("Not enough memory");
					YYABORT;
				}
				memset(lval_tmp, 0, sizeof(*lval_tmp));
				s_tmp.s=(yyvsp[0].strval); s_tmp.len=strlen(s_tmp.s);
				lval_tmp->lv.pvs = pv_cache_get(&s_tmp);
				if (lval_tmp->lv.pvs==NULL){
					lval_tmp->lv.avps.type|= AVP_NAME_STR;
					lval_tmp->lv.avps.name.s.s = s_tmp.s+1;
					lval_tmp->lv.avps.name.s.len = s_tmp.len-1;
					lval_tmp->type=LV_AVP;
				}else{
					lval_tmp->type=LV_PVAR;
				}
				(yyval.lval) = lval_tmp;
				DBG("parsed ambiguous avp/pvar \"%.*s\" to %d\n",
							s_tmp.len, s_tmp.s, lval_tmp->type);
			}
#line 10202 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 679:
#line 2832 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = ASSIGN_T; }
#line 10208 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 680:
#line 2836 "core/cfg.y" /* yacc.c:1646  */
    {
					lval_tmp=pkg_malloc(sizeof(*lval_tmp));
					if (!lval_tmp) {
						yyerror("Not enough memory");
						YYABORT;
					}
					lval_tmp->type=LV_AVP; lval_tmp->lv.avps=*(yyvsp[0].attr);
					pkg_free((yyvsp[0].attr)); /* free the avp spec we just copied */
					(yyval.lval)=lval_tmp;
				}
#line 10223 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 681:
#line 2846 "core/cfg.y" /* yacc.c:1646  */
    {
					if (!pv_is_w((yyvsp[0].pvar)))
						yyerror("read only pvar in assignment left side");
					if ((yyvsp[0].pvar)->trans!=0)
						yyerror("pvar with transformations in assignment"
								" left side");
					lval_tmp=pkg_malloc(sizeof(*lval_tmp));
					if (!lval_tmp) {
						yyerror("Not enough memory");
						YYABORT;
					}
					lval_tmp->type=LV_PVAR; lval_tmp->lv.pvs=(yyvsp[0].pvar);
					(yyval.lval)=lval_tmp;
				}
#line 10242 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 682:
#line 2860 "core/cfg.y" /* yacc.c:1646  */
    {
					if (((yyvsp[0].lval))->type==LV_PVAR){
						if (!pv_is_w((yyvsp[0].lval)->lv.pvs))
							yyerror("read only pvar in assignment left side");
						if ((yyvsp[0].lval)->lv.pvs->trans!=0)
							yyerror("pvar with transformations in assignment"
									" left side");
					}
					(yyval.lval)=(yyvsp[0].lval);
				}
#line 10257 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 683:
#line 2872 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve_rval(RV_INT, (void*)(yyvsp[0].intval)); }
#line 10263 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 684:
#line 2873 "core/cfg.y" /* yacc.c:1646  */
    {	s_tmp.s=(yyvsp[0].strval); s_tmp.len=strlen((yyvsp[0].strval));
							(yyval.rv_expr)=mk_rve_rval(RV_STR, &s_tmp); }
#line 10270 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 685:
#line 2875 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve_rval(RV_AVP, (yyvsp[0].attr)); pkg_free((yyvsp[0].attr)); }
#line 10276 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 686:
#line 2876 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve_rval(RV_PVAR, (yyvsp[0].pvar)); }
#line 10282 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 687:
#line 2877 "core/cfg.y" /* yacc.c:1646  */
    {
							switch((yyvsp[0].lval)->type){
								case LV_AVP:
									(yyval.rv_expr)=mk_rve_rval(RV_AVP, &(yyvsp[0].lval)->lv.avps);
									break;
								case LV_PVAR:
									(yyval.rv_expr)=mk_rve_rval(RV_PVAR, (yyvsp[0].lval)->lv.pvs);
									break;
								default:
									yyerror("BUG: invalid lvalue type ");
									YYABORT;
							}
							pkg_free((yyvsp[0].lval)); /* not needed anymore */
						}
#line 10301 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 688:
#line 2891 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve_rval(RV_SEL, (yyvsp[0].select)); pkg_free((yyvsp[0].select)); }
#line 10307 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 689:
#line 2892 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve_rval(RV_ACTION_ST, (yyvsp[0].action)); }
#line 10313 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 690:
#line 2893 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=mk_rve_rval(RV_BEXPR, (yyvsp[0].expr)); }
#line 10319 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 691:
#line 2894 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve_rval(RV_ACTION_ST, (yyvsp[-1].action)); }
#line 10325 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 692:
#line 2895 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad command block"); }
#line 10331 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 693:
#line 2896 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve_rval(RV_ACTION_ST, (yyvsp[-1].action)); }
#line 10337 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 694:
#line 2897 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10343 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 695:
#line 2901 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=RVE_LNOT_OP; }
#line 10349 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 696:
#line 2902 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=RVE_BNOT_OP; }
#line 10355 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 697:
#line 2903 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=RVE_UMINUS_OP; }
#line 10361 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 698:
#line 2916 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=(yyvsp[0].rv_expr);
										if ((yyval.rv_expr)==0){
											/*yyerror("out of memory\n");*/
											YYERROR;
										}
									}
#line 10372 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 699:
#line 2922 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve1((yyvsp[-1].intval), (yyvsp[0].rv_expr)); }
#line 10378 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 700:
#line 2923 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve1(RVE_INT_OP, (yyvsp[0].rv_expr)); }
#line 10384 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 701:
#line 2924 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve1(RVE_STR_OP, (yyvsp[0].rv_expr)); }
#line 10390 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 702:
#line 2925 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve2(RVE_PLUS_OP, (yyvsp[-2].rv_expr), (yyvsp[0].rv_expr)); }
#line 10396 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 703:
#line 2926 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve2(RVE_MINUS_OP, (yyvsp[-2].rv_expr), (yyvsp[0].rv_expr)); }
#line 10402 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 704:
#line 2927 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve2(RVE_MUL_OP, (yyvsp[-2].rv_expr), (yyvsp[0].rv_expr)); }
#line 10408 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 705:
#line 2928 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve2(RVE_DIV_OP, (yyvsp[-2].rv_expr), (yyvsp[0].rv_expr)); }
#line 10414 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 706:
#line 2929 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve2(RVE_MOD_OP, (yyvsp[-2].rv_expr), (yyvsp[0].rv_expr)); }
#line 10420 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 707:
#line 2930 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve2(RVE_BOR_OP, (yyvsp[-2].rv_expr),  (yyvsp[0].rv_expr)); }
#line 10426 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 708:
#line 2931 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve2(RVE_BAND_OP, (yyvsp[-2].rv_expr),  (yyvsp[0].rv_expr));}
#line 10432 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 709:
#line 2932 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve2(RVE_BXOR_OP, (yyvsp[-2].rv_expr),  (yyvsp[0].rv_expr));}
#line 10438 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 710:
#line 2933 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve2(RVE_BLSHIFT_OP, (yyvsp[-2].rv_expr),  (yyvsp[0].rv_expr));}
#line 10444 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 711:
#line 2934 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve2(RVE_BRSHIFT_OP, (yyvsp[-2].rv_expr),  (yyvsp[0].rv_expr));}
#line 10450 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 712:
#line 2935 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=mk_rve2( (yyvsp[-1].intval), (yyvsp[-2].rv_expr), (yyvsp[0].rv_expr));}
#line 10456 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 713:
#line 2936 "core/cfg.y" /* yacc.c:1646  */
    {
			/* comparing with $null => treat as defined or !defined */
			if((yyvsp[0].rv_expr) != NULL && (yyvsp[0].rv_expr)->op==RVE_RVAL_OP && (yyvsp[0].rv_expr)->left.rval.type==RV_PVAR
					&& (yyvsp[0].rv_expr)->left.rval.v.pvs.type==PVT_NULL) {
				if((yyvsp[-1].intval)==RVE_DIFF_OP || (yyvsp[-1].intval)==RVE_IDIFF_OP
						|| (yyvsp[-1].intval)==RVE_STRDIFF_OP) {
					DBG("comparison with $null switched to notdefined operator\n");
					(yyval.rv_expr)=mk_rve1(RVE_DEFINED_OP, (yyvsp[-2].rv_expr));
				} else {
					DBG("comparison with $null switched to defined operator\n");
					(yyval.rv_expr)=mk_rve1(RVE_NOTDEFINED_OP, (yyvsp[-2].rv_expr));
				}
				/* free rve struct for $null */
				rve_destroy((yyvsp[0].rv_expr));
			} else {
				(yyval.rv_expr)=mk_rve2((yyvsp[-1].intval), (yyvsp[-2].rv_expr), (yyvsp[0].rv_expr));
			}
		}
#line 10479 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 714:
#line 2954 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=mk_rve2(RVE_LAND_OP, (yyvsp[-2].rv_expr), (yyvsp[0].rv_expr));}
#line 10485 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 715:
#line 2955 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=mk_rve2(RVE_LOR_OP, (yyvsp[-2].rv_expr), (yyvsp[0].rv_expr));}
#line 10491 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 716:
#line 2956 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=(yyvsp[-1].rv_expr);}
#line 10497 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 717:
#line 2957 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=mk_rve1(RVE_STRLEN_OP, (yyvsp[-1].rv_expr));}
#line 10503 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 718:
#line 2958 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve1(RVE_STREMPTY_OP, (yyvsp[-1].rv_expr));}
#line 10509 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 719:
#line 2959 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=mk_rve1(RVE_DEFINED_OP, (yyvsp[0].rv_expr));}
#line 10515 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 720:
#line 2960 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10521 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 721:
#line 2961 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10527 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 722:
#line 2962 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10533 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 723:
#line 2963 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10539 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 724:
#line 2964 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10545 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 725:
#line 2965 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10551 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 726:
#line 2966 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10557 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 727:
#line 2967 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10563 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 728:
#line 2968 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10569 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 729:
#line 2969 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10575 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 730:
#line 2971 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10581 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 731:
#line 2973 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10587 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 732:
#line 2974 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10593 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 733:
#line 2975 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10599 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 734:
#line 2976 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10605 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 735:
#line 2977 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10611 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 736:
#line 2978 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10617 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 737:
#line 2981 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action((yyvsp[-1].intval), 2, LVAL_ST, (yyvsp[-2].lval),
														 	  RVE_ST, (yyvsp[0].rv_expr));
											set_cfg_pos((yyval.action));
										}
#line 10626 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 738:
#line 2999 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = 1; }
#line 10632 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 739:
#line 3000 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = 0; }
#line 10638 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 740:
#line 3001 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = -1; }
#line 10644 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 741:
#line 3004 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_T, 2, URIHOST_ST, 0, URIPORT_ST, 0); set_cfg_pos((yyval.action)); }
#line 10650 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 742:
#line 3005 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(	FORWARD_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 10656 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 743:
#line 3006 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(	FORWARD_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 10662 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 744:
#line 3007 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(	FORWARD_T, 2, IP_ST, (void*)(yyvsp[-1].ipaddr), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 10668 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 745:
#line 3008 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 10674 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 746:
#line 3009 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=mk_action(FORWARD_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 10680 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 747:
#line 3010 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_T, 2, IP_ST, (void*)(yyvsp[-3].ipaddr), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 10686 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 748:
#line 3011 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_T, 2, URIHOST_ST, 0, URIPORT_ST, 0); set_cfg_pos((yyval.action)); }
#line 10692 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 749:
#line 3012 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=mk_action(FORWARD_T, 2, URIHOST_ST, 0, NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 10698 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 750:
#line 3013 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_T, 2, URIHOST_ST, 0, NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 10704 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 751:
#line 3014 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 10710 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 752:
#line 3015 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad forward argument"); }
#line 10716 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 753:
#line 3016 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_UDP_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 10722 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 754:
#line 3017 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_UDP_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 10728 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 755:
#line 3018 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_UDP_T, 2, IP_ST, (void*)(yyvsp[-1].ipaddr), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 10734 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 756:
#line 3019 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_UDP_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 10740 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 757:
#line 3020 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=mk_action(FORWARD_UDP_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 10746 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 758:
#line 3021 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_UDP_T, 2, IP_ST, (void*)(yyvsp[-3].ipaddr), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 10752 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 759:
#line 3022 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=mk_action(FORWARD_UDP_T, 2, URIHOST_ST, 0, URIPORT_ST, 0); set_cfg_pos((yyval.action)); }
#line 10758 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 760:
#line 3023 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_UDP_T, 2, URIHOST_ST, 0, NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 10764 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 761:
#line 3024 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_UDP_T, 2, URIHOST_ST, 0, NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 10770 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 762:
#line 3025 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 10776 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 763:
#line 3026 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad forward_udp argument"); }
#line 10782 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 764:
#line 3027 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_TCP_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 10788 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 765:
#line 3028 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_TCP_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 10794 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 766:
#line 3029 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_TCP_T, 2, IP_ST, (void*)(yyvsp[-1].ipaddr), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 10800 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 767:
#line 3030 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_TCP_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 10806 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 768:
#line 3031 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=mk_action(FORWARD_TCP_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 10812 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 769:
#line 3032 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_TCP_T, 2, IP_ST, (void*)(yyvsp[-3].ipaddr), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 10818 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 770:
#line 3033 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=mk_action(FORWARD_TCP_T, 2, URIHOST_ST, 0, URIPORT_ST, 0); set_cfg_pos((yyval.action)); }
#line 10824 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 771:
#line 3034 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_TCP_T, 2, URIHOST_ST, 0, NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 10830 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 772:
#line 3035 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_TCP_T, 2, URIHOST_ST, 0, NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 10836 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 773:
#line 3036 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 10842 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 774:
#line 3037 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad forward_tcp argument"); }
#line 10848 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 775:
#line 3038 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
#line 10861 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 776:
#line 3046 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
#line 10874 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 777:
#line 3054 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, IP_ST, (void*)(yyvsp[-1].ipaddr), NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
#line 10887 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 778:
#line 3062 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
#line 10900 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 779:
#line 3070 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
#line 10913 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 780:
#line 3078 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, IP_ST, (void*)(yyvsp[-3].ipaddr), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
					}
#line 10926 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 781:
#line 3086 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, URIHOST_ST, 0, URIPORT_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
#line 10939 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 782:
#line 3094 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, URIHOST_ST, 0, NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
#line 10952 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 783:
#line 3102 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, URIHOST_ST, 0, NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
#line 10965 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 784:
#line 3110 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 10971 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 785:
#line 3111 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0;
									yyerror("bad forward_tls argument"); }
#line 10978 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 786:
#line 3113 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
	}
#line 10991 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 787:
#line 3121 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
	}
#line 11004 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 788:
#line 3129 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, IP_ST, (void*)(yyvsp[-1].ipaddr), NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
	}
#line 11017 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 789:
#line 3137 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST,
							(void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
	}
#line 11031 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 790:
#line 3146 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST,
							(void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
	}
#line 11045 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 791:
#line 3155 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, IP_ST, (void*)(yyvsp[-3].ipaddr), NUMBER_ST,
							(void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
					}
#line 11059 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 792:
#line 3164 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, URIHOST_ST, 0, URIPORT_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
	}
#line 11072 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 793:
#line 3172 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, URIHOST_ST, 0, NUMBER_ST,
							(void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
	}
#line 11086 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 794:
#line 3181 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, URIHOST_ST, 0, NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
#line 11099 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 795:
#line 3189 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11105 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 796:
#line 3190 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0;
									yyerror("bad forward_sctp argument"); }
#line 11112 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 797:
#line 3192 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=mk_action(LOG_T, 2, NUMBER_ST,
										(void*)(L_DBG+1), STRING_ST, (yyvsp[-1].strval));
									set_cfg_pos((yyval.action)); }
#line 11120 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 798:
#line 3195 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=mk_action(LOG_T, 2, NUMBER_ST, (void*)(yyvsp[-3].intval), STRING_ST, (yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 11126 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 799:
#line 3196 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11132 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 800:
#line 3197 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad log argument"); }
#line 11138 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 801:
#line 3198 "core/cfg.y" /* yacc.c:1646  */
    {
							if (check_flag((yyvsp[-1].intval))==-1)
								yyerror("bad flag value");
							(yyval.action)=mk_action(SETFLAG_T, 1, NUMBER_ST,
													(void*)(yyvsp[-1].intval));
							set_cfg_pos((yyval.action));
									}
#line 11150 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 802:
#line 3205 "core/cfg.y" /* yacc.c:1646  */
    {
							i_tmp=get_flag_no((yyvsp[-1].strval), strlen((yyvsp[-1].strval)));
							if (i_tmp<0) yyerror("flag not declared");
							(yyval.action)=mk_action(SETFLAG_T, 1, NUMBER_ST,
										(void*)(long)i_tmp);
							set_cfg_pos((yyval.action));
									}
#line 11162 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 803:
#line 3212 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')'?"); }
#line 11168 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 804:
#line 3213 "core/cfg.y" /* yacc.c:1646  */
    {
							if (check_flag((yyvsp[-1].intval))==-1)
								yyerror("bad flag value");
							(yyval.action)=mk_action(RESETFLAG_T, 1, NUMBER_ST, (void*)(yyvsp[-1].intval));
							set_cfg_pos((yyval.action));
									}
#line 11179 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 805:
#line 3219 "core/cfg.y" /* yacc.c:1646  */
    {
							i_tmp=get_flag_no((yyvsp[-1].strval), strlen((yyvsp[-1].strval)));
							if (i_tmp<0) yyerror("flag not declared");
							(yyval.action)=mk_action(RESETFLAG_T, 1, NUMBER_ST,
										(void*)(long)i_tmp);
							set_cfg_pos((yyval.action));
									}
#line 11191 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 806:
#line 3226 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')'?"); }
#line 11197 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 807:
#line 3227 "core/cfg.y" /* yacc.c:1646  */
    {
							if (check_flag((yyvsp[-1].intval))==-1)
								yyerror("bad flag value");
							(yyval.action)=mk_action(ISFLAGSET_T, 1, NUMBER_ST, (void*)(yyvsp[-1].intval));
							set_cfg_pos((yyval.action));
									}
#line 11208 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 808:
#line 3233 "core/cfg.y" /* yacc.c:1646  */
    {
							i_tmp=get_flag_no((yyvsp[-1].strval), strlen((yyvsp[-1].strval)));
							if (i_tmp<0) yyerror("flag not declared");
							(yyval.action)=mk_action(ISFLAGSET_T, 1, NUMBER_ST,
										(void*)(long)i_tmp);
							set_cfg_pos((yyval.action));
									}
#line 11220 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 809:
#line 3240 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')'?"); }
#line 11226 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 810:
#line 3241 "core/cfg.y" /* yacc.c:1646  */
    {
		i_tmp=get_avpflag_no((yyvsp[-1].strval));
		if (i_tmp==0) yyerror("avpflag not declared");
		(yyval.action)=mk_action(AVPFLAG_OPER_T, 3, AVP_ST, (yyvsp[-3].attr), NUMBER_ST, (void*)(long)i_tmp, NUMBER_ST, (void*)(yyvsp[-5].intval));
		set_cfg_pos((yyval.action));
	}
#line 11237 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 811:
#line 3247 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=0; yyerror("error parsing flag name");
	}
#line 11245 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 812:
#line 3250 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=0; yyerror("error parsing first parameter (avp or string)");
	}
#line 11253 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 813:
#line 3253 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad parameters"); }
#line 11259 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 814:
#line 3254 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')'?"); }
#line 11265 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 815:
#line 3255 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=mk_action(ERROR_T, 2, STRING_ST, (yyvsp[-3].strval), STRING_ST, (yyvsp[-1].strval));
			set_cfg_pos((yyval.action));
	}
#line 11273 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 816:
#line 3258 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11279 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 817:
#line 3259 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad error argument"); }
#line 11285 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 818:
#line 3260 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-1].rv_expr)) {
			(yyval.action) = mk_action(ROUTE_T, 1, RVE_ST, (void*)(yyvsp[-1].rv_expr));
			set_cfg_pos((yyval.action));
		} else {
			(yyval.action) = 0;
			YYERROR;
		}
	}
#line 11299 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 819:
#line 3269 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-1].strval)) {
			(yyval.action) = mk_action(ROUTE_T, 1, STRING_ST, (void*)(yyvsp[-1].strval));
			set_cfg_pos((yyval.action));
		} else {
			(yyval.action) = 0;
			YYERROR;
		}
	}
#line 11313 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 820:
#line 3278 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11319 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 821:
#line 3279 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad route argument"); }
#line 11325 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 822:
#line 3280 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(EXEC_T, 1, STRING_ST, (yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 11331 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 823:
#line 3281 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(SET_HOST_T, 1, STRING_ST, (yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 11337 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 824:
#line 3282 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11343 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 825:
#line 3283 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 11349 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 826:
#line 3284 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(PREFIX_T, 1, STRING_ST,  (yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 11355 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 827:
#line 3285 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11361 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 828:
#line 3286 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 11367 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 829:
#line 3287 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(STRIP_TAIL_T, 1, NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 11373 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 830:
#line 3288 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11379 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 831:
#line 3289 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, number expected"); }
#line 11385 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 832:
#line 3290 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(STRIP_T, 1, NUMBER_ST, (void*) (yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 11391 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 833:
#line 3291 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11397 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 834:
#line 3292 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, number expected"); }
#line 11403 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 835:
#line 3293 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(SET_USERPHONE_T, 0); set_cfg_pos((yyval.action)); }
#line 11409 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 836:
#line 3294 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11415 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 837:
#line 3295 "core/cfg.y" /* yacc.c:1646  */
    {
			(yyval.action)=mk_action(REMOVE_BRANCH_T, 1, NUMBER_ST, (void*)(yyvsp[-1].intval));
			set_cfg_pos((yyval.action));
	}
#line 11424 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 838:
#line 3299 "core/cfg.y" /* yacc.c:1646  */
    {
			(yyval.action)=mk_action(REMOVE_BRANCH_T, 0);
			set_cfg_pos((yyval.action));
	}
#line 11433 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 839:
#line 3303 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11439 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 840:
#line 3304 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, number expected"); }
#line 11445 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 841:
#line 3305 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(CLEAR_BRANCHES_T, 0); set_cfg_pos((yyval.action)); }
#line 11451 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 842:
#line 3306 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(SET_HOSTPORT_T, 1, STRING_ST, (yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 11457 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 843:
#line 3307 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11463 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 844:
#line 3308 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 11469 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 845:
#line 3309 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(SET_HOSTPORTTRANS_T, 1, STRING_ST, (yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 11475 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 846:
#line 3310 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11481 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 847:
#line 3311 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 11487 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 848:
#line 3312 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(SET_PORT_T, 1, STRING_ST, (yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 11493 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 849:
#line 3313 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11499 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 850:
#line 3314 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 11505 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 851:
#line 3315 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(SET_USER_T, 1, STRING_ST, (yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 11511 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 852:
#line 3316 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11517 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 853:
#line 3317 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 11523 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 854:
#line 3318 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(SET_USERPASS_T, 1, STRING_ST, (yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 11529 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 855:
#line 3319 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11535 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 856:
#line 3320 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 11541 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 857:
#line 3321 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(SET_URI_T, 1, STRING_ST,(yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 11547 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 858:
#line 3322 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11553 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 859:
#line 3323 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 11559 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 860:
#line 3324 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(REVERT_URI_T, 0); set_cfg_pos((yyval.action)); }
#line 11565 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 861:
#line 3325 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(REVERT_URI_T, 0); set_cfg_pos((yyval.action)); }
#line 11571 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 862:
#line 3326 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORCE_RPORT_T, 0); set_cfg_pos((yyval.action)); }
#line 11577 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 863:
#line 3327 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=mk_action(FORCE_RPORT_T, 0); set_cfg_pos((yyval.action)); }
#line 11583 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 864:
#line 3328 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(ADD_LOCAL_RPORT_T, 0); set_cfg_pos((yyval.action)); }
#line 11589 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 865:
#line 3329 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=mk_action(ADD_LOCAL_RPORT_T, 0); set_cfg_pos((yyval.action)); }
#line 11595 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 866:
#line 3330 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			(yyval.action)=mk_action(FORCE_TCP_ALIAS_T, 1, NUMBER_ST, (void*)(yyvsp[-1].intval));
			set_cfg_pos((yyval.action));
		#else
			yyerror("tcp support not compiled in");
		#endif
	}
#line 11608 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 867:
#line 3338 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			(yyval.action)=mk_action(FORCE_TCP_ALIAS_T, 0);
			set_cfg_pos((yyval.action));
		#else
			yyerror("tcp support not compiled in");
		#endif
	}
#line 11621 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 868:
#line 3346 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			(yyval.action)=mk_action(FORCE_TCP_ALIAS_T, 0);
			set_cfg_pos((yyval.action));
		#else
			yyerror("tcp support not compiled in");
		#endif
	}
#line 11634 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 869:
#line 3354 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=0; yyerror("bad argument, number expected"); }
#line 11640 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 870:
#line 3356 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(UDP_MTU_TRY_PROTO_T, 1, NUMBER_ST, (yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 11646 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 871:
#line 3358 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, UDP, TCP, TLS or SCTP expected"); }
#line 11652 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 872:
#line 3359 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=0;
		if ((str_tmp=pkg_malloc(sizeof(str)))==0) {
			PKG_MEM_CRITICAL;
		} else {
			str_tmp->s=(yyvsp[-1].strval);
			str_tmp->len=(yyvsp[-1].strval)?strlen((yyvsp[-1].strval)):0;
			(yyval.action)=mk_action(SET_ADV_ADDR_T, 1, STR_ST, str_tmp);
			set_cfg_pos((yyval.action));
		}
	}
#line 11668 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 873:
#line 3370 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 11674 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 874:
#line 3371 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11680 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 875:
#line 3372 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=0;
		tmp=int2str((yyvsp[-1].intval), &i_tmp);
		if ((str_tmp=pkg_malloc(sizeof(str)))==0) {
			PKG_MEM_CRITICAL;
		} else {
			if ((str_tmp->s=pkg_malloc(i_tmp))==0) {
				PKG_MEM_CRITICAL;
			} else {
				memcpy(str_tmp->s, tmp, i_tmp);
				str_tmp->len=i_tmp;
				(yyval.action)=mk_action(SET_ADV_PORT_T, 1, STR_ST, str_tmp);
				set_cfg_pos((yyval.action));
			}
		}
	}
#line 11701 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 876:
#line 3388 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 11707 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 877:
#line 3389 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11713 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 878:
#line 3390 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(FORCE_SEND_SOCKET_T, 1, SOCKID_ST, (yyvsp[-1].sockid));
		set_cfg_pos((yyval.action));
	}
#line 11722 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 879:
#line 3394 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=0; yyerror("bad argument, [proto:]host[:port] expected");
	}
#line 11730 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 880:
#line 3397 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11736 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 881:
#line 3398 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(SET_FWD_NO_CONNECT_T, 0); set_cfg_pos((yyval.action));
	}
#line 11744 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 882:
#line 3401 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(SET_FWD_NO_CONNECT_T, 0); set_cfg_pos((yyval.action));
	}
#line 11752 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 883:
#line 3404 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(SET_RPL_NO_CONNECT_T, 0); set_cfg_pos((yyval.action));
	}
#line 11760 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 884:
#line 3407 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(SET_RPL_NO_CONNECT_T, 0); set_cfg_pos((yyval.action));
	}
#line 11768 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 885:
#line 3410 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(SET_FWD_CLOSE_T, 0); set_cfg_pos((yyval.action));
	}
#line 11776 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 886:
#line 3413 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(SET_FWD_CLOSE_T, 0); set_cfg_pos((yyval.action));
	}
#line 11784 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 887:
#line 3416 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(SET_RPL_CLOSE_T, 0); set_cfg_pos((yyval.action));
	}
#line 11792 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 888:
#line 3419 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(SET_RPL_CLOSE_T, 0); set_cfg_pos((yyval.action));
	}
#line 11800 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 889:
#line 3422 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(CFG_SELECT_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action));
	}
#line 11808 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 890:
#line 3425 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(CFG_SELECT_T, 2, STRING_ST, (yyvsp[-3].strval), RVE_ST, (yyvsp[-1].rv_expr)); set_cfg_pos((yyval.action));
	}
#line 11816 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 891:
#line 3428 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11822 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 892:
#line 3429 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad arguments, string and number expected"); }
#line 11828 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 893:
#line 3430 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(CFG_RESET_T, 1, STRING_ST, (yyvsp[-1].strval)); set_cfg_pos((yyval.action));
	}
#line 11836 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 894:
#line 3433 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11842 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 895:
#line 3434 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad arguments, string expected"); }
#line 11848 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 896:
#line 3435 "core/cfg.y" /* yacc.c:1646  */
    {
		if (mod_func_action != NULL) {
			LM_ERR("function used inside params of another function: %s\n", (yyvsp[0].strval));
			yyerror("use of function execution inside params not allowed\n");
			exit(-1);
		}
		mod_func_action = mk_action(MODULE0_T, 2, MODEXP_ST, NULL, NUMBER_ST, 0);
		}
#line 11861 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 897:
#line 3442 "core/cfg.y" /* yacc.c:1646  */
    {
		mod_func_action->val[0].u.data =
			find_export_record((yyvsp[-4].strval), mod_func_action->val[1].u.number, rt);
		if (mod_func_action->val[0].u.data == 0) {
			if (find_export_record((yyvsp[-4].strval), mod_func_action->val[1].u.number, 0) ) {
					LM_ERR("misused command %s\n", (yyvsp[-4].strval));
					yyerror("Command cannot be used in the block\n");
			} else {
				LM_ERR("cfg. parser: failed to find command %s (params %ld)\n",
						(yyvsp[-4].strval), mod_func_action->val[1].u.number);
				yyerror("unknown command, missing loadmodule?\n");
			}
			free_mod_func_action(mod_func_action);
			mod_func_action=0;
		}else{
			if (mod_func_action && mod_f_params_pre_fixup(mod_func_action)<0) {
				/* error messages are printed inside the function */
				free_mod_func_action(mod_func_action);
				mod_func_action = 0;
				YYERROR;
			}
		}
		(yyval.action) = mod_func_action;
		set_cfg_pos((yyval.action));
		mod_func_action = NULL;
	}
#line 11892 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 898:
#line 3468 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("'('')' expected (function call)");}
#line 11898 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 900:
#line 3472 "core/cfg.y" /* yacc.c:1646  */
    { }
#line 11904 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 901:
#line 3473 "core/cfg.y" /* yacc.c:1646  */
    {}
#line 11910 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 902:
#line 3476 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[0].rv_expr) && mod_func_action->val[1].u.number < MAX_ACTIONS-2) {
			mod_func_action->val[mod_func_action->val[1].u.number+2].type =
				RVE_ST;
			mod_func_action->val[mod_func_action->val[1].u.number+2].u.data =
				(yyvsp[0].rv_expr);
			mod_func_action->val[1].u.number++;
		} else if ((yyvsp[0].rv_expr)) {
			yyerror("Too many arguments\n");
			YYERROR;
		} else {
			YYERROR;
		}
	}
#line 11929 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 903:
#line 3493 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(DROP_T, 2, NUMBER_ST, 0, NUMBER_ST,
						(void*)(DROP_R_F|EXIT_R_F)); set_cfg_pos((yyval.action));
	}
#line 11938 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 904:
#line 3497 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(DROP_T, 2, RVE_ST, (yyvsp[0].rv_expr), NUMBER_ST,
						(void*)(DROP_R_F|EXIT_R_F)); set_cfg_pos((yyval.action));
	}
#line 11947 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 905:
#line 3501 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(DROP_T, 2, NUMBER_ST, 0, NUMBER_ST,
						(void*)(DROP_R_F|EXIT_R_F)); set_cfg_pos((yyval.action));
	}
#line 11956 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 906:
#line 3505 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(DROP_T, 2, NUMBER_ST, (void*)1, NUMBER_ST,
						(void*)EXIT_R_F);
		set_cfg_pos((yyval.action));
	}
#line 11966 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 907:
#line 3510 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(DROP_T, 2, RVE_ST, (yyvsp[0].rv_expr), NUMBER_ST, (void*)EXIT_R_F);
		set_cfg_pos((yyval.action));
	}
#line 11975 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 908:
#line 3514 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(DROP_T, 2, NUMBER_ST, (void*)1, NUMBER_ST,
						(void*)EXIT_R_F);
		set_cfg_pos((yyval.action));
	}
#line 11985 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 909:
#line 3519 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(DROP_T, 2, NUMBER_ST, (void*)1, NUMBER_ST,
						(void*)RETURN_R_F); set_cfg_pos((yyval.action));
	}
#line 11994 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 910:
#line 3523 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(DROP_T, 2, NUMBER_ST, (void*)1, NUMBER_ST,
						(void*)RETURN_R_F); set_cfg_pos((yyval.action));
	}
#line 12003 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 911:
#line 3527 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(DROP_T, 2, RVE_ST, (yyvsp[0].rv_expr), NUMBER_ST, (void*)RETURN_R_F);
		set_cfg_pos((yyval.action));
	}
#line 12012 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 912:
#line 3531 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(DROP_T, 2, NUMBER_ST, 0, NUMBER_ST, (void*)BREAK_R_F);
		set_cfg_pos((yyval.action));
	}
#line 12021 "core/cfg.tab.c" /* yacc.c:1646  */
    break;


#line 12025 "core/cfg.tab.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 3537 "core/cfg.y" /* yacc.c:1906  */


static void get_cpos(struct cfg_pos* pos)
{
	pos->s_line=startline;
	pos->e_line=line;
	pos->s_col=startcolumn;
	pos->e_col=column-1;
	if(finame==0)
		finame = (cfg_file!=0)?cfg_file:"default";
	pos->fname=finame;
	pos->rname=(routename!=0)?routename:default_routename;
}


static void warn_at(struct cfg_pos* p, char* format, ...)
{
	va_list ap;
	char s[256];

	va_start(ap, format);
	vsnprintf(s, sizeof(s), format, ap);
	va_end(ap);
	if (p->e_line!=p->s_line)
		LM_WARN("warning in config file %s, from line %d, column %d to"
					" line %d, column %d: %s\n",
					p->fname, p->s_line, p->s_col, p->e_line, p->e_col, s);
	else if (p->s_col!=p->e_col)
		LM_WARN("warning in config file %s, line %d, column %d-%d: %s\n",
					p->fname, p->s_line, p->s_col, p->e_col, s);
	else
		LM_WARN("warning in config file %s, line %d, column %d: %s\n",
				p->fname, p->s_line, p->s_col, s);
	cfg_warnings++;
}



static void yyerror_at(struct cfg_pos* p, char* format, ...)
{
	va_list ap;
	char s[256];

	va_start(ap, format);
	vsnprintf(s, sizeof(s), format, ap);
	va_end(ap);
	if (p->e_line!=p->s_line)
		LM_CRIT("parse error in config file %s, from line %d, column %d"
					" to line %d, column %d: %s\n",
					p->fname, p->s_line, p->s_col, p->e_line, p->e_col, s);
	else if (p->s_col!=p->e_col)
		LM_CRIT("parse error in config file %s, line %d, column %d-%d: %s\n",
					p->fname, p->s_line, p->s_col, p->e_col, s);
	else
		LM_CRIT("parse error in config file %s, line %d, column %d: %s\n",
					p->fname, p->s_line, p->s_col, s);
	cfg_errors++;
}



static void warn(char* format, ...)
{
	va_list ap;
	char s[256];
	struct cfg_pos pos;

	get_cpos(&pos);
	va_start(ap, format);
	vsnprintf(s, sizeof(s), format, ap);
	va_end(ap);
	warn_at(&pos, s);
}



static void yyerror(char* format, ...)
{
	va_list ap;
	char s[256];
	struct cfg_pos pos;

	get_cpos(&pos);
	va_start(ap, format);
	vsnprintf(s, sizeof(s), format, ap);
	va_end(ap);
	yyerror_at(&pos, s);
}



/** mk_rval_expr_v wrapper.
 *  checks mk_rval_expr_v return value and sets the cfg. pos
 *  (line and column numbers)
 *  @return rval_expr* on success, 0 on error (@see mk_rval_expr_v)
 */
static struct rval_expr* mk_rve_rval(enum rval_type type, void* v)
{
	struct rval_expr* ret;
	struct cfg_pos pos;

	get_cpos(&pos);
	ret=mk_rval_expr_v(type, v, &pos);
	if (ret==0){
		yyerror("internal error: failed to create rval expr");
		/* YYABORT; */
	}
	return ret;
}


/** mk_rval_expr1 wrapper.
 *  checks mk_rval_expr1 return value (!=0 and type checking)
 *  @return rval_expr* on success, 0 on error (@see mk_rval_expr1)
 */
static struct rval_expr* mk_rve1(enum rval_expr_op op, struct rval_expr* rve1)
{
	struct rval_expr* ret;
	struct rval_expr* bad_rve;
	enum rval_type type, bad_t, exp_t;

	if (rve1==0)
		return 0;
	ret=mk_rval_expr1(op, rve1, &rve1->fpos);
	if (ret && (rve_check_type(&type, ret, &bad_rve, &bad_t, &exp_t)!=1)){
		yyerror_at(&rve1->fpos, "bad expression: type mismatch"
					" (%s instead of %s)", rval_type_name(bad_t),
					rval_type_name(exp_t));
		rve_destroy(ret);
		ret=0;
	}
	return ret;
}


/** mk_rval_expr2 wrapper.
 *  checks mk_rval_expr2 return value (!=0 and type checking)
 *  @return rval_expr* on success, 0 on error (@see mk_rval_expr2)
 */
static struct rval_expr* mk_rve2(enum rval_expr_op op, struct rval_expr* rve1,
									struct rval_expr* rve2)
{
	struct rval_expr* ret;
	struct rval_expr* bad_rve;
	enum rval_type type, bad_t, exp_t;
	struct cfg_pos pos;

	if ((rve1==0) || (rve2==0))
		return 0;
	bad_rve=0;
	bad_t=0;
	exp_t=0;
	cfg_pos_join(&pos, &rve1->fpos, &rve2->fpos);
	ret=mk_rval_expr2(op, rve1, rve2, &pos);
	if (ret && (rve_check_type(&type, ret, &bad_rve, &bad_t, &exp_t)!=1)){
		if (bad_rve)
			yyerror_at(&pos, "bad expression: type mismatch:"
						" %s instead of %s at (%d,%d)",
						rval_type_name(bad_t), rval_type_name(exp_t),
						bad_rve->fpos.s_line, bad_rve->fpos.s_col);
		else
			yyerror("BUG: unexpected null \"bad\" expression\n");
		rve_destroy(ret);
		ret=0;
	}
	return ret;
}


/** check if the expression is an int.
 * if the expression does not evaluate to an int return -1 and
 * log an error.
 * @return 0 success, no warnings; 1 success but warnings; -1 on error */
static int rval_expr_int_check(struct rval_expr *rve)
{
	struct rval_expr* bad_rve;
	enum rval_type type, bad_t, exp_t;

	if (rve==0){
		yyerror("invalid expression");
		return -1;
	}else if (!rve_check_type(&type, rve, &bad_rve, &bad_t ,&exp_t)){
		if (bad_rve)
			yyerror_at(&rve->fpos, "bad expression: type mismatch:"
						" %s instead of %s at (%d,%d)",
						rval_type_name(bad_t), rval_type_name(exp_t),
						bad_rve->fpos.s_line, bad_rve->fpos.s_col);
		else
			yyerror("BUG: unexpected null \"bad\" expression\n");
		return -1;
	}else if (type!=RV_INT && type!=RV_NONE){
		warn_at(&rve->fpos, "non-int expression (you might want to use"
				" casts)\n");
		return 1;
	}
	return 0;
}


/** warn if the expression is constant.
 * @return 0 on success (no warning), 1 when warning */
static int warn_ct_rve(struct rval_expr *rve, char* name)
{
	if (rve && rve_is_constant(rve)){
		warn_at(&rve->fpos, "constant value in %s%s",
				name?name:"expression", name?"(...)":"");
		return 1;
	}
	return 0;
}


static struct name_lst* mk_name_lst(char* host, int flags)
{
	struct name_lst* l;
	if (host==0) return 0;
	l=pkg_malloc(sizeof(struct name_lst));
	if (l==0) {
		PKG_MEM_CRITICAL;
	} else {
		memset(l, 0, sizeof(struct name_lst));
		l->name=host;
		l->flags=flags;
		l->next=0;
	}
	return l;
}


static struct socket_id* mk_listen_id(char* host, int proto, int port)
{
	struct socket_id* l;
	if (host==0) return 0;
	l=pkg_malloc(sizeof(struct socket_id));
	if (l==0) {
		PKG_MEM_CRITICAL;
	} else {
		memset(l, 0, sizeof(struct socket_id));
		l->addr_lst=mk_name_lst(host, 0);
		if (l->addr_lst==0){
			pkg_free(l);
			return 0;
		}
		l->flags=0;
		l->port=port;
		l->proto=proto;
		l->next=0;
	}
	return l;
}


static void free_name_lst(struct name_lst* lst)
{
	struct name_lst* tmp;

	while(lst){
		tmp=lst;
		lst=lst->next;
		pkg_free(tmp);
	}
}


static struct socket_id* mk_listen_id2(struct name_lst* addr_l, int proto,
										int port)
{
	struct socket_id* l;
	if (addr_l==0) return 0;
	l=pkg_malloc(sizeof(struct socket_id));
	if (l==0) {
		PKG_MEM_CRITICAL;
	} else {
		memset(l, 0, sizeof(struct socket_id));
		l->flags=addr_l->flags;
		l->port=port;
		l->proto=proto;
		l->addr_lst=addr_l;
		l->next=0;
	}
	return l;
}


static void free_socket_id(struct socket_id* i)
{
	free_name_lst(i->addr_lst);
	pkg_free(i);
}


static void free_socket_id_lst(struct socket_id* lst)
{
	struct socket_id* tmp;

	while(lst){
		tmp=lst;
		lst=lst->next;
		free_socket_id(tmp);
	}
}


/** create a temporary case statmenet structure.
 *  *err will be filled in case of error (return == 0):
 *   -1 - non constant expression
 *   -2 - expression error (bad type)
 *   -10 - memory allocation error
 */
static struct case_stms* mk_case_stm(struct rval_expr* ct, int is_re,
											struct action* a, int* err)
{
	struct case_stms* s;
	struct rval_expr* bad_rve;
	enum rval_type type, bad_t, exp_t;
	enum match_str_type t;

	t=MATCH_UNKNOWN;
	if (ct){
		/* if ct!=0 => case, else if ct==0 is a default */
		if (!rve_is_constant(ct)){
			yyerror_at(&ct->fpos, "non constant expression in case");
			*err=-1;
			return 0;
		}
		if (rve_check_type(&type, ct, &bad_rve, &bad_t, &exp_t)!=1){
			yyerror_at(&ct->fpos, "bad expression: type mismatch:"
							" %s instead of %s at (%d,%d)",
							rval_type_name(bad_t), rval_type_name(exp_t),
							bad_rve->fpos.s_line, bad_rve->fpos.s_col);
			*err=-2;
			return 0;
		}
		if (is_re)
			t=MATCH_RE;
		else if (type==RV_STR)
			t=MATCH_STR;
		else
			t=MATCH_INT;
	}

	s=pkg_malloc(sizeof(*s));
	if (s==0) {
		yyerror("internal error: memory allocation failure");
		*err=-10;
	} else {
		memset(s, 0, sizeof(*s));
		s->ct_rve=ct;
		s->type=t;
		s->actions=a;
		s->next=0;
		s->append=0;
	}
	return s;
}


/*
 * @return 0 on success, -1 on error.
 */
static int case_check_type(struct case_stms* stms)
{
	struct case_stms* c;
	struct case_stms* s;

	for(c=stms; c ; c=c->next){
		if (!c->ct_rve) continue;
		for (s=c->next; s; s=s->next){
			if (!s->ct_rve) continue;
			if ((s->type!=c->type) &&
				!(	(c->type==MATCH_STR || c->type==MATCH_RE) &&
					(s->type==MATCH_STR || s->type==MATCH_RE) ) ){
					yyerror_at(&s->ct_rve->fpos, "type mismatch in case");
					return -1;
			}
		}
	}
	return 0;
}


/*
 * @return 0 on success, -1 on error.
 */
static int case_check_default(struct case_stms* stms)
{
	struct case_stms* c;
	int default_no;

	default_no=0;
	for(c=stms; c ; c=c->next)
		if (c->ct_rve==0) default_no++;
	return (default_no<=1)?0:-1;
}



/** fixes the parameters and the type of a module function call.
 * It is done here instead of fix action, to have quicker feedback
 * on error cases (e.g. passing a non constant to a function with a
 * declared fixup)
 * The rest of the fixup is done inside do_action().
 * @param a - filled module function call (MODULE*_T) action structure
 *            complete with parameters, starting at val[2] and parameter
 *            number at val[1].
 * @return 0 on success, -1 on error (it will also print the error msg.).
 *
 */
static int mod_f_params_pre_fixup(struct action* a)
{
	ksr_cmd_export_t* cmd_exp;
	action_u_t* params;
	int param_no;
	struct rval_expr* rve;
	struct rvalue* rv;
	int r;
	str s;

	cmd_exp = a->val[0].u.data;
	param_no = a->val[1].u.number;
	params = &a->val[2];

	switch(cmd_exp->param_no) {
		case 0:
			a->type = MODULE0_T;
			break;
		case 1:
			a->type = MODULE1_T;
			break;
		case 2:
			a->type = MODULE2_T;
			break;
		case 3:
			a->type = MODULE3_T;
			break;
		case 4:
			a->type = MODULE4_T;
			break;
		case 5:
			a->type = MODULE5_T;
			break;
		case 6:
			a->type = MODULE6_T;
			break;
		case VAR_PARAM_NO:
			a->type = MODULEX_T;
			break;
		default:
			yyerror("function %s: bad definition"
					" (invalid number of parameters)", cmd_exp->name);
			return -1;
	}

	if ( cmd_exp->fixup) {
		if (is_fparam_rve_fixup(cmd_exp->fixup))
			/* mark known fparam rve safe fixups */
			cmd_exp->fixup_flags  |= FIXUP_F_FPARAM_RVE;
		else if (!(cmd_exp->fixup_flags & FIXUP_F_FPARAM_RVE) &&
				 cmd_exp->free_fixup == 0) {
			/* v0 or v1 functions that have fixups and no coresp. fixup_free
			   functions, need constant, string params.*/
			for (r=0; r < param_no; r++) {
				rve=params[r].u.data;
				if (!rve_is_constant(rve)) {
					yyerror_at(&rve->fpos, "function %s: parameter %d is not"
								" constant\n", cmd_exp->name, r+1);
					return -1;
				}
				if ((rv = rval_expr_eval(0, 0, rve)) == 0 ||
						rval_get_str(0, 0, &s, rv, 0) < 0 ) {
					/* out of mem or bug ? */
					rval_destroy(rv);
					yyerror_at(&rve->fpos, "function %s: bad parameter %d"
									" expression\n", cmd_exp->name, r+1);
					return -1;
				}
				rval_destroy(rv);
				rve_destroy(rve);
				params[r].type = STRING_ST; /* asciiz */
				params[r].u.string = s.s;
				params[r].u.str.len = s.len; /* not used right now */
			}
		}
	}/* else
		if no fixups are present, the RVEs can be transformed
		into strings at runtime, allowing seamless var. use
		even with old functions.
		Further optimizations -> in fix_actions()
		*/
	return 0;
}



/** frees a filled module function call action structure.
 * @param a - filled module function call action structure
 *            complete with parameters, starting at val[2] and parameter
 *            number at val[1].
 */
static void free_mod_func_action(struct action* a)
{
	action_u_t* params;
	int param_no;
	int r;

	param_no = a->val[1].u.number;
	params = &a->val[2];

	for (r=0; r < param_no; r++)
		if (params[r].u.data)
			rve_destroy(params[r].u.data);
	pkg_free(a);
}



/*
int main(int argc, char ** argv)
{
	if (yyparse()!=0)
		fprintf(stderr, "parsing error\n");
}
*/
